module driver

  use sps_vars; use sps_utils
  implicit none
  save

  !f2py intent(hide) pset
  type(PARAMS) :: pset

  !f2py intent(hide) ocompsp
  type(COMPSPOUT), dimension(ntfull) :: ocompsp

  integer :: is_setup=0

  !f2py intent(hide) has_ssp
  integer, dimension(nz) :: has_ssp=0

  !f2py intent(hide) has_ssp_age
  integer, dimension(nz,nt) :: has_ssp_age=0


contains

  subroutine setup(compute_vega_mags0, vactoair_flag0)

    ! Load all the data files/templates into memory.

    implicit none

    integer, intent(in) :: compute_vega_mags0, vactoair_flag0


    compute_vega_mags = compute_vega_mags0
    vactoair_flag = vactoair_flag0
    call sps_setup(-1)
    is_setup = 1

    ! We will only compute mags when asked for through get_mags.
    pset%mag_compute=0

  end subroutine

  subroutine set_ssp_params(imf_type0,imf_upper_limit0,imf_lower_limit0,&
                            imf1,imf2,imf3,vdmc,mdave,dell,&
                            delt,sbss,fbhb,pagb,add_stellar_remnants0,&
                            tpagb_norm_type0,add_agb_dust_model0,agb_dust,&
                            redgb,agb,masscut,fcstar,evtype,smooth_lsf0)

    ! Set the parameters that affect the SSP computation.

    implicit none

    integer, intent(in) :: imf_type0,add_stellar_remnants0,tpagb_norm_type0,&
                           add_agb_dust_model0,smooth_lsf0
    double precision, intent(in) :: imf_upper_limit0, imf_lower_limit0,&
                                    imf1,imf2,imf3,vdmc,mdave,dell,&
                                    delt,sbss,fbhb,pagb,agb_dust,&
                                    redgb,agb,masscut,fcstar,evtype

    imf_type=imf_type0
    imf_upper_limit=imf_upper_limit0
    imf_lower_limit=imf_lower_limit0
    add_stellar_remnants=add_stellar_remnants0
    tpagb_norm_type=tpagb_norm_type0
    add_agb_dust_model=add_agb_dust_model0
    smooth_lsf=smooth_lsf0
    pset%imf1=imf1
    pset%imf2=imf2
    pset%imf3=imf3
    pset%vdmc=vdmc
    pset%mdave=mdave
    pset%dell=dell
    pset%delt=delt
    pset%sbss=sbss
    pset%fbhb=fbhb
    pset%pagb=pagb
    pset%agb_dust=agb_dust
    pset%redgb=redgb
    pset%agb=agb
    pset%masscut=masscut
    pset%fcstar=fcstar
    pset%evtype=evtype

    has_ssp(:) = 0
    has_ssp_age(:,:) = 0

  end subroutine

  subroutine set_csp_params(smooth_velocity0,redshift_colors0,&
                            compute_light_ages0,nebemlineinspec0,&
                            dust_type0,add_dust_emission0,add_neb_emission0,&
                            add_neb_continuum0,cloudy_dust0,add_igm_absorption0,&
                            zmet,sfh,wgp1,wgp2,wgp3,tau,&
                            const,tage,fburst,tburst,dust1,dust2,&
                            logzsol,zred,pmetals,dust_clumps,frac_nodust,&
                            dust_index,dust_tesc,frac_obrun,uvb,mwr,&
                            dust1_index,sf_start,sf_trunc,sf_slope,&
                            duste_gamma,duste_umin,duste_qpah,&
                            sigma_smooth,min_wave_smooth,max_wave_smooth,&
                            gas_logu,gas_logz,igm_factor,fagn,agn_tau)

    ! Set all the parameters that don't affect the SSP computation.

    implicit none

    integer, intent(in) :: smooth_velocity0,redshift_colors0,&
                           compute_light_ages0,nebemlineinspec0,&
                           dust_type0,add_dust_emission0,add_neb_emission0,&
                           add_neb_continuum0,cloudy_dust0,add_igm_absorption0,&
                           zmet,sfh,wgp1,wgp2,wgp3
    double precision, intent(in) :: tau,&
                            const,tage,fburst,tburst,dust1,dust2,&
                            logzsol,zred,pmetals,dust_clumps,frac_nodust,&
                            dust_index,dust_tesc,frac_obrun,uvb,mwr,&
                            dust1_index,sf_start,sf_trunc,sf_slope,&
                            duste_gamma,duste_umin,duste_qpah,&
                            sigma_smooth,min_wave_smooth,max_wave_smooth,&
                            gas_logu,gas_logz,igm_factor,fagn,agn_tau

    smooth_velocity=smooth_velocity0
    redshift_colors=redshift_colors0
    compute_light_ages=compute_light_ages0
    nebemlineinspec=nebemlineinspec0
    dust_type=dust_type0
    add_dust_emission=add_dust_emission0
    add_neb_emission=add_neb_emission0
    add_neb_continuum=add_neb_continuum0
    cloudy_dust=cloudy_dust0
    add_igm_absorption=add_igm_absorption0

    pset%zmet=zmet
    pset%sfh=sfh
    pset%wgp1=wgp1
    pset%wgp2=wgp2
    pset%wgp3=wgp3

    pset%tau=tau
    pset%const=const
    pset%tage=tage
    pset%fburst=fburst
    pset%tburst=tburst
    pset%dust1=dust1
    pset%dust2=dust2
    pset%logzsol=logzsol
    pset%zred=zred
    pset%pmetals=pmetals
    pset%dust_clumps=dust_clumps
    pset%frac_nodust=frac_nodust
    pset%dust_index=dust_index
    pset%dust_tesc=dust_tesc
    pset%frac_obrun=frac_obrun
    pset%uvb=uvb
    pset%mwr=mwr
    pset%dust1_index=dust1_index
    pset%sf_start=sf_start
    pset%sf_trunc=sf_trunc
    pset%sf_slope=sf_slope
    pset%duste_gamma=duste_gamma
    pset%duste_umin=duste_umin
    pset%duste_qpah=duste_qpah
    pset%sigma_smooth=sigma_smooth
    pset%min_wave_smooth=min_wave_smooth
    pset%max_wave_smooth=max_wave_smooth
    pset%gas_logu=gas_logu
    pset%gas_logz=gas_logz
    pset%igm_factor=igm_factor
    pset%fagn=fagn
    pset%agn_tau=agn_tau

  end subroutine

  subroutine ssps

    ! Loop over the metallicity grid and compute all the SSPs.

    implicit none
    integer :: zi
    do zi=1,nz
      call ssp(zi)
    enddo

  end subroutine

  subroutine ssp(zi)

    ! Compute a SSP at a single metallicity.

    implicit none
    integer, intent(in) :: zi
    pset%zmet = zi
    call ssp_gen(pset, mass_ssp_zz(:,zi),lbol_ssp_zz(:,zi),&
         spec_ssp_zz(:,:,zi))
    if (minval(pset%ssp_gen_age) .eq. 1) then
       has_ssp(zi) = 1
    endif
    has_ssp_age(zi,:) = pset%ssp_gen_age

  end subroutine

  subroutine compute_zdep(ns,n_age,ztype)

    ! Compute the full CSP (and the SSPs if they aren't already cached).
    ! After interpolation in metallicity

    implicit none
    integer, intent(in) :: ns,n_age,ztype
    double precision, dimension(ns,n_age) :: spec
    double precision, dimension(n_age) :: mass,lbol
    integer :: zlo,zmet
    double precision :: zpos
    character(100) :: outfile

    if (ztype .eq. 0) then
       ! Build the SSP for one metallicity, then feed to compsp
       zmet = pset%zmet
       if (has_ssp(zmet) .eq. 0) then
          call ssp(zmet)
       endif
       !mass = mass_ssp_zz(:,zmet)
       !lbol = lbol_ssp_zz(:,zmet)
       !spec = spec_ssp_zz(:,:,zmet)
       call compsp(0,1,outfile,mass_ssp_zz(:,zmet),lbol_ssp_zz(:,zmet),&
            spec_ssp_zz(:,:,zmet),pset,ocompsp)
    endif

    if (ztype .eq. 1) then
       zpos = pset%logzsol
       ! Find the bracketing metallicity indices and generate ssps if
       ! necessary, then interpolate, and feed the result to compsp
       zlo = max(min(locate(log10(zlegend/zsol),zpos),nz-1),1)
       do zmet=zlo,zlo+1
          if (has_ssp(zmet) .eq. 0) then
             call ssp(zmet)
          endif
       enddo
       call ztinterp(zpos,spec,lbol,mass)
       call compsp(0,1,outfile,mass,lbol,spec,pset,ocompsp)
    endif

    if (ztype .eq. 2) then
       zpos = pset%logzsol
       ! Build the SSPs for *every* metallicity if necessary, then
       ! comvolve with the MDF, and then feed to compsp
       do zmet=1,nz
          if (has_ssp(zmet) .eq. 0) then
             call ssp(zmet)
          endif
       enddo
       call ztinterp(zpos,spec,lbol,mass,zpow=pset%pmetals)
       call compsp(0,1,outfile,mass,lbol,spec,pset,ocompsp)
    endif

    if (ztype .eq. 3) then
       ! Build the SSPs for *every* metallicity and feed all of them to compsp
       ! for z-dependent tabular
       do zmet=1,nz
          if (has_ssp(zmet) .eq. 0) then
             call ssp(zmet)
          endif
       enddo
       call compsp(0,nz,outfile,mass_ssp_zz,lbol_ssp_zz,&
            spec_ssp_zz,pset,ocompsp)
    endif


  end subroutine

  subroutine get_spec(ns,n_age,spec_out)

    ! Get the grid of spectra for the computed CSP at all ages.

    implicit none
    integer :: i
    integer, intent(in) :: ns,n_age
    double precision, dimension(n_age,ns), intent(out) :: spec_out
    do i=1,n_age
      spec_out(i,:) = ocompsp(i)%spec
    enddo

  end subroutine

  subroutine get_mags(ns,n_age,n_bands,z_red,mc,mags)

    ! Get the photometric magnitudes in all the recognized bands.

    implicit none
    integer :: i
    integer, intent(in) :: ns, n_age, n_bands
    double precision, intent(in) :: z_red
    integer, dimension(n_bands), intent(in) :: mc
    double precision, dimension(n_age,n_bands), intent(out) :: mags
    double precision, dimension(ns) :: tspec
    do i=1,n_age
      tspec = ocompsp(i)%spec
      call getmags(z_red,tspec,mags(i,:),mc)
    enddo

  end subroutine

  subroutine interp_ssp(ns,zpos,tpos,spec,mass,lbol)

    ! Return the SSPs interpolated to the target metallicity
    !(zpos) and target age (tpos)

    implicit none

    integer, intent(in) :: ns
    double precision, intent(in) :: zpos
    double precision, intent(in) :: tpos

    double precision, dimension(ns,1), intent(inout) :: spec
    double precision, dimension(1), intent(inout) :: mass,lbol

    double precision, dimension(nt) :: time

    integer :: zlo,zmet,tlo

    zlo = max(min(locate(log10(zlegend/0.0190),zpos),nz-1),1)
    time = timestep_isoc(zlo,:)
    tlo = max(min(locate(time,tpos),nt-1),1)

    do zmet=zlo,zlo+1
       if ((has_ssp_age(zmet,tlo) .eq. 0) .or. (has_ssp_age(zmet,tlo+1) .eq. 0)) then
          pset%ssp_gen_age = 0
          pset%ssp_gen_age(tlo:tlo+1) = 1
          call ssp(zmet)
          pset%ssp_gen_age = 1
       endif
    enddo

    call ztinterp(zpos,spec,lbol,mass,tpos=tpos)

    end subroutine

  subroutine smooth_spectrum(ns,wave,spec,sigma_broad,minw,maxw)

    ! Smooth the spectrum by a gaussian of width sigma_broad

    implicit none
    integer, intent(in) :: ns
    double precision, intent(in) :: sigma_broad,minw,maxw
    double precision, dimension(ns), intent(in) :: wave
    double precision, dimension(ns), intent(inout) :: spec

    call smoothspec(wave,spec,sigma_broad,minw,maxw)

  end subroutine

  subroutine stellar_spectrum(ns,mact,logt,lbol,logg,phase,ffco,lmdot,wght,spec_out)

    ! Get a stellar spectrum for a given set of parameters

    implicit none
    integer :: i
    integer, intent(in) :: ns
    double precision, intent(in) :: mact, logt, lbol, logg, phase, ffco, lmdot, wght
    double precision, dimension(ns), intent(inout) :: spec_out

    call getspec(pset,mact,logt,lbol,logg,phase,ffco,lmdot,wght,spec_out)

  end subroutine

  subroutine get_ssp_spec(ns,n_age,n_z,ssp_spec_out,ssp_mass_out,ssp_lbol_out)

    ! Return the contents of the ssp spectral array,
    ! regenerating the ssps if necessary

    implicit none
    integer, intent(in) :: ns,n_age,n_z
    integer :: zi
    double precision, dimension(ns,n_age,n_z), intent(inout) :: ssp_spec_out
    double precision, dimension(n_age,n_z), intent(inout) :: ssp_mass_out, ssp_lbol_out
    do zi=1,nz
       if (has_ssp(zi) .eq. 0) then
          call ssp(zi)
       endif
    enddo

    ssp_spec_out = spec_ssp_zz
    ssp_mass_out = mass_ssp_zz
    ssp_lbol_out = lbol_ssp_zz

  end subroutine

  subroutine set_sfh_tab(ntab, age, sfr, met)

    ! Fill the sfh_tab array

    implicit none
    integer, intent(in) :: ntab
    double precision, dimension(ntab), intent(in) :: age, sfr, met
    ntabsfh = ntab
    sfh_tab(1,1:ntabsfh) = age
    sfh_tab(2, 1:ntabsfh) = sfr
    sfh_tab(3, 1:ntabsfh) = met

  end subroutine set_sfh_tab

  subroutine set_ssp_lsf(nsv, sigma, wlo, whi)

    ! Fill the lsfinfo structure

    implicit none
    integer, intent(in) :: nsv
    double precision, dimension(nsv), intent(in) :: sigma
    double precision, intent(in) :: wlo, whi
    lsfinfo%minlam = wlo
    lsfinfo%maxlam = whi
    lsfinfo%lsf = sigma

  end subroutine set_ssp_lsf

  subroutine get_setup_vars(cvms, vta_flag)

    implicit none
    integer, intent(out) :: cvms, vta_flag
    cvms = compute_vega_mags
    vta_flag = vactoair_flag

  end subroutine

  subroutine get_nz(n_z)

    ! Get the number of metallicity bins (hard coded in sps_vars).
    implicit none
    integer, intent(out) :: n_z
    n_z = nz

  end subroutine

  subroutine get_zlegend(n_z,z_legend)

    ! Get the available metallicity values.
    implicit none
    integer, intent(in) :: n_z
    double precision, dimension(n_z), intent(out) :: z_legend
    z_legend = zlegend

  end subroutine

  subroutine get_timefull(n_age,timefull)

    ! Get the actual time steps of the SSPs.
    implicit none
    integer, intent(in) :: n_age
    double precision, dimension(n_age), intent(out) :: timefull

    timefull = time_full

  end subroutine

  subroutine get_ntfull(n_age)

    ! Get the total number of time steps (hard coded in sps_vars).
    implicit none
    integer, intent(out) :: n_age
    n_age = ntfull

  end subroutine

  subroutine get_nspec(ns)

    ! Get the number of wavelength bins in the spectra (hard coded in
    ! sps_vars).
    implicit none
    integer, intent(out) :: ns
    ns = nspec

  end subroutine

  subroutine get_nbands(nb)

    ! Get the number of known filters (hard coded in sps_vars).
    implicit none
    integer, intent(out) :: nb
    nb = nbands

  end subroutine

  subroutine get_nemline(nline)

    ! Get the number of emission lines (hard coded in sps_vars).
    implicit none
    integer, intent(out) :: nline
    nline = nemline

  end subroutine

  subroutine get_emlambda(nline,em_lambda)

    ! Get the emission line wavelengths
    implicit none
    integer, intent(in) :: nline
    double precision, dimension(nline), intent(out) :: em_lambda
    if (vactoair_flag .eq. 1) then
       em_lambda = vactoair(nebem_line_pos)
    else
       em_lambda = nebem_line_pos
    endif

  end subroutine

  subroutine get_lambda(ns,lambda)

    ! Get the grid of wavelength bins.
    implicit none
    integer, intent(in) :: ns
    double precision, dimension(ns), intent(out) :: lambda
    if (vactoair_flag .eq. 1) then
       lambda = vactoair(spec_lambda)
    else
       lambda = spec_lambda
    endif

  end subroutine

  subroutine get_libraries(isocname,specname,dustname)

    implicit none

    character(4), intent(out) :: isocname
    character(5), intent(out) :: specname
    character(6), intent(out) :: dustname
    isocname = isoc_type
    specname = spec_type
    dustname = str_dustem

  end subroutine

  subroutine get_isochrone_dimensions(n_age,n_mass)

    implicit none

    ! Get the dimensions of the produced isochrones.
    integer, intent(out) :: n_age,n_mass
    n_age = nt
    n_mass = n_mass

  end subroutine

  subroutine get_nmass_isochrone(zz, tt, nmass)

    implicit none

    ! Get the number of masses included in a specific isochrone.
    integer, intent(in) :: zz,tt
    integer, intent(out) :: nmass
    nmass = nmass_isoc(zz,tt)

  end subroutine

  subroutine get_stats(n_age,nline,age,mass_csp,lbol_csp,sfr,mdust,mformed,emlines)

    implicit none

    ! Get some stats about the computed SP.
    integer :: i
    integer, intent(in) :: n_age,nline
    double precision, dimension(n_age), intent(out) :: age,mass_csp,&
                                                       lbol_csp,sfr,mdust,&
                                                       mformed
    double precision, dimension(n_age,nline), intent(out) :: emlines

    do i=1,n_age
      age(i)      = ocompsp(i)%age
      mass_csp(i) = ocompsp(i)%mass_csp
      lbol_csp(i) = ocompsp(i)%lbol_csp
      sfr(i)      = ocompsp(i)%sfr
      mdust(i)    = ocompsp(i)%mdust
      mformed(i)  = ocompsp(i)%mformed
      emlines(i,:)  = ocompsp(i)%emlines
    enddo

  end subroutine

  subroutine get_filter_data(nb, wave_eff, mag_vega, mag_sun)

    !get info about the filters
    implicit none
    integer, intent(in) :: nb
    double precision, dimension(nb), intent(out) :: wave_eff,mag_vega,mag_sun
    wave_eff = filter_leff
    mag_vega = magvega - magvega(1)
    mag_sun = magsun

  end subroutine

  subroutine write_isoc(outfile)

    implicit none

    character(100), intent(in)  :: outfile

    call write_isochrone(outfile, pset)

  end subroutine

end module

FUNCTION GET_LUMDIST(z)

  !compute luminosity distance to redshift z
  !assumes flat universe w/ only matter and lambda
  !assumes om0,ol0,H0 set in sps_vars.f90
  
  USE sps_vars; USE sps_utils, ONLY : tsum
  IMPLICIT NONE
  INTEGER :: i
  INTEGER, PARAMETER :: ii=10000
  REAL(SP), INTENT(in) :: z
  REAL(SP) :: get_lumdist, dhub
  REAL(SP), DIMENSION(ii) :: zz, hub

  !---------------------------------------------------------------!
  !---------------------------------------------------------------!

  get_lumdist = 0.0

  !Hubble distance in pc
  dhub = clight/1E13/H0*1E6

  DO i=1,ii
     zz(i) = REAL(i)/ii*z
  ENDDO
  
  hub = SQRT( om0*(1+zz)**3 + ol0 )

  get_lumdist = TSUM(zz,1/hub) * (1+z) * dhub


END FUNCTION GET_LUMDIST

FUNCTION IMF(mass)

  !define IMFs (dn/dM)

  !the following is just a fast-and-loose way to pass things around:
  !if the imf_type var is +10 then we calculate dn/dm*m
  !if the imf_type var is <10 then we calculate dn/dm
  
  USE sps_vars
  IMPLICIT NONE

  REAL(SP), DIMENSION(:), INTENT(in) :: mass
  REAL(SP), DIMENSION(SIZE(mass)) :: imf
  INTEGER :: i,n
  REAL(SP) :: imfcu

  !---------------------------------------------------------------!
  !---------------------------------------------------------------!
 
  imf = 0.0

  !Salpeter (1955) IMF
  IF (MOD(imf_type,10).EQ.0) THEN
     imf = mass**(-salp_ind) 
     IF (imf_type.EQ.10) imf = mass*imf
  ENDIF
  
  !Chabrier (2003) IMF
  IF (MOD(imf_type,10).EQ.1) THEN
     DO i=1,size(mass)
        IF (mass(i).LT.1) THEN
           imf(i) = exp(-(log10(mass(i))-log10(chab_mc))**2&
                /2/chab_sigma2)
        ELSE
           imf(i) = exp(-log10(chab_mc)**2/2./chab_sigma2)*&
                mass(i)**(-chab_ind)
        ENDIF
     ENDDO
     !convert from dn/dlnM to dn/dM
     imf = imf/mass
     IF (imf_type.EQ.11) imf = mass*imf
  ENDIF
  
  !Kroupa (2001) IMF
  IF (MOD(imf_type,10).EQ.2) THEN
     DO i=1,size(mass)
        IF (mass(i).GE.0.08.AND.mass(i).LT.0.5) &
             imf(i) = mass(i)**(-imf_alpha(1))
        IF (mass(i).GE.0.5.AND.mass(i).LT.1.0) &
             imf(i) = 0.5**(-imf_alpha(1)+imf_alpha(2))*&
             mass(i)**(-imf_alpha(2))
        IF (mass(i).GE.1.0) &
             imf(i) = 0.5**(-imf_alpha(1)+imf_alpha(2))*&
             mass(i)**(-imf_alpha(3))
     ENDDO
     IF (imf_type.EQ.12) imf = mass*imf
  ENDIF
  
  !van Dokkum (2008) IMF
  IF (MOD(imf_type,10).EQ.3) THEN
     DO i=1,size(mass)
        IF (mass(i).LE.vd_nc*imf_vdmc) THEN
           imf(i) = vd_al*(0.5*vd_nc*imf_vdmc)**(-vd_ind)*&
                exp(-(log10(mass(i))-log10(imf_vdmc))*&
                (log10(mass(i))-log10(imf_vdmc))/2./vd_sigma2)
        ELSE
           imf(i) = vd_ah*mass(i)**(-vd_ind)
        ENDIF
     ENDDO
     !convert from dn/dlnM to dn/dM
     imf = imf/mass
     IF (imf_type.EQ.13) imf = mass*imf
  ENDIF
  
  !Dave (2008) IMF
  IF (MOD(imf_type,10).EQ.4) THEN
     DO i=1,size(mass)
        IF (mass(i).GE.0.08.AND.mass(i).LT.imf_mdave) &
             imf(i) = mass(i)**(-imf_alpha(1))
        IF (mass(i).GE.imf_mdave) &
             imf(i) = imf_mdave**(-imf_alpha(1)+imf_alpha(2))*&
             mass(i)**(-imf_alpha(2))
     ENDDO
     IF (imf_type.EQ.14) imf = mass*imf
  ENDIF

  !user-defined IMF
  IF (MOD(imf_type,10).EQ.5) THEN
     DO i=1,size(mass)
        IF (mass(i).GE.imf_user_alpha(1,1).AND.&
                mass(i).LT.imf_user_alpha(2,1)) &
                imf(i) = mass(i)**(-imf_user_alpha(3,1))
        imfcu = 1.0
        DO n=2,n_user_imf
           IF (mass(i).GE.imf_user_alpha(1,n).AND.&
                mass(i).LT.imf_user_alpha(2,n)) &
                imf(i) = mass(i)**(-imf_user_alpha(3,n))*&
                imf_user_alpha(1,n)**(-imf_user_alpha(3,n-1)+&
                imf_user_alpha(3,n))*imfcu
           imfcu = imfcu*imf_user_alpha(1,n)**(-imf_user_alpha(3,n-1)+&
                imf_user_alpha(3,n))
        ENDDO
     ENDDO
     IF (imf_type.EQ.15) imf = mass*imf
  ENDIF

END FUNCTION IMF

SUBROUTINE ADD_NEBULAR(pset,sspi,sspo,nebemline)

  !routine to add nebular emission (both line and continuum)
  !to input SSPs (sspi).  Returns SSPs as output (sspo).

  USE sps_vars; USE sps_utils, ONLY : locate,tsum
  IMPLICIT NONE

  INTEGER :: t,i,nti,a1,z1,u1
  REAL(SP) :: da,dz,du,sigma,dlam,qq,compute_q
  TYPE(PARAMS), INTENT(in) :: pset
  REAL(SP), INTENT(in), DIMENSION(nspec,ntfull)    :: sspi
  REAL(SP), INTENT(inout), DIMENSION(nspec,ntfull) :: sspo
  REAL(SP), INTENT(inout), DIMENSION(nemline,ntfull), OPTIONAL :: nebemline
  REAL(SP), DIMENSION(nemline) :: tmpnebline
  REAL(SP), DIMENSION(nspec)   :: tmpnebcont,nu

  !-----------------------------------------------------------!
  !-----------------------------------------------------------!

  !locate the maximum nebular age point in the full time array
  nti = locate(time_full,nebem_age(nebnage))
  !right now we only include nebular emission for ages<2x10^7 yr
  !nti = locate(time_full,7.d30)

  !set up the interpolation variables for logZ and logU
  z1 = MAX(MIN(locate(nebem_logz,pset%gas_logz),nebnz-1),1)
  dz = (pset%gas_logz-nebem_logz(z1))/(nebem_logz(z1+1)-nebem_logz(z1))
  dz = MAX(MIN(dz,1.0),0.0) !no extrapolation
  u1 = MAX(MIN(locate(nebem_logu,pset%gas_logu),nebnip-1),1)
  du = (pset%gas_logu-nebem_logu(u1))/(nebem_logu(u1+1)-nebem_logu(u1))
  du = MAX(MIN(du,1.0),0.0) !no extrapolation

  !set up a "master" array of normalized Gaussians
  !in sps_setup.f90 this makes the code much faster
  IF (setup_nebular_gaussians.EQ.0.AND.nebemlineinspec.EQ.1) THEN
     DO i=1,nemline
        IF (smooth_velocity.EQ.1) THEN
           !smoothing variable is km/s
           dlam = nebem_line_pos(i)*pset%sigma_smooth/clight*1E13
        ELSE
           !smoothing variable is A
           dlam = pset%sigma_smooth
        ENDIF
        !broaden the line to at least the resolution element 
        !of the spectrum (x2).
        dlam = MAX(dlam,neb_res_min(i)*2)
        gaussnebarr(:,i) = 1/SQRT(2*mypi)/dlam*&
             EXP(-(spec_lambda-nebem_line_pos(i))**2/2/dlam**2)  / &
             clight*nebem_line_pos(i)**2
     ENDDO
  ENDIF

  sspo = sspi
  nebemline = 0.0
  
  DO t=1,nti

     !remove ionizing photons from the stellar source
     sspo(1:whlylim,t) = sspi(1:whlylim,t)*MAX(MIN(pset%frac_obrun,1.0),0.0)

     !the number of ionizing photons is computed here
     !some fraction of the stars are "runaways" which means
     !that they are not embedded in the HII region
     qq = tsum(spec_nu(:whlylim),sspi(:whlylim,t)/spec_nu(:whlylim))/&
          hplank*lsun 
     qq = qq * (1-pset%frac_obrun)

     !set up age interpolant
     a1 = MAX(MIN(locate(nebem_age,time_full(t)),nebnage-1),1)
     da = (time_full(t)-nebem_age(a1))/(nebem_age(a1+1)-nebem_age(a1))
     da = MAX(MIN(da,1.0),0.0) !no extrapolations
    
     !add nebular continuum emission
     IF (add_neb_continuum.EQ.1) THEN
        tmpnebcont = &   !interpolate in Zgas, logU, age
             (1-dz)*(1-da)*(1-du)* nebem_cont(:,z1,a1,u1)+&
             (1-dz)*(1-da)*(du)*   nebem_cont(:,z1,a1,u1+1)+&
             (1-dz)*(da)*(1-du)*   nebem_cont(:,z1,a1+1,u1)+&
             (1-dz)*(da)*(du)*     nebem_cont(:,z1,a1+1,u1+1)+&
             (dz)*(1-da)*(1-du)*   nebem_cont(:,z1+1,a1,u1)+&
             (dz)*(1-da)*(du)*     nebem_cont(:,z1+1,a1,u1+1)+&
             (dz)*(da)*(1-du)*     nebem_cont(:,z1+1,a1+1,u1)+&
             (dz)*(da)*(du)*       nebem_cont(:,z1+1,a1+1,u1+1)
        sspo(:,t) = sspo(:,t) + 10**tmpnebcont * qq
     ENDIF

     !add line emission
     tmpnebline = &    !interpolate in Zgas, logU, age
          (1-dz)*(1-da)*(1-du)* nebem_line(:,z1,a1,u1)+&
          (1-dz)*(1-da)*(du)*   nebem_line(:,z1,a1,u1+1)+&
          (1-dz)*(da)*(1-du)*   nebem_line(:,z1,a1+1,u1)+&
          (1-dz)*(da)*(du)*     nebem_line(:,z1,a1+1,u1+1)+&
          (dz)*(1-da)*(1-du)*   nebem_line(:,z1+1,a1,u1)+&
          (dz)*(1-da)*(du)*     nebem_line(:,z1+1,a1,u1+1)+&
          (dz)*(da)*(1-du)*     nebem_line(:,z1+1,a1+1,u1)+&
          (dz)*(da)*(du)*       nebem_line(:,z1+1,a1+1,u1+1)

     IF (PRESENT(nebemline)) nebemline(:,t) = 10**tmpnebline*qq

     IF (nebemlineinspec.EQ.1) THEN
        DO i=1,nemline
           sspo(:,t) = sspo(:,t) + 10**tmpnebline(i)*qq*gaussnebarr(:,i)
        ENDDO
     ENDIF
        
  ENDDO


END SUBROUTINE ADD_NEBULAR

function sfh_weight(sfh, imin, imax)
  ! Function to calculate the weights
  !
  ! Inputs
  ! --------
  !
  ! sfh:
  !   An SFHPARAMS structure, containing SFH parameters in yrs, and some
  !   useful lookback times.
  !
  ! imin:
  !   The index of the youngest SSP to consider.  If zero, weights for the t=0
  !   -> t=time_full(1) bin will be added to sfh_weights(1)
  !
  ! imax:
  !   The oldest SSP to consider.  This should usually be the next oldest SSP
  !   compared to tage (or tage - sf_start)
  !
  ! Outputs
  ! --------
  !
  ! sfh_weight:
  !   array of shape `ntfull` that gives the proper weights for the SSPs to
  !   produce the SFH.

  use sps_vars, only: ntfull, time_full, tiny_logt, &
                      SFHPARAMS, SP
  use sps_utils, only: intsfwght, sfhlimit, locate
  implicit none
  
  type(SFHPARAMS), intent(in) :: sfh
  integer, intent(in) :: imin, imax

  real(SP), dimension(ntfull) ::sfh_weight
  
  integer :: i, istart
  real(SP), dimension(2) :: tlim
  real(SP) :: dt, delta_time, log_tb
  real(SP), dimension(ntfull) :: tmp_wght=0. !left=0., right=0.
  

  ! Check if this is an SSP.  If so, do simple weights and return.
  if (sfh%type.eq.-1) then
     sfh_weight = 0.
     ! Check for burst out of valid limits.
     ! N.B. we allow bursts before sf_start (sfh%tb > sfh%tage)
     if (sfh%tb.lt.0) then
        return
     endif
     log_tb = log10(sfh%tb)
     if (log_tb.le.time_full(1)) then
        ! Just return all weight in the youngest ssp.
        sfh_weight(1) = 1.0
        return
     endif

     istart = min(max(locate(time_full, log_tb), 1), ntfull-1)
     dt = delta_time(time_full(istart), time_full(istart+1))
     sfh_weight(istart) = delta_time(log_tb, time_full(istart+1)) / dt
     sfh_weight(istart+1) = delta_time(time_full(istart), log_tb) / dt
     return
  endif

  ! Loop over each SSP and calculate its weight in the given sfh.
  ! Note we skip i=0 for now, which is a flag for adding in the bin from t=0 to
  ! t=time_full(1).
  tmp_wght = 0.
  istart = max(imin, 1)
  do i=istart, imax
     if (i.gt.1) then
        ! There is a younger (`left`) bin, and we calculate its contribution to
        ! the weight.
        ! First calculate actual limits for the younger bin.  
        tlim(1) = sfhlimit(time_full(i-1), sfh)
        tlim(2) = sfhlimit(time_full(i), sfh)
        ! The elements of `tlim` will be equal if there is no valid SFR in the
        ! younger bin; only proceed if there is a non-zero sfr in the younger bin.
        if (tlim(1).ne.tlim(2)) then
           dt = delta_time(time_full(i-1), time_full(i))
           ! Note sign flip here
           !left(i) = 0. - intsfwght(i-1, tlim, sfh) / dt
           tmp_wght(i) = tmp_wght(i) - intsfwght(i-1, tlim, sfh) / dt
        endif
     endif
     if (i.lt.ntfull) then
        ! There is an older (`right`) bin, we calculate its contribution to the
        ! weight.
        tlim(1) = sfhlimit(time_full(i), sfh)
        tlim(2) = sfhlimit(time_full(i+1), sfh)
        ! The elements of `tlim` will be equal if there is no valid SFR in the
        ! older bin; only proceed if there is a non-zero sfr in the older bin.
        if (tlim(1).ne.tlim(2)) then
           dt = delta_time(time_full(i), time_full(i+1))
           !right(i) = intsfwght(i+1, tlim, sfh) / dt
           tmp_wght(i) = tmp_wght(i) + intsfwght(i+1, tlim, sfh) / dt
        endif
     endif
  enddo

  ! Do we need to add weights from the zero bin to the first SSP?
  !   We assume the t~0 spectrum is the same as the t=10**time_full(1) spectrum
  !   (i.e., nearest neighbor extrapolation), so the t~0 weight gets added to
  !   sfh_weight(1)
  if (imin.eq.0) then
     tlim(1) = sfhlimit(tiny_logt, sfh)
     tlim(2) = sfhlimit(time_full(1), sfh)
     if (tlim(1).ne.tlim(2)) then
        dt = delta_time(tiny_logt, time_full(1))
        ! Contribution of i=1 to younger bin.
        tmp_wght(1) = tmp_wght(1) - intsfwght(0, tlim, sfh) / dt
        ! Contribution of i=0 to older bin
        tmp_wght(1) = tmp_wght(1) + intsfwght(1, tlim, sfh) / dt
     endif
  endif

  sfh_weight = tmp_wght

end function sfh_weight

  
function delta_time(logt1, logt2)
  ! Dumb function to properly calculate dt based on interpolation type.
  !
  ! Returns (logt2 - logt1), or (10**logt2 - 10**logt1)

  use sps_vars, only: interpolation_type, SP
  implicit none

  real(SP), intent(in) :: logt1, logt2
  real(SP) :: delta_time

  if (interpolation_type.eq.0) then
     delta_time = logt2 - logt1
  else if (interpolation_type.eq.1) then
     delta_time = 10**logt2 - 10**logt1
  endif

end function delta_time

SUBROUTINE MOD_GB(zz,t,age,delt,dell,pagb,redgb,agb,&
     nn,logl,logt,phase,wght)

  !routine to modify TP-AGB stars, HB+RGB, and post-AGB stars. 

  USE sps_vars
  IMPLICIT NONE

  INTEGER,  INTENT(in) :: t, nn,zz
  REAL(SP), INTENT(inout), DIMENSION(nt,nm) :: logl,logt
  REAL(SP), INTENT(in), DIMENSION(nt,nm)    :: phase
  REAL(SP), INTENT(inout), DIMENSION(nm)    :: wght
  REAL(SP), INTENT(in) :: delt, dell, pagb, redgb, agb
  REAL(SP), INTENT(in), DIMENSION(nt) :: age
  INTEGER  :: i
  REAL(SP) :: age8=8.0_sp,age91=9.1_sp,twght

  !---------------------------------------------------------------!
  !---------------------------------------------------------------!
 
  DO i=1,nn

     !modify TP-AGB stars
     IF (phase(t,i).EQ.5.0) THEN

        !renormalize the Padova isochrones
        IF (isoc_type.EQ.'pdva'.AND.tpagb_norm_type.NE.0) THEN

           !Conroy & Gunn (2010) normalization
           IF (tpagb_norm_type.EQ.1) THEN

              IF (age(t).GT.age8.AND.age(t).LT.age91) THEN
                 logl(t,i) = logl(t,i) - 1.0+(age(t)-8.)/1.5
                 IF (LOG10(zlegend(zz)/zsol).LT.-0.25) THEN
                    logt(t,i) = logt(t,i) + 0.10
                 ENDIF
              ELSE
                 logl(t,i) = logl(t,i) - &
                      MAX(MIN(0.4,-LOG10(zlegend(zz)/zsol)),0.2)
                 logt(t,i) = logt(t,i) + 0.1 - MIN((age(t)-age91)/1.5,0.2)
              ENDIF

           !Villaume, Conroy, Johnson (2014) normalization
           ELSE IF (tpagb_norm_type.EQ.2) THEN

              twght   = MAX(0.1,10**(-1.+(age(t)-8.0)/2.5))
              wght(i) = twght * wght(i)

           ENDIF

        ENDIF

        ! modify wght of tp-agb stars
        wght(i) = wght(i)*agb

        !add extra fudge factors to the default normalization
        logl(t,i) = logl(t,i) + dell
        logt(t,i) = logt(t,i) + delt

     ENDIF

     !modify post-AGB stars
     IF (phase(t,i).EQ.6.0.AND.pagb.NE.1.0) THEN
        wght(i) = wght(i)*pagb
     ENDIF

     !modify RGB + red clump HB + AGB
     !NB: this feature does not work w/ Padova isochrones, which
     !dont have these phases explicitly defined
     IF (phase(t,i).EQ.2.OR.phase(t,i).EQ.3 &
          .OR.phase(t,i).EQ.4.OR.phase(t,i).EQ.5) THEN
        !logt(t,i) = LOG10(10**logt(t,i) - 100.)
        wght(i) = wght(i)*redgb
     ENDIF

  ENDDO

END SUBROUTINE MOD_GB

FUNCTION ATTN_CURVE(lambda,dtype,pset)

  ! Routine to generate and return the attenuation curve for a chosen 
  ! dust type.  The V-band optical depth (dust2) is passed via the 
  ! pset variable.  Option 3 (Witt & Gordon models) do not use the
  ! dust2 option as those grids fully predict the actual attn curves.

  USE sps_vars
  USE sps_utils, ONLY : locate
  IMPLICIT NONE

  INTEGER, INTENT(in) :: dtype
  TYPE(PARAMS), INTENT(in) :: pset
  INTEGER  :: w63
  REAL(SP) :: eb,zero=0.0,dd63=6300.00,lamv=5500.0,dlam=350.0,lamuvb=2175.0
  REAL(SP), INTENT(in), DIMENSION(nspec) :: lambda
  REAL(SP), DIMENSION(nspec) :: x,a,b,y,fa,fb,hack,cal00
  REAL(SP), DIMENSION(nspec) :: attn_curve,drude,tmp
 
  !---------------------------------------------------------------------!

  attn_curve = 0.0

  !-------------------------power-law attenuation-----------------------!

  !power-law attenuation
  IF (dtype.EQ.0) THEN 

     attn_curve = (lambda/lamv)**pset%dust_index * pset%dust2

  !-----------------CCM89 MW curve w/ variable UV bump------------------!

  !MW extinction law w/ UV bump
  ELSE IF (dtype.EQ.1) THEN 

     tmp = 0.0

     !use CCM89 extinction curve parameterization
     x = 1E4/lambda
     y = x-1.82

     !IR
     tmp(mwdindex(2):mwdindex(1)) = &
          (0.574*x(mwdindex(2):mwdindex(1))**1.61) + &
          (-0.527*x(mwdindex(2):mwdindex(1))**1.61)/pset%mwr

     !optical+near-IR
     tmp(mwdindex(3):mwdindex(2)) = &
          (1+0.17699*y(mwdindex(3):mwdindex(2))-&
          0.50447*y(mwdindex(3):mwdindex(2))**2-&
          0.02427*y(mwdindex(3):mwdindex(2))**3+&
          0.72085*y(mwdindex(3):mwdindex(2))**4+&
          0.01979*y(mwdindex(3):mwdindex(2))**5-&
          0.77530*y(mwdindex(3):mwdindex(2))**6+&
          0.32999*y(mwdindex(3):mwdindex(2))**7)+&
          (1.41338*y(mwdindex(3):mwdindex(2))+&
          2.28305*y(mwdindex(3):mwdindex(2))**2+&
          1.07233*y(mwdindex(3):mwdindex(2))**3-&
          5.38434*y(mwdindex(3):mwdindex(2))**4-&
          0.62251*y(mwdindex(3):mwdindex(2))**5+&
          5.3026*y(mwdindex(3):mwdindex(2))**6-&
          2.09002*y(mwdindex(3):mwdindex(2))**7)/pset%mwr

     !near-UV
     a = 1.752-0.316*x-0.104/((x-4.67)**2+0.341)*pset%uvb
     b = -3.09+1.825*x+1.206/((x-4.62)**2+0.263)*pset%uvb
     !this hack parameter is not in the original CCM89 
     !parameterization.  It is a hack designed to result in 
     !a smooth profile in the presence of a variable UVB strength
     hack = (x(mwdindex(3))/x)**6.*(tmp(mwdindex(3))-&
          (a(mwdindex(3))+b(mwdindex(3))/pset%mwr))
     tmp(mwdindex(4):mwdindex(3)) = &
          a(mwdindex(4):mwdindex(3)) + &
          b(mwdindex(4):mwdindex(3))/pset%mwr + &
          hack(mwdindex(4):mwdindex(3))

     !mid-UV
     fa = -0.04473*(x-5.9)**2-0.009779*(x-5.9)**3
     fb =  0.2130*(x-5.9)**2+0.1207*(x-5.9)**3
     a  = 1.752-0.316*x-0.104/((x-4.67)**2+0.341)*pset%uvb+fa
     b  = -3.09+1.825*x+1.206/((x-4.62)**2+0.263)*pset%uvb+fb
     tmp(mwdindex(5):mwdindex(4)) = &
          a(mwdindex(5):mwdindex(4)) + b(mwdindex(5):mwdindex(4))/pset%mwr

     !far-UV
     a = -1.073-0.628*(x-8.)+0.137*(x-8.)**2-0.070*(x-8.)**3
     b = 13.67+4.257*(x-8.)-0.42*(x-8.)**2+0.374*(x-8.)**3
     tmp(mwdindex(6):mwdindex(5)) = &
          a(mwdindex(6):mwdindex(5)) + b(mwdindex(6):mwdindex(5))/pset%mwr

     !set to a constant at lambda < 12 um^-1
     a = -1.073-0.628*(12.-8.)+0.137*(12.-8.)**2-0.070*(12.-8.)**3
     b = 13.67+4.257*(12.-8.)-0.42*(12.-8.)**2+0.374*(12.-8.)**3
     tmp(:mwdindex(6)) = &
          a(:mwdindex(6)) + b(:mwdindex(6))/pset%mwr

     attn_curve = pset%dust2*tmp


  !------------------Calzetti et al. 2000 attenuation-------------------!

  ELSE IF (dtype.EQ.2) THEN 

     w63   = locate(lambda,dd63)
     cal00 = 0.0
     cal00(w63+1:) = 1.17*( -1.857+1.04*(1E4/lambda(w63+1:)) ) + 1.78
     cal00(1:w63)  = 1.17*(-2.156+1.509*(1E4/lambda(1:w63))-&
          0.198*(1E4/lambda(1:w63))**2 + &
          0.011*(1E4/lambda(1:w63))**3) + 1.78
     cal00 = cal00/0.44/4.05  !R=4.05
     w63   = locate(cal00,zero)
     IF (w63.NE.nspec) THEN
        cal00(w63+1:) = 0.0
     ENDIF
 
     attn_curve = cal00 * pset%dust2

  !------------------Witt & Gordon 2000 attenuation--------------------!

  ELSE IF (dtype.EQ.3) THEN
  
     attn_curve = wgdust(:,pset%wgp1,pset%wgp2,pset%wgp3)

  !------------------Kriek & Conroy 2013 attenuation-------------------!

  ELSE IF (dtype.EQ.4) THEN

     !Calzetti curve
     w63   = locate(lambda,dd63)
     cal00 = 0.0
     cal00(w63+1:) = 1.17*( -1.857+1.04*(1E4/lambda(w63+1:)) ) + 1.78
     cal00(1:w63)  = 1.17*(-2.156+1.509*(1E4/lambda(1:w63))-&
          0.198*(1E4/lambda(1:w63))**2 + &
          0.011*(1E4/lambda(1:w63))**3) + 1.78
     !R=4.05 NB: I'm not sure I have this normalization correct...
     cal00 = cal00/0.44/4.05 
     w63   = locate(cal00,zero)
     IF (w63.NE.nspec) THEN
        cal00(w63+1:) = 0.0
     ENDIF

     eb = 0.85 - 1.9 * pset%dust_index  !KC13 Eqn 3

     !Drude profile for 2175A bump
     drude = eb*(lambda*dlam)**2 / &
          ( (lambda**2-lamuvb**2)**2 + (lambda*dlam)**2 )

     attn_curve = pset%dust2*(cal00+drude/4.05)*&
          (lambda/lamv)**pset%dust_index

  ENDIF


END FUNCTION ATTN_CURVE

PROGRAM AUTOSPS

  USE sps_vars; USE sps_utils
  
  IMPLICIT NONE

  INTEGER :: z
  REAL(SP), DIMENSION(ntfull,nspec)  :: spec_ssp
  REAL(SP), DIMENSION(ntfull)        :: mass_ssp,lbol_ssp
  CHARACTER(100) :: file1='',aux
  CHARACTER(3)  :: str
  TYPE(PARAMS)  :: pset
  TYPE(COMPSPOUT), DIMENSION(ntfull) :: ocompsp

  !---------------------------------------------------------------!
  !---------------------------------------------------------------!
  
  IF (isoc_type.NE.'pdva') THEN
     WRITE(*,*) 'ERROR: autosps only works with the "Padova" isochrones'
     WRITE(*,*) '       edit sps_vars.f90 to turn these isochrones on'
     RETURN
  ENDIF

  !set IMF
  WRITE(6,*)  'enter IMF [0-5; def:0]:'
  WRITE(6,*) ' (0=Salpeter, 1=Chabrier 2003, 2=Kroupa 2001, '//&
       '3=van Dokkum 2008, 4=Dave 2008, 5=tabulated)'
  READ(5,'(A)')  aux
  IF (LEN(TRIM(aux)).EQ.0) THEN
     imf_type = 0
  ELSE
     READ(aux,'(I1)') imf_type
  ENDIF
  IF (imf_type.LT.0.OR.imf_type.GT.5) THEN
     WRITE(*,*) 'ERROR: imf out of bounds: ',imf_type
     STOP
  ENDIF
  WRITE(6,'(" ---> Using IMF",1x,I1)') imf_type
  

  !setup directory and metallicity array
  CALL GETENV('SPS_HOME',SPS_HOME)
  IF (LEN_TRIM(SPS_HOME).EQ.0) THEN
     WRITE(*,*) 'SETUP_SPS ERROR: spsdir environment variable not set!'
     STOP
  ENDIF
  OPEN(90,FILE=TRIM(SPS_HOME)//'/ISOCHRONES/Padova/Padova2007/zlegend.dat',&
       STATUS='OLD',ACTION='READ')
  DO z=1,nz
     READ(90,'(F6.4)') zlegend(z)
  ENDDO
  CLOSE(90)


  !set SFH
  WRITE(6,*)
  WRITE(6,*)  'Specify SFH [0-2, def:0]'
  WRITE(6,*)  '(0=SSP, 1=CSP, 2=tabulated)'
  READ(5,'(A)')  aux
  IF (len(trim(aux)).EQ.0) THEN
     pset%sfh = 0
  ELSE
     READ(aux,'(I1)') pset%sfh
  ENDIF
  IF (pset%sfh.EQ.0) WRITE(6,'(" ---> Computing an SSP")') 
  IF (pset%sfh.EQ.1) WRITE(6,'(" ---> Computing a CSP")') 
  IF (pset%sfh.EQ.2) WRITE(6,'(" ---> Computing a tabulated SFH")') 

  IF (pset%sfh.EQ.1) THEN
     WRITE(6,*)
     WRITE(6,*) 'input parameters for CSP: tau, const, age, fburst, tburst'
     WRITE(6,*) ' - tau in Gyr' 
     WRITE(6,*) ' - const as fraction of mass formed in constant component'
     WRITE(6,*) ' - age of the system in Gyr.  i.e. results span the time 0<t<age'
     WRITE(6,*) ' - fburst as fraction of mass formed in an instantaneous burst'
     WRITE(6,*) ' - tburst as time of burst, with tburst<age'
     READ(5,*) pset%tau,pset%const,tuniv,pset%fburst,pset%tburst
     pset%tage = 0.0
     IF (pset%const.LT.0.OR.pset%const.GT.1.0) THEN
        WRITE(6,*) 'ERROR, const out of bounds: ',pset%const
        STOP
     ENDIF
     IF (pset%fburst.LT.0.OR.pset%fburst.GT.1.0) THEN
        WRITE(6,*) 'ERROR, fburst out of bounds: ',pset%fburst
        STOP
     ENDIF
     WRITE(6,'(" ---> (tau const age fburst tburst)=(",5(F6.2),")")') &
          pset%tau,pset%const,tuniv,pset%fburst,pset%tburst

  ENDIF

  IF (pset%sfh.NE.2) THEN
     !set metallicity
     WRITE(6,*)
     WRITE(6,*)  'enter metallicity [1-22; def:20]:'
     READ(5,'(A)')  aux
     IF (len(trim(aux)).EQ.0) THEN
        pset%zmet = 20
     ELSE
        READ(aux,'(I2)') pset%zmet
     ENDIF
     IF (pset%zmet.LT.1.OR.pset%zmet.GT.nz) THEN
        WRITE(*,*) 'ERROR: Z out of bounds: ',pset%zmet
        STOP
     ENDIF
     WRITE(6,'(" ---> Using metallicity",1x,I2," corresponding to log(Z/Zsol)=",1x,F5.2)') &
          pset%zmet,LOG10(zlegend(pset%zmet)/zsol)
  ENDIF

  !set dust
  WRITE(6,*)
  WRITE(6,*)  'Include default dust model? [yes/no, def:no]'
  WRITE(6,*)  '(default: tau1=1.0, tau2=0.3, MW extinction)'
  READ(5,'(A)')  aux
  IF (len(trim(aux)).NE.0) THEN
     READ(aux,'(A3)') str
     IF (str(1:1).EQ.'y') THEN
        dust_type  = 1
        pset%dust1 = 1.0
        pset%dust2 = 0.3
     ENDIF
  ENDIF
  WRITE(6,'(" ---> tau1=",1x,F5.2,", tau2=",1x,F5.2)') pset%dust1,pset%dust2


  !set filename
  WRITE(6,*)
  WRITE(6,*)  'Enter filename [def: "CSP.out"]'
  READ(5,'(A)')  aux
  IF (len(trim(aux)).EQ.0) THEN
     file1 = 'CSP.out'
  ELSE
     READ(aux,'(A)') file1
  ENDIF
  WRITE(6,'(" ---> Output filename:",1x,A100)') file1


  WRITE(6,'(" ---> Running model.......")')
  
  IF (pset%sfh.EQ.2) THEN
     CALL SPS_SETUP(-1) 
     DO z=1,nz
        pset%zmet=z
        CALL SSP_GEN(pset,mass_ssp_zz(:,z),lbol_ssp_zz(:,z),spec_ssp_zz(:,:,z))
     ENDDO
     CALL COMPSP(3,nz,file1,mass_ssp_zz,lbol_ssp_zz,spec_ssp_zz,pset,ocompsp)
  ELSE
     CALL SPS_SETUP(pset%zmet)
     CALL SSP_GEN(pset,mass_ssp,lbol_ssp,spec_ssp)
     CALL COMPSP(3,1,file1,mass_ssp,lbol_ssp,spec_ssp,pset,ocompsp)
  ENDIF


END PROGRAM AUTOSPS 

SUBROUTINE SMOOTHSPEC(lambda,spec,sigma,minl,maxl,ires)

  !routine to compute velocity broadening of an input spectrum
  !this is only approximate b/c we are ignoring the variation
  !in dlambda with lambda within each integration
  !integration is truncated at +/-4*sigma.
  !If optional input ires is present, then the spectrum will be
  !smoothed by a wavelength dependent velocity dispersion.

  USE sps_vars; USE sps_utils, ONLY : locate,linterp,tsum,linterparr
  IMPLICIT NONE
  
  REAL(SP), INTENT(inout), DIMENSION(nspec) :: spec
  REAL(SP), INTENT(in), DIMENSION(nspec)    :: lambda
  REAL(SP), INTENT(in), DIMENSION(nspec), OPTIONAL :: ires
  REAL(SP), INTENT(in) :: sigma,minl,maxl
  REAL(SP), DIMENSION(nspec) :: tspec,tnspec,vel,func,gauss,psf,lnlam
  REAL(SP) :: ckms,cg,xmax,xmin,fwhm,psig,dlstep,sigmal
  INTEGER :: i,j,il,ih,m=4,grange

  !---------------------------------------------------------------!
  !---------------------------------------------------------------!
 
  IF (sigma.LE.tiny_number) RETURN

  ckms = clight/1E13

  tspec = spec

  !convolve at fixed sigma_velocity
  IF (smooth_velocity.EQ.1) THEN

     !compute smoothing the fast (and slightly less accurate) way
     IF (smoothspec_fast.EQ.1.OR.PRESENT(ires)) THEN
        
        spec = 0.0

        DO i=1,nspec
           
           IF (lambda(i).LT.minl.OR.lambda(i).GT.maxl) THEN
              spec(i)=tspec(i)
              CYCLE
           ENDIF
           
           IF (PRESENT(ires)) THEN
              sigmal = ires(i)
              IF (sigmal.LE.tiny_number) THEN
                 spec(i)=tspec(i)
                 CYCLE
              ENDIF
           ELSE
              sigmal = sigma
           ENDIF

           xmax = lambda(i)*(m*sigmal/ckms+1)
           ih   = MIN(locate(lambda(1:nspec),xmax),nspec)
           il   = MAX(2*i-ih,1)
           
           IF (il.EQ.ih) THEN
              spec(i) = tspec(i)
           ELSE
              vel(il:ih)  = (lambda(i)/lambda(il:ih)-1)*ckms
              func(il:ih) =  1/SQRT(2*mypi)/sigmal * &
                   EXP(-vel(il:ih)**2/2./sigmal**2)
              !normalize the weights to integrate to unity
              func(il:ih) = func(il:ih) / TSUM(vel(il:ih),func(il:ih))
              spec(i) = TSUM(vel(il:ih),func(il:ih)*tspec(il:ih))
          ENDIF
           
        ENDDO

     !compute smoothing the correct (and somewhat slower) way
     !NB: the accuracy of this approach depends strongly on the 
     !min/max wavelength parameters through the density of the lnlam grid
     ELSE
        
        dlstep = (LOG(maxl)-LOG(minl))/nspec
        DO i=1,nspec
           lnlam(i) = i*dlstep+LOG(minl)
        ENDDO
        
        tspec = linterparr(LOG(lambda(1:nspec)),spec(1:nspec),lnlam)
        
        fwhm   = sigma*2.35482/ckms/dlstep
        psig   = fwhm/2.0/SQRT(-2.0*LOG(0.5)) ! equivalent sigma for kernel
        grange = FLOOR(m*psig)	              ! range for kernel (-range:range)
        
        DO i=1,2*grange+1
           psf(i) = 1.d0/SQRT(2.*mypi)/psig*EXP(-((i-grange-1)/psig)**2/2.)
        ENDDO
        psf(1:2*grange+1) = psf(1:2*grange+1) / SUM(psf(1:2*grange+1))
        
        DO i=grange+1,nspec-grange
           tnspec(i) = SUM( psf(1:2*grange+1)*tspec(i-grange:i+grange) )
        ENDDO
        
        !the ends are not smoothed
        DO i=1,grange
           tnspec(i)=tspec(i)
        ENDDO
        DO i=nspec-grange+1,nspec
           tnspec(i)=tspec(i)
        ENDDO
        
        !interpolate back to the main array
        il = locate(lambda,minl)
        ih = locate(lambda,maxl)
        spec(il:ih) = linterparr(EXP(lnlam),tnspec,lambda(il:ih))
        
     ENDIF

  !convolve at fixed sigma_wavelength
  ELSE
     
     DO i=1,nspec

        IF (lambda(i).LT.minl.OR.lambda(i).GT.maxl) THEN
           spec(i)=tspec(i)
           CYCLE
        ENDIF

        xmax = lambda(i)*(m*sigma+1)
        ih   = MIN(locate(lambda(1:nspec),xmax),nspec)
        il   = MAX(2*i-ih,1)

        IF (il.EQ.ih) THEN
           spec(i) = tspec(i)
        ELSE
           func(il:ih) =  1/SQRT(2*mypi)/sigma * &
                EXP(-(lambda(il:ih)-lambda(i))**2/2./sigma**2)
           !normalize the weights to integrate to unity
           func(il:ih) = func(il:ih) / TSUM(lambda(il:ih),func(il:ih))
           spec(i) = TSUM(lambda(il:ih),func(il:ih)*tspec(il:ih))
        ENDIF

        !gauss = 1/SQRT(2*mypi)/sigma*EXP(-(lambda-lambda(i))**2/2/sigma**2)
        !DO j=1,nspec
        !   spec(i) = spec(i) + gauss(j)*tspec(j)
        !ENDDO
 
    ENDDO
     
  ENDIF

  RETURN

END SUBROUTINE SMOOTHSPEC

function sfhlimit(tlim, sfh)
  ! Deal with all the logic for computing the limits of integration in the
  ! weight calculations.  This should return the input `tlim`, clipped to valid
  ! limits, such that if no SFR occurs between t1 and t2 then sfhlimit(t1, sfh)
  ! = sfhlimit(t2, sfh)
  !
  ! Inputs
  ! ----------
  !
  ! tlim:
  !    The proposed limit of the integration, in log(lookback_time(yrs)).
  !
  ! sfh:
  !    An sfhparams structure containing the relevant special lookback times.
  !
  use sps_vars, only: tiny_logt, SFHPARAMS, SP
  implicit none
  
  real(SP), intent(in) :: tlim
  type(SFHPARAMS), intent(in) :: sfh

  real(SP) :: sfhlimit
  
  real(SP) :: tlo, thi
  
  ! For the simha linear portion, we integrate from sf_trunc to tage or the
  ! zero crossing, whichever is smaller but still greater than sf_trunc.
  ! For everything else we integrate from 0 to tage or sf_trunc, whichever is
  ! smaller but non-zero.
  ! Of course, we are doing this using the lookback time versions of sf_trunc,
  ! the zero crossing time, and 0!!!
  if (sfh%use_simha_limits.eq.1) then
     tlo = sfh%t0
     thi = sfh%tq
  else
     tlo = sfh%tq
     thi = sfh%tage
  endif
  
  ! Convert to log, taking care of possible zeros.
  tlo = log10(max(tlo, 10**tiny_logt))
  thi = log10(max(thi, 10**tiny_logt))
  
  ! Finally, clip proposed limit to the upper and lower value
  sfhlimit = MIN(MAX(tlim, tlo), thi)
  
end function sfhlimit

SUBROUTINE SBF(pset,outfile)

  !routine to read in an isochrone (logt,logl,z) and produce 
  !SBFs for each point.  SBF magnitudes are a light-weighted average
  !of the stellar luminosities over stellar mass

  USE sps_vars
  USE sps_utils, ONLY : imf_weight,mod_hb,add_bs,mod_gb,getmags,getspec
  IMPLICIT NONE

  CHARACTER(100), INTENT(in) :: outfile
  TYPE(PARAMS), INTENT(in)   :: pset
  INTEGER       :: i,j
  CHARACTER(34) :: fmt
  REAL(SP)      :: zero=0.0,hb_wght
  REAL(SP), DIMENSION(nspec)  :: tspec,tspec2,spec1,spec2
  REAL(SP), DIMENSION(nbands) :: mags
  REAL(SP), DIMENSION(nm)     :: wght
  REAL(SP), DIMENSION(nt,nm)  :: mini,mact,logl,logt,logg,ffco,phase,lmdot
  INTEGER, DIMENSION(nt)      :: nmass
  REAL(SP), DIMENSION(nt)     :: time

  !-----------------------------------------------------------!
  !-----------------------------------------------------------!

  !set up the format 
  fmt = '(F7.4,1x,3(F8.4,1x),000(F7.3,1x))'
  WRITE(fmt(21:23),'(I3,1x,I4)') nbands

  !reset arrays
  hb_wght  = 0.
  wght     = 0.
 
  OPEN(56,FILE=TRIM(SPS_HOME)//'/OUTPUTS/'//TRIM(outfile)//&
       '.mags',STATUS='REPLACE')
  DO i=1,8 !write a dummy header
     WRITE(56,*) '#'
  ENDDO

  !transfer isochrones into temporary arrays
  mini  = mini_isoc(pset%zmet,:,:)  !initial mass
  mact  = mact_isoc(pset%zmet,:,:)  !actual (present) mass
  logl  = logl_isoc(pset%zmet,:,:)  !log(Lbol)
  logt  = logt_isoc(pset%zmet,:,:)  !log(Teff)
  logg  = logg_isoc(pset%zmet,:,:)  !log(g)
  ffco  = ffco_isoc(pset%zmet,:,:)  !is the TP-AGB star C-rich or O-rich?
  lmdot = lmdot_isoc(pset%zmet,:,:) !log Mdot
  phase = phase_isoc(pset%zmet,:,:) !flag indicating phase of evolution
  nmass = nmass_isoc(pset%zmet,:)   !number of elements per isochrone
  time  = timestep_isoc(pset%zmet,:)!age of each isochrone in log(yr)

  DO i=1,nt

     !compute IMF-based weights
     CALL IMF_WEIGHT(mini(i,:),wght,nmass(i))
     
     !modify the horizontal branch
     !need the hb weight for the blue stragglers too
     IF (pset%fbhb.GT.0.0.OR.pset%sbss.GT.1E-3) &
          CALL MOD_HB(pset%fbhb,i,mini,mact,logl,logt,logg,phase,&
          wght,hb_wght,nmass,time(i))

     !add in blue stragglers
     IF (time(i).GE.bhb_sbs_time.AND.pset%sbss.GT.1E-3) &
          CALL ADD_BS(pset%sbss,i,mini,mact,logl,logt,logg,phase,&
          wght,hb_wght,nmass)

     !modify the TP-AGB stars and Post-AGB stars
     CALL MOD_GB(pset%zmet,i,time,pset%delt,pset%dell,pset%pagb,&
          pset%redgb,pset%agb,nmass(i),logl,logt,phase,wght)
 
     spec1 = 0.0
     spec2 = 0.0
     DO j=1,nmass(i)
           
        !get spectrum of ith star
        CALL GETSPEC(pset,mact(i,j),logt(i,j),10**logl(i,j),logg(i,j),&
             phase(i,j),ffco(i,j),lmdot(i,j),wght(j),tspec)

        !compute first and second moments of flux for
        !all stars and also by evolutionary phase
        spec2 = spec2 + wght(j)*tspec**2
        spec1 = spec1 + wght(j)*tspec

     ENDDO

     !compute the SBF
     tspec2 = spec2/spec1

     CALL GETMAGS(zero,tspec2,mags)
     WRITE(56,fmt) time(i),0.0,0.0,0.0,mags

  ENDDO

  CLOSE(56)

END SUBROUTINE SBF
 

SUBROUTINE ADD_REMNANTS(mass,maxmass)

  !add remnant (WD, NS, BH) masses back into the total mass
  !of the SSP.  These initial-mass-dependent remnant 
  !formulae are taken from Renzini & Ciotti 1993.
  
  USE sps_vars
  USE sps_utils, ONLY : imf, funcint
  IMPLICIT NONE

  REAL(SP), INTENT(inout) :: mass
  !maximum mass still alive
  REAL(SP), INTENT(in) :: maxmass
  REAL(SP) :: minmass, imfnorm

  !---------------------------------------------------------------!
  !---------------------------------------------------------------!

  !normalize the weights
  imf_type = imf_type+10
  imfnorm  = funcint(imf,imf_lower_limit,imf_upper_limit)
  imf_type = imf_type-10

  !BH remnants
  !40<M<imf_up leave behind a 0.5*M BH
  minmass = MAXVAL((/mlim_bh,maxmass/))
  imf_type = imf_type+10
  mass = mass + 0.5*funcint(imf,minmass,imf_upper_limit)/imfnorm
  imf_type = imf_type-10

  !NS remnants
  !8.5<M<40 leave behind 1.4 Msun NS
  IF (maxmass.LE.mlim_bh) THEN
     minmass = MAXVAL((/mlim_ns,maxmass/))
     mass = mass + 1.4*funcint(imf,minmass,mlim_bh)/imfnorm
  ENDIF

  !WD remnants
  !M<8.5 leave behind 0.077*M+0.48 WD
  IF (maxmass.LE.8.5) THEN
     mass = mass + 0.48*funcint(imf,maxmass,mlim_ns)/imfnorm
     imf_type = imf_type+10
     mass = mass + 0.077*funcint(imf,maxmass,mlim_ns)/imfnorm
     imf_type = imf_type-10

  ENDIF

  RETURN

END SUBROUTINE ADD_REMNANTS

SUBROUTINE IMF_WEIGHT(mini,wght,nmass)

  !weight each star by the initial mass function (IMF)
  !such that the total initial population consists of 
  !one solar mass of stars.

  !This weighting scheme assumes that the luminosity, mass, etc.
  !does not vary within the mass bin.  The point is that we
  !want each element to represent the whole bin, from 
  !mass+/-0.5dm, rather than just the values at point i.
  !Then every intergral over mass is just a sum.

  USE sps_vars; USE sps_utils, ONLY : imf, funcint
  IMPLICIT NONE

  REAL(SP), INTENT(inout), DIMENSION(nm) :: wght
  REAL(SP), INTENT(in), DIMENSION(nm)    :: mini
  INTEGER, INTENT(in) :: nmass
  INTEGER  :: i
  REAL(SP) :: m1,m2

  !--------------------------------------------------------!
  !--------------------------------------------------------!

  wght = 0.0

  DO i=1,nmass

     IF (mini(i).LT.imf_lower_limit.OR.&
          mini(i).GT.imf_upper_limit) CYCLE

     IF (i.EQ.1) THEN
        !note that this is not equal to imf_lower_limit
        !only for the Geneva models, which do not extend below 1.0 Msun
        m1 = imf_lower_bound
     ELSE
        m1 = mini(i) - 0.5*(mini(i)-mini(i-1))
     ENDIF
     IF (i.EQ.nmass) THEN
        m2 = mini(i)
     ELSE
        m2 = mini(i) + 0.5*(mini(i+1)-mini(i))
     ENDIF

     IF (m2.LT.m1) THEN
        WRITE(*,*) 'IMF_WEIGHT WARNING: non-monotonic mass!',m1,m2,m2-m1
        CYCLE
     ENDIF

     IF (m2.EQ.m1) CYCLE

     wght(i) = funcint(imf,m1,m2)

  ENDDO

  !normalize the weights as an integral from lower to upper limits
  imf_type = imf_type + 10
  wght = wght / funcint(imf,imf_lower_limit,imf_upper_limit)
  imf_type = imf_type - 10

  RETURN

END SUBROUTINE IMF_WEIGHT

SUBROUTINE GETSPEC(pset,mact,logt,lbol,logg,phase,ffco,lmdot,wght,spec)

  ! Routine to return the spectrum of a star with an input logg,logt
  ! the phase flag determines if the star is a WR, P-AGB, or TP-AGB star
  ! ffco specifies the chemical composition of WR and TP-AGB stars

  ! This subroutine is a major bottleneck.  The spectra must be
  ! recomputed each time the IMF or isochrone parameters change.

  USE sps_vars; USE sps_utils, ONLY: locate
  IMPLICIT NONE

  REAL(SP), INTENT(in) :: mact,logt,lbol,logg,phase,ffco,wght,lmdot
  TYPE(PARAMS), INTENT(in) :: pset
  REAL(SP), INTENT(inout), DIMENSION(nspec) :: spec  
  REAL(SP), DIMENSION(nspec) :: ispec
  REAL(SP) :: t,u,r2,test1,test2,test3,test4,loggi,teffi,rwr,twr
  INTEGER  :: klo,jlo,flag

  !---------------------------------------------------------------!
  !---------------------------------------------------------------!

  spec  = tiny_number
  ispec = tiny_number
  flag  = 0

  !compute radius squared (cm^2) 
  !we need to re-compute logg becuase we modify the logt,logl of AGB stars
  loggi = LOG10( gsig4pi*mact/lbol ) + 4*logt
  r2    = mact*msun*newton/10**loggi

  !post-AGB non-LTE model spectra from Rauch 2003
  !the H-Ni composition spectra are used here.
  !this library has two Zs, Solar and 0.1Solar, simply use one or the other
  IF (phase.EQ.6.0.AND.logt.GE.4.699) THEN
    
     flag = flag+1
     jlo = MIN(MAX(locate(pagb_logt,logt),1),ndim_pagb-1)
     t   = (logt-pagb_logt(jlo)) / &
          (pagb_logt(jlo+1)-pagb_logt(jlo))
     t = MIN(MAX(t,0.0),1.0) !no extrapolation
     klo = 1
     IF (zlegend(pset%zmet)/zsol.GT.0.5) klo=2 
     !the post-agb library is normalized to unity
     spec = lbol*((1-t)*pagb_spec(:,jlo,klo)+t*pagb_spec(:,jlo+1,klo))

  !WR library from Smith et al. 2002 (CMFGEN)
  !NB: there is currently no log(g) dependence in the WR spectra
  ELSE IF (phase.EQ.9.0) THEN
     
     IF (isoc_type.EQ.'mist') THEN
        !below is from Maeder (1990)
        !terminal velocity = 3000 km/s = 3E8 cm/s
        !kappa_es = 0.2*(1+X) cm2/g; assume X=0.73 (Solar)
        rwr = SQRT(r2)+3*0.2*(1+0.73)*ABS(10**lmdot)/8./mypi/3E8/yr2sc*msun
        twr = 10**logt*SQRT(SQRT(r2)/rwr)
        !this is from Smith et al. 2002
        twr = LOG10( 0.6*10**logt + 0.4*twr )
     ELSE
        twr = logt
     ENDIF

     IF (ffco.LT.10) THEN

        !WN spectra
        flag = flag+1
        jlo  = MIN(MAX(locate(wrn_logt,twr),1),ndim_wr-1)
        t    = (twr-wrn_logt(jlo))/(wrn_logt(jlo+1)-wrn_logt(jlo))
        t    = MIN(MAX(t,0.0),1.0) !no extrapolation
        !the WR library is normalized to unity
        spec = lbol*((1-t)*wrn_spec(:,jlo,pset%zmet)+&
             t*wrn_spec(:,jlo+1,pset%zmet))

     ELSE IF (ffco.GE.10) THEN
     
        !WC spectra
        flag = flag+1
        jlo  = MIN(MAX(locate(wrc_logt,twr),1),ndim_wr-1)
        t    = (twr-wrc_logt(jlo))/(wrc_logt(jlo+1)-wrc_logt(jlo))
        t    = MIN(MAX(t,0.0),1.0) !no extrapolation
        !the WR library is normalized to unity
        spec = lbol*((1-t)*wrc_spec(:,jlo,pset%zmet)+&
             t*wrc_spec(:,jlo+1,pset%zmet))

     ENDIF

  !O-rich TP-AGB spectra, from Lancon & Mouhcine 2002
  ELSE IF (phase.EQ.5.0.AND.logt.LT.3.6.AND.ffco.LE.1.0) THEN
     
     flag = flag+1
     jlo  = MAX(MIN(locate(agb_logt_o(pset%zmet,:),logt),n_agb_o-1),1)
     t    = (logt - agb_logt_o(pset%zmet,jlo)) / &
          (agb_logt_o(pset%zmet,jlo+1)-agb_logt_o(pset%zmet,jlo))
     t    = MIN(MAX(t,0.0),1.0) !no extrapolation

     !The spectra are Fdlambda, need to convert to Fdnu and 
     !interpolate in Teff.
     spec = lbol*spec_lambda*spec_lambda/clight * &
          ( (1-t)*agb_spec_o(:,jlo) + t*(agb_spec_o(:,jlo+1)) )

  !C-rich TP-AGB spectra
  ELSE IF (phase.EQ.5.0.AND.logt.LT.3.6.AND.ffco.GT.1.0) THEN
     
     flag = flag+1

     !use Aringer et al. (2009) synthetic spectra
     IF (cstar_aringer.EQ.1) THEN 
        jlo  = MAX(MIN(locate(agb_logt_car,logt),n_agb_car-1),1)
        t    = (logt - agb_logt_car(jlo)) / &
             (agb_logt_car(jlo+1)-agb_logt_car(jlo))
        t    = MIN(MAX(t,0.0),1.0) !no extrapolation
        !The spectra are Fnu/Lbol
        spec = lbol*( (1-t)*agb_spec_car(:,jlo) + t*(agb_spec_car(:,jlo+1)) )

     !use LW02 empirical spectra
     ELSE
        jlo  = MAX(MIN(locate(agb_logt_c,logt),n_agb_c-1),1)
        t    = (logt - agb_logt_c(jlo)) / &
             (agb_logt_c(jlo+1)-agb_logt_c(jlo))
        t    = MIN(MAX(t,0.0),1.0)
        !The spectra are Fdlambda, need to convert to Fdnu and 
        !interpolate in Teff.
        spec = lbol*spec_lambda*spec_lambda/clight * &
             ( (1-t)*agb_spec_c(:,jlo) + t*(agb_spec_c(:,jlo+1)) )
     ENDIF

  !use WMBasic grid from JJ Eldridge for T>25,000K MS stars
  ELSE IF (phase.EQ.0.0.AND.logt.GT.wmb_logt(1)) THEN

     flag = flag+1

     jlo = MIN(MAX(locate(wmb_logt,logt),1),ndim_wmb_logt-1)
     klo = MIN(MAX(locate(wmb_logg,loggi),1),ndim_wmb_logg-1)
     t   = (logt-wmb_logt(jlo)) / (wmb_logt(jlo+1)-wmb_logt(jlo))
     t   = MIN(MAX(t,0.0),1.0) !no extrapolation (this means >50K -> 50K)
     u   = (loggi-wmb_logg(klo))  / (wmb_logg(klo+1)-wmb_logg(klo))
     u   = MIN(MAX(u,0.0),1.0) !no extrapolation in logg

     spec = (1-t)*(1-u)*wmb_spec(:,pset%zmet,jlo,klo) + &
          t*(1-u)*wmb_spec(:,pset%zmet,jlo+1,klo) + &
          t*u*wmb_spec(:,pset%zmet,jlo+1,klo+1) + &
          (1-t)*u*wmb_spec(:,pset%zmet,jlo,klo+1)
     !the WMBasic library is normalized to unity
     spec = spec*lbol

  !use the primary library for the rest of the isochrone
  ELSE

     flag = flag+1

     !find the subgrid containing point i 
     jlo = MIN(MAX(locate(speclib_logt,logt),1),ndim_logt-1)
     klo = MIN(MAX(locate(speclib_logg,loggi),1),ndim_logg-1)
     t   = (logt-speclib_logt(jlo))/(speclib_logt(jlo+1)-speclib_logt(jlo))
     t   = MIN(MAX(t,0.0),1.0) !no extrapolation
     u   = (loggi-speclib_logg(klo))/(speclib_logg(klo+1)-speclib_logg(klo))
     u   = MIN(MAX(u,0.0),1.0) !no extrapolation

     test1 = speclib(whlam5000,pset%zmet,jlo,klo)
     test2 = speclib(whlam5000,pset%zmet,jlo+1,klo)
     test3 = speclib(whlam5000,pset%zmet,jlo,klo+1)
     test4 = speclib(whlam5000,pset%zmet,jlo+1,klo+1)
     
     !if all four components are zero, set the flag to zero
     IF ((test1.LE.tiny30.AND.test2.LE.tiny30.AND.&
          test3.LE.tiny30.AND.test4.LE.tiny30)) flag=0

     !catch stars that fall off part of the grid
     !the flux at 5000A should never be zero unless a spec is missing
     IF ((test1.LE.tiny30.OR.test2.LE.tiny30.OR.&
          test3.LE.tiny30.OR.test4.LE.tiny30).AND.flag.EQ.1) THEN

        IF (verbose.EQ.99) & 
             WRITE(*,'(" GETSPEC WARNING: Part of the '//&
             'point is off the grid: Z=",I2,'//&
             '" logT=",F5.2," logg=",F5.2," phase=",I2," lg IMF*L=",F5.2)') &
             pset%zmet,logt,loggi,INT(phase),LOG10(wght*lbol)

        !this is a very crude hack.  just pick one of the spectra
        IF (test1.GT.tiny30) ispec = speclib(:,pset%zmet,jlo,klo)
        IF (test2.GT.tiny30) ispec = speclib(:,pset%zmet,jlo+1,klo)
        IF (test3.GT.tiny30) ispec = speclib(:,pset%zmet,jlo,klo+1)
        IF (test4.GT.tiny30) ispec = speclib(:,pset%zmet,jlo+1,klo+1)

     ELSE

        !bilinear interpolation
        ispec = (1-t)*(1-u)*speclib(:,pset%zmet,jlo,klo) + &
             t*(1-u)*speclib(:,pset%zmet,jlo+1,klo) + &
             t*u*speclib(:,pset%zmet,jlo+1,klo+1) + &
             (1-t)*u*speclib(:,pset%zmet,jlo,klo+1)

     ENDIF

     !at long last the extra factor of 4pi (below) has been found!
     !see p244-245 of Collins' "Fundamentals of Stellar Astrophysics"
     spec = 4*mypi*4*mypi*r2/lsun * ispec

  ENDIF
 
  !make sure the spectrum never has any zeros or negative numbers
  spec = MAX(spec,tiny_number)
  
  IF (verbose.EQ.1) THEN
     !IF (flag.EQ.0.AND.(spec_type.EQ.'basel'.OR.spec_type.EQ.'ckc14').AND.&
     !     phase.NE.6.AND.phase.NE.9) THEN
     IF (flag.EQ.0..AND.wght.GT.0.0) THEN
        WRITE(*,'(" GETSPEC WARNING: point entirely off the grid: Z=",I2,'//&
             '" logT=",F5.2," logg=",F5.2," phase=",I2," lg IMF*L=",F5.2)') &
            pset%zmet,logt,loggi,INT(phase),LOG10(wght*lbol)
     ENDIF
  ENDIF

  IF (flag.GT.1) THEN
     WRITE(*,'(" GETSPEC ERROR: isochrone point assigned *two* spectra!")') 
  ENDIF

  !add circumstellar dust around AGB stars
  IF ((phase.EQ.4.OR.phase.EQ.5) &
       .AND.add_agb_dust_model.EQ.1.AND.pset%agb_dust.GT.tiny_number) THEN
     CALL ADD_AGB_DUST(pset%agb_dust,spec,mact,&
          logt,LOG10(lbol),logg,zlegend(pset%zmet),ffco,lmdot)
  ENDIF


  !pure blackbody; no longer used but kept here for posterity
  !teffi = 10**logt
  !spec = 15/mypi*lbol/clight*&
  !     (hck/teffi)*(hck/teffi)*(hck/teffi)*(hck/teffi) / &
  !     (spec_lambda*spec_lambda*spec_lambda)/ ( &
  !     EXP(hck/spec_lambda/teffi)-1 )

  
END SUBROUTINE GETSPEC

SUBROUTINE COMPSP(write_compsp, nzin, outfile,&
                  mass_ssp, lbol_ssp, tspec_ssp,&
                  pset, ocompsp)
  !
  !
  !N.B. variables not otherwise defined come from sps_vars.f90
  use sps_vars
  use sps_utils, only: write_isochrone, add_nebular, setup_tabular_sfh, &
                       csp_gen, sfhinfo, linterp, agn_dust, &
                       smoothspec, igm_absorb, getindx, getmags
                       
  implicit none

  INTEGER, INTENT(in) :: write_compsp,nzin
  CHARACTER(100), INTENT(in) :: outfile
  REAL(SP), INTENT(in), DIMENSION(ntfull, nzin) :: lbol_ssp,mass_ssp
  REAL(SP), INTENT(in), DIMENSION(nspec, ntfull, nzin) :: tspec_ssp
  TYPE(PARAMS), intent(in) :: pset

  TYPE(COMPSPOUT), INTENT(inout), DIMENSION(ntfull) :: ocompsp

  REAL(SP), DIMENSION(nspec, ntfull, nzin)   :: spec_ssp
  REAL(SP), DIMENSION(nemline, ntfull, nzin) :: emlin_ssp
  REAL(SP), DIMENSION(nemline) :: emlin_csp
  REAL(SP), dimension(ntfull) :: mdust_ssp
  REAL(SP) :: lbol_csp, mass_csp, mdust_csp
  REAL(SP) :: age, mdust, mass_frac, tsfr, zred, frac_linear, maxtime
  REAL(SP), DIMENSION(nspec) :: csp1, csp2, spec_dusty, spec_csp
  REAL(SP), DIMENSION(nbands)  :: mags
  REAL(SP), DIMENSION(nindx)   :: indx
  INTEGER :: i, nage

  ! ------ Various checks and setup ------

  IF (check_sps_setup.EQ.0) THEN
     WRITE(*,*) 'COMPSP ERROR: '//&
          'SPS_SETUP must be run before calling COMPSP. '
     STOP
  ENDIF

  IF ((nzin.GT.1).and.(pset%sfh.ne.2).and.(pset%sfh.ne.3)) THEN
     WRITE(*,*) 'COMPSP ERROR: '//&
          'nzin > 1 no longer supported for non-tabular SFH.'
     STOP
  ENDIF

  call setup_tabular_sfh(pset, nzin)

  ! Make sure various variables are set correctly
  IF (pset%tage.GT.tiny_number) THEN
     maxtime = pset%tage * 1e9
  else
     maxtime = 10**time_full(ntfull)
  endif
  
  CALL COMPSP_WARNING(maxtime, pset, nzin, write_compsp)

  ! Setup output files
  if ((pset%tage.gt.0).or.&
      ((pset%tage.eq.-99).and.((pset%sfh.eq.2).or.(pset%sfh.eq.3)))) then
     nage = 1
  else
     nage = ntfull
  endif
  IF (write_compsp.GT.0) &
       CALL COMPSP_SETUP_OUTPUT(write_compsp, pset, outfile, 1, nage)

  ! Isochrone case just writes the CMDs and exits
  IF (write_compsp.EQ.5) THEN
     CALL WRITE_ISOCHRONE(outfile, pset)
     RETURN
  ENDIF

  ! ------ Prepare SSPs ------
  ! Only doing nebular emission at the moment, dust is added in csp_gen.
  ! We should probably only do this for ages up to tage, if it is set.
  ! Also we will operate on copies of the spectra

  spec_ssp = tspec_ssp

  ! Add nebular emission
  if (add_neb_emission.EQ.1) then
     if (nzin.GT.1) then
        WRITE(*,*) 'COMPSP ERROR: cannot handle both nebular '//&
             'emission and mult-metallicity SSPs in compsp'
        STOP
     endif
     call add_nebular(pset, tspec_ssp(:,:,1), spec_ssp(:,:,1), emlin_ssp(:,:,1))
  else
     emlin_ssp = 0.
  endif


  ! --- Get CSP spectra -------
  
  ! Loop over output ages.
  do i=1,ntfull
     ! ------
     ! First decide what mode we are in.
     if (pset%tage.gt.0) then
        ! A specific age was asked for, so we will only compute one spectrum at
        ! that age.
        age = pset%tage
     else if ((pset%tage.eq.-99).and.((pset%sfh.eq.2).or.(pset%sfh.eq.3))) then
        ! Special switch to just do the last time in the tabular file
        age = maxval(sfh_tab(1, 1:ntabsfh)) / 1E9
     else
        ! Otherwise we will calculate composite spectra for every SSP age.
        age = 10**(time_full(i)-9.)
     endif

     ! -----
     ! Get the spectrum for this age.  Note this is always normalized to one
     ! solar mass formed, so we actually need to renormalize if computing all
     ! ages, which is done using info from `sfhinfo`
     call csp_gen(mass_ssp, lbol_ssp, spec_ssp, &
          pset, age, nzin, mass_csp, lbol_csp, spec_csp,&
          mdust_csp,emlin_ssp,emlin_csp)
     
     call sfhinfo(pset, age, mass_frac, tsfr, frac_linear)
     if (pset%tage.le.0) then   
        mass_csp  = mass_csp * mass_frac
        lbol_csp  = log10(10**lbol_csp * mass_frac)
        spec_csp  = spec_csp * mass_frac
        mdust_csp = mdust_csp * mass_frac
        emlin_csp = emlin_csp * mass_frac
     else
        ! Renormalize the SFR to be appropriate for one solar mass formed.
        tsfr = tsfr / mass_frac
        mass_frac = 1.0
     endif

     ! -------
     ! Now do a bunch of stuff with the spectrum
     ! Smooth the spectrum
     if (pset%sigma_smooth.GT.0.0) then
        call smoothspec(spec_lambda, spec_csp, pset%sigma_smooth,&
                        pset%min_wave_smooth, pset%max_wave_smooth)
     endif
     ! Add IGM absorption
     if (add_igm_absorption.EQ.1.AND.pset%zred.GT.tiny_number) then
        spec_csp = igm_absorb(spec_lambda,spec_csp, pset%zred,&
                              pset%igm_factor)
     endif
     !add AGN dust
     IF (add_agn_dust.EQ.1.AND.pset%fagn.GT.tiny_number) THEN
        spec_csp = agn_dust(spec_lambda, spec_csp, pset, lbol_csp)
     ENDIF
     ! Compute spectral indices
     if (write_compsp.EQ.4) then
        call getindx(spec_lambda, spec_csp, indx)
     else
        indx = 0.0
     endif
     ! Compute mags
     if (redshift_colors.EQ.0) then
        call getmags(pset%zred, spec_csp, mags, pset%mag_compute)
     else
        ! here we compute the redshift at the corresponding age
        zred = min(max(linterp(cosmospl(:,2), cosmospl(:,1), age),&
                       0.0), 20.0)
        write(33,*) zred
        call getmags(zred, spec_csp, mags, pset%mag_compute)
     endif

     ! ---------
     ! Store the spectrum and write....
     call save_compsp(write_compsp, ocompsp(i), log10(age)+9,&
          mass_csp, lbol_csp, tsfr, mags, spec_csp, mdust_csp, mass_frac,&
          indx,emlin_csp)

     ! Terminate the loop if a single specific tage was requested
     if (nage.eq.1) then
        exit
     endif

  enddo

  if (write_compsp.EQ.1.OR.write_compsp.EQ.3) CLOSE(10)
  if (write_compsp.EQ.2.OR.write_compsp.EQ.3) CLOSE(20)

end subroutine compsp

SUBROUTINE COMPSP_WARNING(maxtime,pset,nzin,write_compsp)

  !check that variables are properly set

  USE sps_vars
  IMPLICIT NONE
  INTEGER, INTENT(in) :: nzin, write_compsp
  REAL(SP), INTENT(in) :: maxtime
  TYPE(PARAMS), INTENT(in) :: pset

  !-----------------------------------------------------!

  IF (maxtime.LE.0.AND.pset%sfh.NE.0) THEN
     WRITE(*,*) 'COMPSP ERROR, maxtime too small:',maxtime
     STOP
  ENDIF

  !the isochrones don't go past 10**10.15 yrs, so warn the user
  !that this will be an extrapolation
  IF (maxtime.GT.10**10.2.AND.isoc_type.NE.'mist') THEN
     WRITE(*,*) 'COMPSP WARNING: log(Tmax)>10.2 yrs -'//&
          ' linear extrapolation beyond this point for log(Tmax)=:',&
          LOG10(maxtime)
  ENDIF
  IF (maxtime.GT.10**10.35.AND.isoc_type.EQ.'mist') THEN
     WRITE(*,*) 'COMPSP WARNING: log(Tmax)>10.35 yrs -'//&
          ' linear extrapolation beyond this point for log(Tmax)=:',&
          LOG10(maxtime)
  ENDIF

  !warn the user about an out-of-bounds burst component
  IF (pset%tburst*1E9.GT.maxtime.AND.pset%fburst.GT.tiny_number.AND.&
       (pset%sfh.EQ.1.OR.pset%sfh.EQ.4)) THEN
     WRITE(*,*) 'COMPSP WARNING: burst time > age of system....'//&
          ' the burst component will NOT be added.'
  ENDIF

  IF (pset%sf_start.LT.0.0) THEN
     WRITE(*,*) 'COMPSP ERROR: sf_start<0.  stopping...'
     STOP
  ENDIF

  IF (pset%sf_start*1E9.GT.maxtime) THEN
     WRITE(*,*) 'COMPSP ERROR: sf_start>maxtime  stopping...'
     STOP
  ENDIF

  IF ((pset%sf_trunc.LT.pset%sf_start).AND.(pset%sf_trunc.GT.tiny_number)) THEN
     WRITE(*,*) 'COMPSP WARNING: sf_trunc<sf_start....'//&
          ' sf_trunc will be ignored.'
  ENDIF

  
  !set limits on the parameters tau and const
  IF (pset%sfh.EQ.1.OR.pset%sfh.EQ.4) THEN
     IF (pset%tau.LE.0.1.AND.pset%tau.GE.0.0) THEN
        IF (verbose.EQ.1) THEN
           WRITE(*,*) 'COMPSP WARNING: tau <0.1, setting tau=0.1'
        ENDIF
     ELSE IF (pset%tau.GE.1E2) THEN
        IF (verbose.EQ.1) THEN
           WRITE(*,*) 'COMPSP WARNING: tau >1E2, setting tau=1E2'
        ENDIF
     ENDIF

     IF (pset%const.GT.1.0.OR.pset%const.LT.0.0) THEN
        WRITE(*,*) 'COMPSP ERROR: const out of bounds:',pset%const
        STOP
     ENDIF

     IF ((pset%const + pset%fburst).GT.1.0) THEN
        WRITE(*,*) 'COMPSP ERROR: const + fburst > 1', pset%const + pset%fburst
        STOP
     ENDIF
  ENDIF

  IF (pset%dust_tesc.LE.5.5) THEN
     WRITE(*,*) 'COMPSP ERROR: pset%dust_tesc<=5.5, you need to set'//&
          ' dust_tesc to a value >5.5; currently it is: ',pset%dust_tesc
     STOP
  ENDIF

  IF (pset%duste_qpah.LT.0.0) THEN
     WRITE(*,*) 'COMPSP WARNING: pset%duste_qpah<0.0, '//&
          'the allowable range is 0-5 and will be set to 0.0'
  ENDIF

  IF (pset%duste_gamma.LT.0.0) THEN
     WRITE(*,*) 'COMPSP WARNING: pset%duste_gamma<0.0, '//&
          'the allowable range is >0, and will be set to 0.0'
  ENDIF
  IF ((pset%sfh.EQ.0.OR.pset%sfh.EQ.1.OR.pset%sfh.EQ.4).AND.nzin.NE.1) THEN
     WRITE(*,*) 'COMPSP_ERROR: sfh=0,1,or,4 but nzin NE 1'
     STOP
  ENDIF

  IF ((pset%sfh.EQ.2.OR.pset%sfh.EQ.3).AND.(nzin.NE.nz.AND.nzin.NE.1)) THEN
     WRITE(*,*) 'COMPSP_ERROR: sfh=2 or 3 but nzin NE (nz OR 1)'
     STOP
  ENDIF

  IF (nzin.NE.1.AND.nzin.NE.nz) THEN
     WRITE(*,*) 'COMPSP_ERROR: nzin NE 1 and nzin NE nz:',nz
     STOP
  ENDIF

  IF (write_compsp.NE.0.AND.write_compsp.NE.1 &
       .AND.write_compsp.NE.2.AND.write_compsp.NE.3 &
       .AND.write_compsp.NE.4.AND.write_compsp.NE.5) THEN
     WRITE(*,*) 'COMPSP ERROR: invalid write_compsp value:', &
          write_compsp
     STOP
  ENDIF

  if ((pset%dust1.gt.tiny_number).and.(compute_light_ages.eq.1)) then
     WRITE(*,*) 'COMPSP WARNING: compute_light_ages does not take into'//&
          ' account age-dependent dust (dust1 > 0)'
  ENDIF
     

END SUBROUTINE COMPSP_WARNING

!------------------------------------------------------------!
!------------------------------------------------------------!

SUBROUTINE COMPSP_SETUP_OUTPUT(write_compsp,pset,outfile,imin,imax)

  USE sps_vars
  USE sps_utils, ONLY : vactoair
  IMPLICIT NONE
  INTEGER, INTENT(in) :: imin,imax,write_compsp
  REAL(SP) :: writeage
  TYPE(PARAMS), INTENT(in) :: pset
  CHARACTER(100), INTENT(in) :: outfile

  !-----------------------------------------------------!

  !open output file for magnitudes
  IF (write_compsp.EQ.1.OR.write_compsp.EQ.3) THEN
     OPEN(10,FILE=TRIM(SPS_HOME)//'/OUTPUTS/'//TRIM(outfile)//'.mags',&
          STATUS='REPLACE')
     CALL COMPSP_HEADER(10,pset)
  ENDIF
  
  !open output file for spectra
  IF (write_compsp.EQ.2.OR.write_compsp.EQ.3) THEN
     OPEN(20,FILE=TRIM(SPS_HOME)//'/OUTPUTS/'//TRIM(outfile)//'.spec',&
          STATUS='REPLACE')
     CALL COMPSP_HEADER(20,pset)
  ENDIF

  !open output file for indices
  IF (write_compsp.EQ.4) THEN
     OPEN(30,FILE=TRIM(SPS_HOME)//'/OUTPUTS/'//TRIM(outfile)//'.indx',&
          STATUS='REPLACE')
     CALL COMPSP_HEADER(30,pset)
  ENDIF

  IF (pset%sfh.EQ.0) THEN
     IF (verbose.NE.0) WRITE(*,*) '  Processing SSP'
     IF (write_compsp.EQ.1.OR.write_compsp.EQ.3) THEN
        WRITE(10,'("#   Processing SSP")')
        WRITE(10,'("#")') 
        WRITE(10,32) 
     ENDIF
     IF (write_compsp.EQ.2.OR.write_compsp.EQ.3) THEN
        WRITE(20,'("#   Processing SSP")')
        WRITE(20,'("#")') 
        WRITE(20,31) 
        IF (imax-imin.EQ.1) WRITE(20,'(I3,1x,I6)') 1,nspec
        IF (imax-imin.GT.1) WRITE(20,'(I3,1x,I6)') ntfull,nspec
        IF (vactoair_flag.EQ.0) THEN
           WRITE(20,'(50000(F15.4))') spec_lambda
        ELSE
           WRITE(20,'(50000(F15.4))') vactoair(spec_lambda)
        ENDIF
     ENDIF
     IF (write_compsp.EQ.4) THEN
        WRITE(30,'("#   Processing SSP")')
        WRITE(30,'("#")') 
        WRITE(30,34) 
     ENDIF
  ELSE
     IF (pset%sfh.EQ.2.OR.pset%sfh.EQ.3) THEN
        IF (verbose.EQ.1) &
             WRITE(*,30) pset%dust1,pset%dust2
        IF (write_compsp.EQ.1.OR.write_compsp.EQ.3) &
             WRITE(10,30) pset%dust1,pset%dust2
        IF (write_compsp.EQ.2.OR.write_compsp.EQ.3) &
             WRITE(20,30) pset%dust1,pset%dust2
     ELSE
        IF (pset%tage.GT.tiny_number) writeage = pset%tage
        IF (pset%tage.LE.tiny_number) writeage = 10**time_full(ntfull)/1E9
        IF (verbose.EQ.1) &
             WRITE(*,33) writeage,LOG10(pset%tau),pset%const,pset%fburst,&
             pset%tburst,pset%sf_start,pset%dust1,pset%dust2
        IF (write_compsp.EQ.1.OR.write_compsp.EQ.3) &
             WRITE(10,33) writeage,LOG10(pset%tau),pset%const,pset%fburst,&
             pset%tburst,pset%sf_start,pset%dust1,pset%dust2
        IF (write_compsp.EQ.2.OR.write_compsp.EQ.3) &
             WRITE(20,33) writeage,LOG10(pset%tau),pset%const,pset%fburst,&
             pset%tburst,pset%sf_start,pset%dust1,pset%dust2
        IF (write_compsp.EQ.4) &
             WRITE(30,33) writeage,LOG10(pset%tau),pset%const,pset%fburst,&
             pset%tburst,pset%sf_start,pset%dust1,pset%dust2
     ENDIF
     IF (write_compsp.EQ.1.OR.write_compsp.EQ.3) THEN 
        WRITE(10,'("#")') 
        WRITE(10,32) 
     ENDIF
     IF (write_compsp.EQ.2.OR.write_compsp.EQ.3) THEN
        WRITE(20,'("#")') 
        WRITE(20,31) 
        IF (imax-imin.EQ.1) WRITE(20,'(I3,1x,I6)') 1,nspec
        IF (imax-imin.GT.1) WRITE(20,'(I3,1x,I6)') ntfull,nspec
        IF (vactoair_flag.EQ.0) THEN
           WRITE(20,'(50000(F15.4))') spec_lambda
        ELSE
           WRITE(20,'(50000(F15.4))') vactoair(spec_lambda)
        ENDIF
       ENDIF
       IF (write_compsp.EQ.4) THEN
          WRITE(20,'("#")') 
          WRITE(20,34) 
       ENDIF
   ENDIF

   !formats
30 FORMAT('#   SFH: tabulated input, dust=(',F6.2,','F6.2,')')
31 FORMAT('#   log(age) log(mass) Log(lbol) log(SFR) spectra')
32 FORMAT('#   log(age) log(mass) Log(lbol) log(SFR) mags (see FILTER_LIST)')
33 FORMAT('#   SFH: Tage=',F6.2,' Gyr, log(tau/Gyr)= ',F6.3,&
        ', const= ',F6.3,', fb= ',F6.3,', tb= ',F6.2,&
        ' Gyr, sf_start= 'F6.3,', dust=(',F6.2,','F6.2,')')
34 FORMAT('#   log(age) indices (see allindices.dat)')


END SUBROUTINE COMPSP_SETUP_OUTPUT

!------------------------------------------------------------!
!------------------------------------------------------------!

SUBROUTINE COMPSP_HEADER(unit,pset)

  !writes headers for the .mag, .spec, .indx files

  USE sps_vars
  IMPLICIT NONE
  INTEGER, INTENT(in) :: unit
  TYPE(PARAMS), INTENT(in) :: pset

  !-----------------------------------------------------!

  IF (pset%sfh.NE.2) THEN
     WRITE(unit,'("#   Log(Z/Zsol): ",F6.3)') &
          LOG10(zlegend(pset%zmet)/zsol)
  ELSE
     WRITE(unit,'("#   Log(Z/Zsol): tabulated")')
  ENDIF
  WRITE(unit,'("#   Fraction of blue HB stars: ",F6.3,'//&
       '"; Ratio of BS to HB stars: ",F6.3)') pset%fbhb, pset%sbss
  WRITE(unit,'("#   Shift to TP-AGB [log(Teff),log(Lbol)]: ",F5.2,1x,F5.2)') &
       pset%delt, pset%dell
  IF (imf_type.EQ.2) THEN
     WRITE(unit,'("#   IMF: ",I1,", slopes= ",3F4.1)') &
          imf_type,pset%imf1,pset%imf2,pset%imf3
  ELSE IF (imf_type.EQ.3) THEN
     WRITE(unit,'("#   IMF: ",I1,", cut-off= ",F4.2)') imf_type,pset%vdmc
  ELSE
     WRITE(unit,'("#   IMF: ",I1)') imf_type
  ENDIF
  IF (compute_vega_mags.EQ.1) THEN
     WRITE(unit,'("#   Mag Zero Point: Vega (not relevant for spec/indx files)")')
  ELSE
     WRITE(unit,'("#   Mag Zero Point: AB (not relevant for spec/indx files)")')
  ENDIF

END SUBROUTINE COMPSP_HEADER

!------------------------------------------------------------!
!------------------------------------------------------------!

SUBROUTINE SAVE_COMPSP(write_compsp,cspo,time,mass,&
     lbol,sfr,mags,spec,mdust,mformed,indx,emlines)

  !routine to print and save outputs

  USE sps_vars
  IMPLICIT NONE
  INTEGER, INTENT(in) :: write_compsp
  REAL(SP), INTENT(in)    :: time,mass,lbol,sfr,mdust,mformed
  REAL(SP), DIMENSION(nspec), INTENT(in)    :: spec
  REAL(SP), DIMENSION(nbands), INTENT(in)   :: mags
  REAL(SP), DIMENSION(nindx), INTENT(in)    :: indx
  REAL(SP), DIMENSION(nemline), INTENT(in)  :: emlines
  TYPE(COMPSPOUT), INTENT(inout) :: cspo
  CHARACTER(34) :: fmt

  !-----------------------------------------------------!

  fmt = '(F7.4,1x,3(F8.4,1x),000(F7.3,1x))'
  WRITE(fmt(21:23),'(I3,1x,I4)') nbands

  !dump info into output structure
  cspo%age      = time
  cspo%mass_csp = mass
  cspo%lbol_csp = lbol
  cspo%sfr      = sfr
  cspo%mags     = mags
  cspo%spec     = MAX(spec,tiny_number)
  cspo%mdust    = mdust
  cspo%mformed  = mformed
  cspo%indx     = indx
  cspo%emlines  = emlines

  !write to mags file
  IF (write_compsp.EQ.1.OR.write_compsp.EQ.3) &
       WRITE(10,fmt) time,LOG10(mass+tiny_number),&
       lbol,LOG10(sfr+tiny_number),mags
 
  !write to spectra file
  IF (write_compsp.EQ.2.OR.write_compsp.EQ.3) THEN
     WRITE(20,'(4(F8.4,1x))') time,&
          LOG10(mass+tiny_number),lbol,LOG10(sfr+tiny_number)
     WRITE(20,'(50000(E14.6))') MAX(spec,tiny_number)
  ENDIF

  !write to indx file
  IF (write_compsp.EQ.4) &
       WRITE(30,'(F8.4,99(F7.3,1x))') time,indx
  
END SUBROUTINE SAVE_COMPSP

FUNCTION IGM_ABSORB(lam,spec,zz,factor)

  !routine to include IGM absorption via Madau (1995)
  !this routine includes a fudge factor (accessed by pset%igm_factor)
  !that allows the user to scale the IGM optical depth

  USE sps_vars; USE sps_utils, ONLY : locate
  IMPLICIT NONE

  REAL(SP), DIMENSION(nspec), INTENT(in) :: lam,spec
  REAL(SP), DIMENSION(nspec) :: igm_absorb,lobs,xc,tau
  REAL(SP), INTENT(in) :: zz,factor
  REAL(SP) :: z1,lylim,a_metal
  INTEGER, PARAMETER  :: nly=17
  INTEGER :: vv,i
  REAL(SP), DIMENSION(nly) :: lyw,lycoeff

  !--------------------------------------------------------------!

  lyw = (/1215.67, 1025.72, 972.537, 949.743, 937.803,&
          930.748, 926.226, 923.150, 920.963, 919.352,&
          918.129, 917.181, 916.429, 915.824, 915.329,&
          914.919, 914.576/)

  lycoeff = (/0.0036,0.0017,0.0011846,0.0009410,0.0007960,&
       0.0006967,0.0006236,0.0005665,0.0005200,0.0004817,&
       0.0004487,0.0004200,0.0003947,0.000372,0.000352,&
       0.0003334,0.00031644/)

  lylim   = 911.75
  a_metal = 0.0017

  z1   = 1+zz
  lobs = lam*z1
  xc   = lobs/lylim

  tau = 0.0

  !Ly series line blanketing
  DO i=1,nly
     IF (lam(1).GT.lyw(i)) CONTINUE
     vv = MIN(MAX(locate(lam,lyw(i)),1),nspec)
     tau(1:vv) = tau(1:vv) + lycoeff(i) * &
          (lobs(1:vv)/lyw(i))**3.46
     !add metal blanketing (this has ~no effect)
     IF (i.EQ.1) THEN 
        tau(1:vv) = tau(1:vv)+a_metal*(lobs(1:vv)/lyw(i))**1.68
     ENDIF
  ENDDO

  !LyC absorption
  IF (lam(1).LT.lylim) THEN
     vv = MIN(MAX(locate(lam,lylim),1),nspec)
     !approximation to Eqn 16 in Madau (1995); see his footnote 3
     tau(1:vv) = tau(1:vv) + &
          (0.25*xc(1:vv)**3*(z1**0.46-xc(1:vv)**0.46)) + &
          (9.4*xc(1:vv)**1.5*(z1**0.18-xc(1:vv)**0.18)) - &
          (0.7*xc(1:vv)**3*(xc(1:vv)**(-1.32)-z1**(-1.32))) - &
          (0.023*(z1**1.68-xc(1:vv)**1.68))
  ENDIF

  !the LyC fitting function seems to fall apart at really short 
  !wavelengths, so when tau starts to decrease, cap it at the max.
  vv = MAXLOC(tau,1)
  tau(1:vv) = tau(vv)

  !attenuate the input spectrum by the IGM
  !include a fudge factor to dial up/down the strength
  igm_absorb = spec * EXP(-tau*factor)


END FUNCTION IGM_ABSORB

subroutine csp_gen(mass_ssp, lbol_ssp, spec_ssp, &
     pset, tage, nzin, mass_csp, lbol_csp, spec_csp, &
     mdust_csp,emlin_ssp,emlin_csp)
  !
  ! Return the spectrum (and mass and lbol) of a composite stellar population.
  !
  ! Inputs
  ! ---------
  !
  ! mass_ssp, lbol_ssp, spec_ssp:
  !   The (surviving) stellar masses, bolometric luminosities, and spectra of
  !   the SSPs.
  !
  ! pset:
  !   A `PARAMS` structure containing the SFH parameters
  !
  ! tage:
  !   The age (in Gyr of forward time) at which the spectrum is desired.  Note
  !   that this can be different than pset%tage if the latter is 0.
  !
  ! Outputs
  ! ---------
  !
  ! mass_csp, lbol_csp, spec_csp:
  !   The (surviving) stellar masses, bolometric luminosity, and spectrum of
  !   the composite stellar population at tage, normalized to 1 M_sun *formed*.
  
  use sps_vars, only: ntfull, nspec, time_full, tiny_number, tiny_logt, &
                      zlegend, nz, sfh_tab, ntabsfh, compute_light_ages, &
                      SFHPARAMS, PARAMS, SP, nemline, dust_type
  use sps_utils, only: locate, sfh_weight, sfhinfo, add_dust
  implicit none

  real(SP), intent(in), dimension(ntfull, nzin) :: mass_ssp, lbol_ssp
  real(SP), intent(in), dimension(nspec, ntfull, nzin) :: spec_ssp
  type(PARAMS), intent(in) :: pset
  real(SP), intent(in) :: tage
  integer, intent(in) :: nzin
  
  real(SP), intent(out) :: mass_csp, lbol_csp, mdust_csp
  real(SP), intent(out), dimension(nspec) :: spec_csp

  real(SP), DIMENSION(nemline, ntfull, nzin), intent(in) :: emlin_ssp
  real(SP), DIMENSION(nemline), intent(out) :: emlin_csp

  real(SP), dimension(nspec) :: csp1, csp2, lw_age
  real(SP), dimension(nemline) :: ncsp1, ncsp2, nlw_age
  real(SP), dimension(ntfull, nzin) :: total_weights
  real(SP), dimension(ntfull) :: w1=0., w2=0.
  integer :: i, j, k, imin, imax, i_tesc
  type(SFHPARAMS) :: sfhpars
  real(SP) :: m1, m2, frac_linear, mfrac, sfr, fburst
  real(SP) :: t1, t2, dt, zbin, dz  ! for tabular calculations
  real(SP) :: lbol_age, mass_age ! for mass and lbol weighted ages

  ! ------- Setup ----------

  ! Build a structure containing useful units, numbers, and switches for the
  ! weight calculations. The units of the parameters in the `sfhparams`
  ! structure are years of lookback time.
  call convert_sfhparams(pset, tage, sfhpars)
  ! Only calculate SFH weights for SSPs up to tage
  ! (plus the next couple, to bracket and be safe).
  imin = 0
  imax = min(max(locate(time_full, log10(sfhpars%tage)) + 2, 1), ntfull)

  ! ----- Get SFH weights -----

  total_weights = 0.

  ! SSP.
  if (pset%sfh.eq.0) then
     ! Make sure to use SSP weighting scheme
     sfhpars%type = -1
     ! Use tage as the burst lookback time, instead of tage-tburst.
     sfhpars%tb = sfhpars%tage
     ! Only need weights at two SSP points. Though in practice this doesn't
     ! matter, as the appropriate ages are located within sfh_weight.
     ! But it speeds up the matrix multiply later
     imin = max(imax - 2, 1)
     ! These come pre-normalized to 1 Msun
     total_weights(:, 1) = sfh_weight(sfhpars, imin, imax)
  endif


  ! Tau and delayed-tau.
  if ((pset%sfh.eq.1).or.(pset%sfh.eq.4)) then
     imin = 0
     sfhpars%type = pset%sfh
     total_weights(:, 1) = sfh_weight(sfhpars, imin, imax)
     ! Could save some loops by having proper normalization analytically from sfh_weight
     m1 = sum(total_weights(1:imax, 1))
     if (m1.lt.tiny_number) m1 = 1.0
     total_weights(:, 1) = total_weights(:, 1) / m1
  endif

  
  ! Add constant and burst weights for SFH=1,4
  if (((pset%sfh.eq.1).or.(pset%sfh.eq.4)).and.&
       ((pset%const.gt.0).or.(pset%fburst.gt.tiny_number))) then
     imin = 0
     ! Constant
     sfhpars%type = 0
     w1 = sfh_weight(sfhpars, imin, imax)
     m1 = sum(w1(1:imax))
     ! Burst.  These weights come pre-normalized to 1 Msun.
     ! If burst happens after age of system then we kill it entirely.
     sfhpars%type = -1
     if (sfhpars%tb.lt.0) then
        w2 = 0.
        fburst = 0.
     else
        w2 = sfh_weight(sfhpars, imin, imax)
        fburst = pset%fburst
        ! We'll need to add any early bursts when summing later
        imax = max(imax, min(max(locate(time_full, log10(sfhpars%tb)) + 2, 1), ntfull))
     endif
     ! Sum with proper relative normalization.  Beware divide by zero.
     if (m1.lt.tiny_number) m1 = 1.0
     total_weights(:,1) = (1 - pset%const - fburst) * total_weights(:,1) + &
                          pset%const * (w1 / m1) + &
                          fburst * w2
  endif

  
  ! Simha
  if (pset%sfh.eq.5) then
     imin = 0
     ! Delayed-tau model portion, could set imin here to be just before
     ! sfhpars%tq, for small speed increase.
     ! imin = min(max(locate(time_full, log10(sfhpars%tq)), 0), ntfull-1)
     sfhpars%type = 4
     w1 = sfh_weight(sfhpars, imin, imax)
     m1 = sum(w1(1:imax))
     ! Linear portion.  Need to set `use_simha_limits` flag to get correct
     ! integration limits. Could set imax here to be just after sfhpars%tq,
     ! but with imin=0, for small speed increase.
     ! imax = imin + 1
     ! imin = 0
     sfhpars%type = 5
     sfhpars%use_simha_limits = 1
     w2 = sfh_weight(sfhpars, imin, imax)
     sfhpars%use_simha_limits = 0
     m2 = sum(w2(1:imax))
     ! Normalize and sum.  need to be careful of divide by zero here, if all
     ! linear or all delay-tau s.t. weights sum to zero for a component.
     if (m1.lt.tiny_number) m1 = 1.0
     if (m2.lt.tiny_number) m2 = 1.0
     ! need to get the fraction of the mass formed in the linear portion
     call sfhinfo(pset, tage, mfrac, sfr, frac_linear)
     total_weights(:, 1) = (w1 / m1) * (1 - frac_linear) + frac_linear * (w2 / m2)
     ! imax = min(max(locate(time_full, log10(sfhpars%tage)) + 2, 1), ntfull)
  endif


  ! Tabular.  Time units in sfh_tab are assumed to be linear years of time
  ! since big bang (forward time).  We are going to treat this as a sum of
  ! linear SFHs, one for each bin in the table
  if (pset%sfh.eq.2.or.pset%sfh.eq.3) then
     total_weights = 0.

     ! Assume linear SFH within the bins
     sfhpars%type = 5
     ! Loop over each bin in the table.
     do j=1, ntabsfh-1
        ! Edges of the bin in lookback time. Note that the order of sfhtab gets
        ! flipped, since it is given in forward time and then we convert to
        ! lookback time.  So j=0 is the `oldest` in terms of lookback time
        t1 = tage*1e9 - sfh_tab(1, j+1)
        t2 = tage*1e9 - sfh_tab(1, j)
        if (t2.lt.0) then
           ! Entire bin is in the future, skip
           cycle
        endif
        ! Metallicity of the bin. Just a straight average.
        zbin = (sfh_tab(3, j) + sfh_tab(3, j+1)) / 2

        ! Linear slope.  Positive should be sfr *decreasing* in time since big bang.
        sfhpars%sf_slope = -(sfh_tab(2, j+1) - sfh_tab(2, j)) / (t2 - t1) / sfh_tab(2, j+1)
        ! Set integration limits using bin edges clipped to valid times.
        ! That is, don't include any portion of a bin that goes to negative
        ! time, or beyond the oldest isochrone.
        sfhpars%tq = min(max(t1, 10**tiny_logt), 10**time_full(ntfull))  ! lower limit (in lookback time)
        sfhpars%tage = min(max(t2, 10**tiny_logt), 10**time_full(ntfull)) ! upper limit
        sfhpars%sf_trunc = sfhpars%tage - sfhpars%tq
        ! Mass that formed within these valid times.
        dt = (sfhpars%tage - sfhpars%tq)
        m2 = sfh_tab(2, j+1) * (1 + sfhpars%sf_slope/2. * (sfhpars%tage + sfhpars%tq - 2*t1)) * dt
        ! min and max ssps to consider, being conservative.
        imin = min(max(locate(time_full, log10(t1)) - 1, 0), ntfull)
        imax = min(max(locate(time_full, log10(t2)) + 2, 0), ntfull)

        ! Get the weights for this bin in the tabulated sfh and add to the
        ! total weight, after normalizing.
        w1 = sfh_weight(sfhpars, imin, imax)
        m1 = sum(w1)
        if (m1.lt.tiny_number) m1 = 1.0
        ! This is where we'd assign to specific metallicities, if taking that
        ! into account.  This scheme assumes entire bin is at average of the
        ! two enclosing Z values.
        if (nzin.gt.1) then
           k = max(min(locate(zlegend, zbin), nz-1), 1)
           dz = (log10(zbin) - log10(zlegend(k))) / &
                (log10(zlegend(k+1)) - log10(zlegend(k)))
           dz = max(min(dz, 1.0), -1.0) !don't extrapolate
           total_weights(:, k) = total_weights(:, k) + (1-dz) * w1 * (m2 / m1)
           total_weights(:, k+1) = total_weights(:, k+1) + dz * w1 * (m2 / m1)
        else
           total_weights(:, 1) = total_weights(:, 1) + w1 * (m2 / m1)
        endif
     enddo
     ! Reset imin and imax for the spectral sum.
     imin = 0
     imax = ntfull
  endif

  ! ----- Combine SSPs with dust -------
  ! Now weight each SSP by `total_weight`, assign to young or old, and feed to
  ! add_dust, which does the final sum as well as attenuating.
  ! This matrix multiply could probably be optimized!!!!

  csp1  = 0. ! young
  csp2  = 0. ! old
  ncsp1 = 0. ! young nebular
  ncsp2 = 0. ! old nebular
  if (compute_light_ages.eq.1) then
     nlw_age  = 0.
     lw_age   = 0.
     lbol_age = 0.
     mass_age = 0.
  endif

  ! Dust treatment is not strictly correct, since the age bin older than
  ! dust_tesc will include some contribution from young star dust due to the
  ! interpolation, and changing dust_tesc by values smaller than half the ssp
  ! age grid resolution will have no effect on the output.
  i_tesc = locate(time_full, pset%dust_tesc)
  do i=max(imin, 1), imax
     do k=1,nzin
        if (total_weights(i, k).gt.tiny_number) then
           if (i.le.i_tesc) then
              csp1  = csp1  + total_weights(i, k) * spec_ssp(:, i, k)
              ncsp1 = ncsp1 + total_weights(i, k) * emlin_ssp(:, i, k)
           else
              csp2  = csp2  + total_weights(i, k) * spec_ssp(:, i, k)
              ncsp2 = ncsp2 + total_weights(i, k) * emlin_ssp(:, i, k)
           endif
           ! Now do numerator in case of light and mass weighted ages.
           if (compute_light_ages.eq.1) then
              nlw_age = nlw_age + total_weights(i, k) * emlin_ssp(:, i, k) &
                       * 10**(time_full(i)-9)
              lw_age = lw_age + total_weights(i, k) * spec_ssp(:, i, k) &
                       * 10**(time_full(i)-9)
              lbol_age = lbol_age + 10**lbol_ssp(i, k) * total_weights(i, k) &
                         * 10**(time_full(i)-9)
              mass_age = mass_age + mass_ssp(i, k) * total_weights(i, k) &
                         * 10**(time_full(i)-9)
           endif
        endif
     enddo
  enddo
  mass_csp = sum(mass_ssp * total_weights)
  lbol_csp = log10(sum(10**lbol_ssp * total_weights))

  ! Here we add young and old spectra with dust.
  if (((pset%dust1.gt.tiny_number).or.(pset%dust2.gt.tiny_number).or.(dust_type.eq.3))&
       .and.(compute_light_ages.eq.0)) then
     call add_dust(pset, csp1, csp2, spec_csp, mdust_csp, ncsp1, ncsp2, emlin_csp)

  else
     spec_csp  = csp1 + csp2
     emlin_csp = ncsp1 + ncsp2
     mdust_csp = 0.0
  endif

  if (compute_light_ages.eq.1) then
     spec_csp  = lw_age / spec_csp
     emlin_csp = nlw_age / emlin_csp
     lbol_csp  = lbol_age / 10**lbol_csp
     mass_csp  = mass_age / mass_csp
  endif

end subroutine csp_gen


subroutine convert_sfhparams(pset, tage, sfh)
  ! Convert the pset values to yrs, subtract sf_start from the relevant times,
  ! pre-calculate some useful lookback times, and store in a structure.  Note
  ! that this subroutine uses but does not alter the pset values.
  !
  ! Inputs
  ! ----------
  !
  ! pset:
  !    The parameter set.
  !
  ! tage:
  !    The age (in forward time, not lookback time) at which you are
  !    calculating the composite spectrum, in Gyr.
  !
  ! Outputs
  ! ----------
  ! sfh:
  !    An SFHPARAMS structure, containing SFH parameters in yrs, with sf_start
  !    subtracted, and some useful lookback times.
  !       - `tq` is the truncation time, in lookback time
  !       - `t0` is the zero crossing time for a linear SFH, in lookback time.
  !       - `tb` is the burst time, in lookback time.
  !       - `sf_slope` is the fractional change in the SFR in inverse years.  It is
  !          positive for SFR that increases with *lookback* time.
  !
  use sps_vars, only: tiny_number, SFHPARAMS, PARAMS, SP
  implicit none
  
  type(PARAMS), intent(in) :: pset
  real(SP), intent(in) :: tage
  
  type(SFHPARAMS), intent(inout) :: sfh

  real(SP) :: start

  ! Define a starting time iff SFH=1,4,5
  if ((pset%sfh.eq.1).or.(pset%sfh.eq.4).or.(pset%sfh.eq.5)) then
     start = pset%sf_start * 1e9
  else
     start = 0.
  endif
  ! Convert units from Gyr to yr, subtract sf_start
  sfh%tage = tage * 1e9 - start
  sfh%tburst = pset%tburst * 1e9 - start
  sfh%sf_trunc = pset%sf_trunc * 1e9 - start
  sfh%tau = pset%tau * 1e9
  ! Note the sign flip here!  pset%sf_slope is positive for sfr that increases
  ! with forward time, sfh%sf_slope is positive for sfr that increases with
  ! *lookback time*.  Yeah, awesome!
  sfh%sf_slope = -pset%sf_slope / 1e9

  ! convert tburst to lookback time
  sfh%tb = sfh%tage - sfh%tburst
  
  ! convert sf_trunc to to lookback time
  if ((sfh%sf_trunc.le.0).or.(sfh%sf_trunc.gt.sfh%tage)) then
     sfh%tq = 0.
  else
     sfh%tq = sfh%tage - sfh%sf_trunc
  endif
  ! For simha get zero crossing time (in lookback time), avoiding divison by zero
  ! Note that only positive slopes have a chance to hit zero SFR.
  if (sfh%sf_slope.gt.tiny_number) then
     sfh%t0 = sfh%tq - 1. / sfh%sf_slope
  else
     sfh%t0 = 0.
  endif
  ! If the zero crossing time is outside the linear regime, set it to zero.
  if ((sfh%t0.gt.sfh%tq).or.(sfh%t0.le.0)) then
     sfh%t0 = 0.
  endif

end subroutine convert_sfhparams

! Tabulated SFH defined in a file called sfh.dat that must reside in the data
! directory (or a file specified via the parameter sfh filename; see
! below). The file must contain three columns. The first column is time since
! the Big Bang in Gyr, the second is the SFR in units of solar masses per year,
! the third is the absolute metallicity. An example is provided in the data
! directory. The time grid in this file can be arbitrary (so long as the units
! are correct), but it is up to the user to ensure that the tabulated sfh is
! well-sampled so that the outputs are stable. Obviously, highly oscillatory
! data require dense sampling.
!
! SFRs are clipped to a minimum value of 1e-30 to avoid divide by zero errors.


subroutine setup_tabular_sfh(pset, nzin)

  use sps_vars, only: sfh_tab, ntabsfh, ntabmax, nz, &
                      tiny_number, tiny30, PARAMS, SPS_HOME
  implicit none
  type(PARAMS), intent(in) :: pset
  integer, intent(in) :: nzin
  integer :: stat, n
  
  IF (pset%sfh.EQ.2) THEN

     if (pset%sf_start.gt.tiny_number) then 
        WRITE(*,*) 'COMPSP ERROR: Tabular sfh, but sf_start > 0'
        STOP
     endif
     
     ! Read the sfh file
     IF (TRIM(pset%sfh_filename).EQ.'') THEN
        OPEN(3,FILE=TRIM(SPS_HOME)//'/data/sfh.dat',ACTION='READ',STATUS='OLD')
     ELSE
        OPEN(3,FILE=TRIM(SPS_HOME)//'/data/'//TRIM(pset%sfh_filename),&
             ACTION='READ',STATUS='OLD')
     ENDIF
     DO n=1,ntabmax
        IF (nzin.EQ.nz) THEN
           READ(3,*,IOSTAT=stat) sfh_tab(1,n),sfh_tab(2,n),sfh_tab(3,n)
        ELSE
           READ(3,*,IOSTAT=stat) sfh_tab(1,n),sfh_tab(2,n)
           sfh_tab(3,n)=0.0
        ENDIF
        IF (stat.NE.0) GOTO 29
     ENDDO
     WRITE(*,*) 'COMPSP ERROR: didnt finish reading in the sfh file,'
     WRITE(*,*) '     increase ntabmax variable in sps_vars.f90 file'
     STOP
29   CONTINUE
     CLOSE(3)

     
     ntabsfh = n-1
     sfh_tab(1,1:ntabsfh) = sfh_tab(1,1:ntabsfh)*1E9 !convert to yrs        
     
     !special switch to compute only the last time output
     !in the tabulated file
     ! IF (pset%tage.EQ.-99.) imin=imax

  ELSE IF (pset%sfh.EQ.3) THEN 

     !sfh_tab array is supposed to already be filled in, check that it is
     IF (ntabsfh.EQ.0) THEN 
        WRITE(*,*) 'COMPSP ERROR: sfh=3 but sfh_tab array not initialized!'
        STOP
     ENDIF

  ENDIF

  ! clip SFR to a minimum of 1e-30
  do n=1, ntabsfh
     sfh_tab(2, n) = max(sfh_tab(2, n), tiny30)
  enddo
  
end subroutine setup_tabular_sfh

FUNCTION COMPUTE_TAU1(cstar,mact,logt,logl,logg,zz,lmdot)

  !routine to compute tau at 1um from input
  !stellar parameters.  See Villaume et al. (2015)
  
  USE sps_vars
  IMPLICIT NONE
  INTEGER, INTENT(in) :: cstar
  REAL(SP), INTENT(in)  :: mact,logt,logl,logg, zz,lmdot
  REAL(SP) :: compute_tau1, radius, period, vexp, vexp_max
  REAL(SP) :: rin, delta, kappa, delta_agb, mdot

  !-----------------------------------------------------------!
  !write(*,*) 'in function: ', cstar
  !dust-to-gas ratio depends on C/O
  IF (cstar.EQ.1) THEN
     delta_agb = 0.0025
  ELSE
     delta_agb = 0.01
  ENDIF

  !extinction coefficient depends on grain composition (C/O)
  IF (cstar.EQ.1) THEN
     !sum of AmC and SiC (90%+10%)
     kappa = 3200.
  ELSE
     !Sil
     kappa = 3000.
  ENDIF
  
  !stellar radius in solar units
  radius = SQRT(mact*msun*newton/10**logg) / rsun
 
  !fundamental pulsation period in days
  period = 10**( -2.07 + 1.94*LOG10(radius)-0.9*LOG10(mact) )
  
  !expansion velocity in km/s
  vexp     = -13.5 + 0.056*period
  !metallicity dependent maximum (Bressan et al. 1998)
  !this implicitly introduces a (strong) metallicity
  !dependence on the dust-to-gas ratio (see below)
  !vexp_max = 6.5*zz/0.008 + 0.00226*period
  vexp     = MAX(MIN(vexp,15.0),3.0)

  !mass-loss rate in Msun/yr
  IF (use_isoc_mdot.EQ.1) THEN
     IF (isoc_type.NE.'mist') THEN
        WRITE(*,*) 'ADD_AGB_DUST ERROR: use_isoc_mist=1 but isoc_type NE MIST!'
        STOP
     ENDIF
     !use Mdot from the isochrone files
     mdot = MIN(10**lmdot,1E-4)
  ELSE
     !see Vassiliadis & Wood (1993) for details
     IF (period.LT.500.) THEN
        IF (mact.LT.2.5) THEN
           mdot = 10**(-11.4+0.0123*period)
        ELSE
           mdot = 10**(-11.4+0.0125*(period-100*(mact-2.5)))
        ENDIF
     ELSE
        !superwind phase
        mdot = 10**logl/vexp*1.93E3*yr2sc/clight
     ENDIF
  ENDIF

  !inner radius (assuming Td=1100K for C-rich and 
  !Td=700 for O-rich) in cm
  IF (cstar.EQ.1) THEN
    rin = 1.92E12 * (10**logl)**0.5
  ELSE 
    rin = 4.74E12 * (10**logl)**0.5
  ENDIF

  !dust-to-gas ratio
  delta = delta_agb * vexp**2 / 225. * (10**logl/1E4)**(-0.6)

  !finally, compute tau (and convert to cgs)
  compute_tau1 = kappa * delta * (mdot*msun/yr2sc) &
       / rin / (4*mypi) / (vexp*1E5)

  !WRITE(*,'(13ES11.2)') mact,logl,logg,radius,period,mdot,rin,&
  !     vexp,delta,compute_tau1

END FUNCTION COMPUTE_TAU1

!------------------------------------------------------------!
!------------------------------------------------------------!
!------------------------------------------------------------!

SUBROUTINE ADD_AGB_DUST(weight,tspec,mact,logt,logl,logg,zz,&
     tco,lmdot)

  !routine to add a circumstellar dust shell to AGB stars
  !computes the optical depth at 1um from stellar parameters
  !then looks up the corresponding DUSTY model given the C/O
  !ratio and Teff.
  
  USE sps_vars; USE sps_utils, ONLY: locate, smoothspec
  IMPLICIT NONE

  REAL(SP), DIMENSION(nspec), INTENT(inout) :: tspec
  REAL(SP), INTENT(in)  :: weight,mact,logt,logl,logg,zz,tco,lmdot
  INTEGER :: cstar,jlo,klo
  REAL(SP) :: tau1,dj,dk, compute_tau1, loggi
  REAL(SP), DIMENSION(nspec) :: dusty
  
  !-----------------------------------------------------------!
  !-----------------------------------------------------------!

  IF (tco.GT.1) THEN
     cstar=1 
  ELSE 
     cstar=0
  ENDIF

  !we need to recompute loggi here because the BaSTI
  !isochrones do not come with logg pre-tabulated
    IF (isoc_type.EQ.'bsti') THEN
        loggi = LOG10( gsig4pi*mact/10**logl ) + 4*logt
    ELSE
        loggi = logg
    ENDIF
   !compute tau1 based on input stellar parameters
   tau1 = compute_tau1(cstar,mact,logt,logl,loggi,zz,lmdot)

  !allow the user to manually adjust the tau1 value
  !by an overall scale factor
  tau1 = tau1*weight

  IF (tau1.LE.tiny_number) RETURN

  !find dusty model given tau1,tco,Teff
  jlo = MIN(MAX(locate(teff_dagb(cstar+1,:),10**logt),1),&
       nteff_dagb-1)
  klo = MIN(MAX(locate(tau1_dagb(cstar+1,:),LOG10(tau1)),1),ntau_dagb-1)

  dj   = (10**logt-teff_dagb(cstar+1,jlo)) / &
       (teff_dagb(cstar+1,jlo+1)-teff_dagb(cstar+1,jlo))
  dk   = (LOG10(tau1)-tau1_dagb(cstar+1,klo)) / &
       (tau1_dagb(cstar+1,klo+1)-tau1_dagb(cstar+1,klo))

  !don't allow extrapolation off the grid
  dj = MIN(MAX(dj,-1.0),1.0)
  dk = MIN(MAX(dk,-1.0),1.0)

  !bilinear interpolation
  dusty = (1-dj)*(1-dk)*flux_dagb(:,cstar+1,jlo,klo) + &
       dj*(1-dk)*flux_dagb(:,cstar+1,jlo+1,klo) + &
       dj*dk*flux_dagb(:,cstar+1,jlo+1,klo+1) + &
       (1-dj)*dk*flux_dagb(:,cstar+1,jlo,klo+1) 

  !implement the dusty spectra (which are in units of 
  !flux_out/flux_in) into the AGB spectra
!  tspec = tspec * dusty
  CALL SMOOTHSPEC(spec_lambda,tspec,10000.d0,30000.d0,100000000.d0)
  tspec = tspec * dusty

END SUBROUTINE ADD_AGB_DUST

 PROGRAM SIMPLE

  !set up modules
  USE sps_vars; USE sps_utils  
  IMPLICIT NONE

  !NB: the various structure types are defined in sps_vars.f90
  !    variables not explicitly defined here are defined in sps_vars.f90

  INTEGER :: i
  !define variable for SSP spectrum
  REAL(SP), DIMENSION(ntfull,nspec)  :: spec_ssp
  !define variables for Mass and Lbol info
  REAL(SP), DIMENSION(ntfull)    :: mass_ssp,lbol_ssp
  CHARACTER(100) :: file1='', file2=''
  !structure containing all necessary parameters
  TYPE(PARAMS) :: pset
  !define structure for CSP spectrum
  TYPE(COMPSPOUT), DIMENSION(ntfull) :: ocompsp
  REAL(SP) :: ssfr6,ssfr7,ssfr8,ave_age

  !---------------------------------------------------------------!
  !---------------------------------------------------------------!
  
  ! Lets compute an SSP, solar metallicity, with a Chabrier IMF
  ! with no dust, and the 'default' assumptions regarding the 
  ! locations of the isochrones

  imf_type  = 0             !define the IMF (1=Chabrier 2003)
                            !see sps_vars.f90 for details of this var
  pset%zmet = 10            !define the metallicity (see the manual)
                            !20 = solar metallacity

  CALL SPS_SETUP(pset%zmet) !read in the isochrones and spectral libraries

  !define the parameter set.  These are the default values, specified 
  !in sps_vars.f90, but are explicitly included here for transparency
  pset%sfh   = 0     !set SFH to "SSP"
  pset%const = 1.
  pset%zred  = 0.0   !redshift  
  pset%dust1 = 0.0   !dust parameter 1
  pset%dust2 = 0.0   !dust parameter 2

  pset%dell  = 0.0   !shift in log(L) for TP-AGB stars
  pset%delt  = 0.0   !shift in log(Teff) for TP-AGB stars
  pset%fbhb  = 0.0   !fraction of blue HB stars
  pset%sbss  = 0.0   !specific frequency of BS stars

  !compute the SSP
  CALL SSP_GEN(pset,mass_ssp,lbol_ssp,spec_ssp)
  !compute mags and write out mags and spec for SSP
  file1 = 'SSP_BPASS.out'
  CALL COMPSP(3,1,file1,mass_ssp,lbol_ssp,spec_ssp,pset,ocompsp)



  ! Now lets compute a 1 Gyr tau model SFH with a Salpeter IMF
  ! with a simple dust model, at a particular time 
  ! (rather than outputing all the time info)

  imf_type  = 0                !define the IMF (0=Salpeter)
                               !see sps_vars.f90 for details of this var

  !NB: you only need to re-run SPS_SETUP if you have changed the metallicity
  !    or, even better (but slower), you can call SPS_SETUP(-1) and this will
  !    set up all the metallicities at once.
  CALL SPS_SETUP(pset%zmet)    !read in the isochrones and spectral libraries

  !define the parameter set. 
  pset%sfh   = 1     !set SFH to "CSP"; sfh=1 means a normal tau model
  pset%tau   = 2.0   !tau units are Gyr
  pset%dust1 = 1.0   !dust parameter 1
  pset%dust2 = 0.3   !dust parameter 2
  !pset%tage  = 12.5  !age at which we want the mags

  !compute the CSP
  CALL SSP_GEN(pset,mass_ssp,lbol_ssp,spec_ssp)
  !compute mags, and write out mags and spec for CSP
  file1 = 'CSP.out'
  CALL COMPSP(3,1,file1,mass_ssp,lbol_ssp,spec_ssp,pset,ocompsp)

  !compute basic SFH statistics for the last entry in the ocompsp array
  !results are returned in the variables ssfr6,...,ave_age
  CALL SFHSTAT(pset,ocompsp(1),ssfr6,ssfr7,ssfr8,ave_age)


END PROGRAM SIMPLE

FUNCTION LOCATE(xx,x)

  USE sps_vars
  IMPLICIT NONE
  REAL(SP), DIMENSION(:), INTENT(IN) :: xx
  REAL(SP), INTENT(IN) :: x
  INTEGER :: locate
  INTEGER :: n,jl,jm,ju
  LOGICAL :: ascnd
  
  n = SIZE(xx)
  ascnd = (xx(n) >= xx(1))
  jl=0
  ju=n+1
  
  DO
     IF (ju-jl <= 1) EXIT
     jm=(ju+jl)/2
     IF (ascnd.EQV.(x >= xx(jm))) THEN
        jl=jm
     ELSE
        ju=jm
     ENDIF
  ENDDO

  IF (x == xx(1)) THEN
     locate=1
  ELSE IF (x == xx(n)) THEN
     locate=n-1
  ELSE
     locate=jl
  ENDIF

END FUNCTION LOCATE

SUBROUTINE MOD_HB(f_bhb,t,mini,mact,logl,logt,logg,phase, &
     wght,hb_wght,nmass,hbtime)

  !routine to modify the horizontal branch to include bluer 
  !stars.  The fiducial HB stars are identified and then a fraction
  !f_bhb uniformly redistributed from the red clump to 10^4 K 
  !We also want to be able to call this routine when f_bhb=0 
  !in order to count the weight of stars on the HB.

  !see e.g. Sarajedini et al. 2007.  This treatment of BHB 
  !produces spectra similar to the Maraston 2005 models
  !see also Jimenez et al. 2004

  !Note that the parameter bhb_sbs_time, set in sps_vars.f90,
  !sets the turn-on time for this modification.

  USE sps_vars
  IMPLICIT NONE

  REAL(SP), INTENT(inout), DIMENSION(nt,nm) :: mini,mact,&
       logl,logt,logg,phase
  REAL(SP), INTENT(inout), DIMENSION(nm) :: wght
  REAL(SP), DIMENSION(nm) :: tphase=0.0
  INTEGER, INTENT(inout), DIMENSION(nt) :: nmass
  REAL(SP), INTENT(inout) :: hb_wght
  INTEGER, INTENT(in) :: t
  REAL(SP), INTENT(in) :: f_bhb, hbtime

  !number of blue HB to add per HB star
  !(not important b/c their total weight remains fixed)
  INTEGER, PARAMETER :: nhb=10
  INTEGER :: j, i, flip=0, tnhb
  REAL(SP) :: tgrad=0., hblum=-999.,minteff=1E6
  REAL(SP), DIMENSION(nhb) :: dumarr=0.

  !---------------------------------------------------------------!
  !---------------------------------------------------------------!

  hblum   = -999.
  flip    = 0
  hb_wght = 0.
  tphase  = phase(t,:)

  !we need to count the total number of HB stars in 
  !these isochrones.  Also the minimum Teff for the HB
  IF (isoc_type.EQ.'bsti'.OR.isoc_type.EQ.'mist') THEN
     tnhb = 0
     minteff=1E6
     DO i=1,nm
        IF (tphase(i).EQ.3) THEN
           tnhb=tnhb+1
           !need this delta(mass) cut to remove the stars 
           !descending from the TRGB in the MIST models
           IF (logt(t,i).LT.minteff.AND.(mini(t,i+1)-mini(t,i)).GT.1E-6)  &
                minteff=logt(t,i)
        ENDIF
     ENDDO
     i=1
  ENDIF

  DO j=2,nm

     IF (isoc_type.EQ.'pdva') THEN

        IF (flip.NE.-1) THEN 
        
           tgrad = (logl(t,j)-logl(t,j-1)) / (mini(t,j)-mini(t,j-1))
           
           !if the lum jump is negative and large, we're on the HB
           IF (tgrad.LE.-5E2.AND.logl(t,j-1).GT.2.5) THEN
              flip = 1
              hblum = logl(t,j)
           ENDIF
        
           IF (flip.EQ.1) THEN

              !modify the HB
              !once lum increases by 0.1 dex we've left the HB
              IF (ABS(logl(t,j)-hblum).LT.0.1) THEN 

                 !keep track of total HB weight
                 hb_wght  = hb_wght+wght(j)
                 
                 !Blue HB stars have to be old
                 IF (f_bhb.GT.1E-3.AND.hbtime.GE.bhb_sbs_time) THEN

                    !add blue HB stars (their mass and Lbol remain the same)
                    mini(t,nmass(t)+1:nmass(t)+nhb)  = dumarr+mini(t,j)
                    mact(t,nmass(t)+1:nmass(t)+nhb)  = dumarr+mact(t,j)
                    logl(t,nmass(t)+1:nmass(t)+nhb)  = dumarr+logl(t,j)
                    phase(t,nmass(t)+1:nmass(t)+nhb) = dumarr+8.
                    DO i=1,nhb
                       !distribute Teff uniformly to high T
                       logt(t,nmass(t)+i) = logt(t,j)+(4.2-logt(t,j))*i/REAL(nhb)
                       !logt(t,nmass(t)+i) = 4.0+(4.3-4.0)*i/REAL(nhb)
                       !compute logg
                       logg(t,nmass(t)+i) = LOG10( gsig4pi*mact(t,nmass(t)+i)/&
                            10**logl(t,nmass(t)+i) ) + 4*logt(t,nmass(t)+i) 

                    ENDDO
                    wght(nmass(t)+1:nmass(t)+nhb)   = dumarr + &
                         f_bhb*wght(j)/nhb
                    !modify the weight of the existing HB stars
                    wght(j)   = wght(j) * (1-f_bhb)                 
                    !update number of stars in the isochrone
                    nmass(t) = nmass(t)+nhb
                 ENDIF

              ELSE 
                 flip = -1
              ENDIF
           
           ENDIF
        
        ENDIF

     ELSE IF ((isoc_type.EQ.'bsti'.OR.isoc_type.EQ.'mist') &
          .AND.tphase(j).EQ.3) THEN

        !keep track of total HB weight
        hb_wght  = hb_wght+wght(j)
        
        !Blue HB stars have to be old
        !here, we're adding one additional BHB stars per CHeB star
        !we're also putting the original BHB star to the RC, so that
        !if f_bhb is small, then the actual BHB contribution is small
        !if f_bhb<1E-4, then the default MIST BHB is used
        IF (f_bhb.GT.1E-4.AND.hbtime.GE.bhb_sbs_time) THEN

           !update number of stars in the isochrone
           nmass(t) = nmass(t)+1
           !add blue HB stars (their mass and Lbol remain the same)
           mini(t,nmass(t))  = mini(t,j)
           mact(t,nmass(t))  = mact(t,j)
           logl(t,nmass(t))  = logl(t,j)
           phase(t,nmass(t)) = 8.
           logt(t,j) = minteff 
           !distribute Teff uniformly to high T
           logt(t,nmass(t)) = logt(t,j)+(4.5-logt(t,j))*i/REAL(tnhb)
           i=i+1
           wght(nmass(t))   = f_bhb*wght(j)
           !modify the weight of the existing HB stars
           wght(j)   = wght(j) * (1-f_bhb)                
           !compute logg
           logg(t,nmass(t)) = LOG10( gsig4pi*mact(t,nmass(t))/&
                10**logl(t,nmass(t)) ) + 4*logt(t,nmass(t)) 
              
        ENDIF

     ENDIF

  ENDDO

  IF (nmass(t).GT.nm) THEN
     WRITE(*,*) 'MOD_HB ERROR: number of mass points GT nm'
     STOP
  ENDIF

  RETURN

END SUBROUTINE MOD_HB

FUNCTION LINTERP(xin,yin,xout)

  !routine to linearly interpolate a function yin(xin) at xout

  USE sps_vars; USE sps_utils, ONLY: locate
  IMPLICIT NONE
  REAL(SP), DIMENSION(:), INTENT(in) :: xin,yin
  REAL(SP), INTENT(in)  :: xout
  REAL(SP) :: linterp
  INTEGER :: klo,n

  !---------------------------------------------------------------!
  !---------------------------------------------------------------!

  n   = SIZE(xin)
  klo = MAX(MIN(locate(xin,xout),n-1),1)

  linterp = yin(klo) + (yin(klo+1)-yin(klo))*&
       (xout-xin(klo))/(xin(klo+1)-xin(klo))

END FUNCTION LINTERP

SUBROUTINE WRITE_ISOCHRONE(outfile,pset)

  !routine to write all isochrones and CMDs at a given metallicity
  !note that the output age grid is the native spacing, not boosted
  !by the parameter time_res_incr

  USE sps_vars
  USE sps_utils, ONLY : getmags,getspec,imf_weight,mod_hb,mod_gb,add_bs
  IMPLICIT NONE

  INTEGER :: i,tt,zz
  TYPE(PARAMS), INTENT(in) :: pset
  CHARACTER(100), INTENT(in)  :: outfile
  CHARACTER(60)  :: fmt
  REAL(SP) :: dz=0.0,loggi,hb_wght
  REAL(SP), DIMENSION(nspec)  :: spec
  REAL(SP), DIMENSION(nm)     :: wght
  REAL(SP), DIMENSION(nbands) :: mags
  !temp arrays for the isochrone data
  REAL(SP), DIMENSION(nt,nm)  :: mini,mact,logl,logt,logg,&
       ffco,phase,lmdot
  INTEGER, DIMENSION(nt)      :: nmass

  !---------------------------------------------------------------!
  !---------------------------------------------------------------!

  hb_wght = 0.0
  wght    = 0.0
  zz      = pset%zmet

  fmt = '(F7.4,1x,F8.4,1x,F14.9,1x,F14.9,1x,7(F8.4,1x),000(F7.3,1x))'
  WRITE(fmt(47:49),'(I3,1x,I4)') nbands

  OPEN(40,FILE=TRIM(SPS_HOME)//'/OUTPUTS/'//TRIM(outfile)//'.cmd',&
       STATUS='REPLACE')
  WRITE(40,*) '# age log(Z) mini mact logl logt logg '//&
       'phase composition log(weight) log(mdot) mags'
       
  !transfer isochrones into temporary arrays
  mini  = mini_isoc(zz,:,:)  !initial mass
  mact  = mact_isoc(zz,:,:)  !actual (present) mass
  logl  = logl_isoc(zz,:,:)  !log(Lbol)
  logt  = logt_isoc(zz,:,:)  !log(Teff)
  logg  = logg_isoc(zz,:,:)  !log(g)
  ffco  = ffco_isoc(zz,:,:)  !is the TP-AGB star C-rich or O-rich?
  lmdot = lmdot_isoc(zz,:,:) !log Mdot
  phase = phase_isoc(zz,:,:) !flag indicating phase of evolution
  nmass = nmass_isoc(zz,:)   !number of elements per isochrone

  DO tt=1,nt

     !compute IMF-based weights
     CALL IMF_WEIGHT(mini(tt,:),wght,nmass(tt))

     !modify the horizontal branch
     !need the hb weight for the blue stragglers too
     IF (pset%fbhb.GT.0.0.OR.pset%sbss.GT.1E-3) &
          CALL MOD_HB(pset%fbhb,tt,mini,mact,logl,logt,logg,phase,&
          wght,hb_wght,nmass,timestep_isoc(zz,tt))

     !add in blue stragglers
     IF (timestep_isoc(zz,tt).GE.bhb_sbs_time.AND.pset%sbss.GT.1E-3) &
          CALL ADD_BS(pset%sbss,tt,mini,mact,logl,logt,logg,phase,&
          wght,hb_wght,nmass)

     !modify the RGB and/or AGB stars
     CALL MOD_GB(zz,tt,timestep_isoc(zz,:),pset%delt,&
          pset%dell,pset%pagb,pset%redgb,pset%agb,nmass(tt),logl,logt,phase,wght)

     DO i=1,nmass(tt)
        
        !get the spectrum
        CALL GETSPEC(pset,mact(tt,i),logt(tt,i),10**logl(tt,i),&
             logg(tt,i),phase(tt,i),ffco(tt,i),lmdot(tt,i),wght(i),spec)
        !calculate magnitudes
        CALL GETMAGS(dz,spec,mags)

        IF (isoc_type.EQ.'bsti') THEN
           loggi = LOG10( gsig4pi*mact_isoc(zz,tt,i)/&
                logl(tt,i) ) + 4*logt(tt,i)
        ELSE
           loggi = logg(tt,i)
        ENDIF

        !write results to file
        WRITE(40,fmt) timestep_isoc(zz,tt),LOG10(zlegend(zz)),&
             mini(tt,i),mact(tt,i),logl(tt,i),logt(tt,i),loggi,phase(tt,i),&
             ffco(tt,i),LOG10(wght(i)),lmdot(tt,i),mags
        
     ENDDO

  ENDDO

  CLOSE(40)

END SUBROUTINE WRITE_ISOCHRONE

FUNCTION AIRTOVAC(lam)
  
  !convert wavelengths from air to vac
  !see Morton (1991 Ap.J. Suppl. 77, 119)
  !this code was adapted from the IDL routine airtovac.pro

  USE sps_vars; USE sps_utils, ONLY : locate
  IMPLICIT NONE

  INTEGER :: vv,nn
  REAL(SP), DIMENSION(:), INTENT(in) :: lam
  REAL(SP), DIMENSION(SIZE(lam)) :: airtovac,fact,sigma2

  !------------------------------------------------------!

  nn = SIZE(lam)

  !Convert to wavenumber squared
  sigma2(1:nn) = (1E4/lam(1:nn) )**2.   

  !Compute conversion factor
  fact(1:nn) = 1.D0 + 6.4328D-5 + 2.94981D-2/(146.d0 - sigma2(1:nn)) + &
       2.5540D-4/( 41.d0 - sigma2(1:nn))
  
  !no conversion for wavelengths <2000A
  IF (lam(1).LT.2000.D0) THEN
     vv = MIN(MAX(locate(lam(1:nn),2000.D0),1),nn)
     fact(1:vv) = 1.0
  ENDIF

  !Convert wavelength
  airtovac(1:nn) = lam(1:nn)*fact(1:nn)

END FUNCTION AIRTOVAC

!---------------------------------------------------------------!
!---------------------------------------------------------------!
!---------------------------------------------------------------!

FUNCTION VACTOAIR(lam)

  !convert wavelengths from air to vac
  !see Morton (1991 Ap.J. Suppl. 77, 119)
  !this code was adapted from the IDL routine vactoair.pro

  USE sps_vars; USE sps_utils, ONLY : locate
  IMPLICIT NONE

  INTEGER :: vv,nn
  REAL(SP), DIMENSION(:), INTENT(in) :: lam
  REAL(SP), DIMENSION(SIZE(lam)) :: vactoair,fact

  !------------------------------------------------------!

  nn = SIZE(lam)

  fact(1:nn) = 1.D0 + 2.735182D-4 + 131.4182/lam(1:nn)**2 + &
       2.76249D8/lam(1:nn)**4

  !no conversion for wavelengths <2000A
   IF (lam(1).LT.2000.D0) THEN
     vv = MIN(MAX(locate(lam(1:nn),2000.D0),1),nn)
     fact(1:vv) = 1.0
  ENDIF

  !Convert wavelengths
  vactoair(1:nn) = lam(1:nn)/fact(1:nn)

END FUNCTION VACTOAIR

MODULE SPS_UTILS

  INTERFACE
     SUBROUTINE ADD_AGB_DUST(weight,tspec,mact,logt,logl,logg,&
          zz,tco,lmdot)
       USE sps_vars
       REAL(SP), DIMENSION(nspec), INTENT(out) :: tspec
       REAL(SP), INTENT(in)  :: weight,mact,logt,logl,logg,zz,tco,lmdot
     END SUBROUTINE ADD_AGB_DUST
  END INTERFACE

  INTERFACE
     SUBROUTINE ADD_BS(s_bs,t,mini,mact,logl,logt,logg,phase, &
          wght,hb_wght,nmass)
       USE sps_vars
       REAL(SP), INTENT(inout), DIMENSION(nt,nm) :: mini,mact,&
            logl,logt,logg,phase
       REAL(SP), INTENT(inout), DIMENSION(nm) :: wght
       REAL(SP), INTENT(in) :: hb_wght,s_bs
       INTEGER, INTENT(in)  :: t
       INTEGER, INTENT(inout), DIMENSION(nt)  :: nmass
     END SUBROUTINE ADD_BS
  END INTERFACE

  INTERFACE
     SUBROUTINE ADD_DUST(pset,csp1,csp2,specdust,mdust,ncsp1,ncsp2,nebdust)
       USE sps_vars
       REAL(SP), INTENT(out) :: mdust
       REAL(SP), DIMENSION(nspec), INTENT(in) :: csp1,csp2
       TYPE(PARAMS), INTENT(in) :: pset
       REAL(SP), DIMENSION(nspec), INTENT(out) :: specdust
       REAL(SP), DIMENSION(nemline), INTENT(in) :: ncsp1,ncsp2
       REAL(SP), DIMENSION(nemline), INTENT(out) :: nebdust
     END SUBROUTINE ADD_DUST
  END INTERFACE

  INTERFACE
     SUBROUTINE ADD_NEBULAR(pset,sspi,sspo,nebemline)
       USE sps_vars
       TYPE(PARAMS), INTENT(in) :: pset
       REAL(SP), INTENT(in), DIMENSION(nspec,ntfull)    :: sspi
       REAL(SP), INTENT(inout), DIMENSION(nspec,ntfull) :: sspo
       REAL(SP), INTENT(inout), DIMENSION(nemline,ntfull), OPTIONAL :: nebemline

     END SUBROUTINE ADD_NEBULAR
  END INTERFACE

  INTERFACE
     SUBROUTINE ADD_REMNANTS(mass,maxmass)
       USE sps_vars
       REAL(SP), INTENT(inout) :: mass
       REAL(SP), INTENT(in) :: maxmass
     END SUBROUTINE ADD_REMNANTS
  END INTERFACE

  INTERFACE
     FUNCTION AGN_DUST(lam,spec,pset,lbol_csp)
       USE sps_vars
       REAL(SP), DIMENSION(nspec), INTENT(in) :: lam,spec
       REAL(SP), INTENT(in) :: lbol_csp
       TYPE(PARAMS), INTENT(in) :: pset
       REAL(SP), DIMENSION(nspec) :: agn_dust
     END FUNCTION AGN_DUST
  END INTERFACE

  INTERFACE
     FUNCTION AIRTOVAC(lam)
       USE sps_vars
       REAL(SP), DIMENSION(:), INTENT(in) :: lam
       REAL(SP), DIMENSION(SIZE(lam)) :: airtovac
     END FUNCTION AIRTOVAC
  END INTERFACE

 INTERFACE
     FUNCTION ATTN_CURVE(lambda,dtype,pset)
       USE sps_vars
       INTEGER, INTENT(in) :: dtype
       REAL(SP), INTENT(in), DIMENSION(nspec) :: lambda
       TYPE(PARAMS), INTENT(in) :: pset
       REAL(SP), DIMENSION(nspec) :: attn_curve
     END FUNCTION ATTN_CURVE
  END INTERFACE

  INTERFACE
     SUBROUTINE COMPSP(write_compsp,nzin,outfile,mass_ssp,&
          lbol_ssp,spec_ssp,pset,ocompsp)
       USE sps_vars
       INTEGER, INTENT(in) :: write_compsp,nzin
       REAL(SP), INTENT(in), DIMENSION(ntfull,nzin) :: lbol_ssp,mass_ssp
       REAL(SP), INTENT(in), DIMENSION(nspec,ntfull,nzin) :: spec_ssp
       CHARACTER(100), INTENT(in) :: outfile
       TYPE(PARAMS), INTENT(in)   :: pset
       TYPE(COMPSPOUT), INTENT(inout), DIMENSION(ntfull) :: ocompsp
     END SUBROUTINE COMPSP
  END INTERFACE

  INTERFACE
     SUBROUTINE COMPSP_GRID(pset,nti,specout)
       USE sps_vars
       TYPE(PARAMS), INTENT(in) :: pset
       INTEGER, INTENT(in) :: nti
       REAL(SP), DIMENSION(nspec), INTENT(inout) :: specout
     END SUBROUTINE COMPSP_GRID
  END INTERFACE

  INTERFACE
     SUBROUTINE CSP_GEN(mass_ssp, lbol_ssp, spec_ssp, pset, tage, nzin,&
                        mass_csp, lbol_csp, spec_csp, mdust_csp,emlin_ssp,emlin_csp)
       USE sps_vars
       REAL(SP), DIMENSION(ntfull), INTENT(in) :: mass_ssp, lbol_ssp
       REAL(SP), DIMENSION(nspec, ntfull), INTENT(in) :: spec_ssp
       TYPE(PARAMS), intent(in) :: pset
       REAL(SP), INTENT(in)  :: tage
       INTEGER, INTENT(IN) :: nzin
       REAL(SP), INTENT(out) :: mass_csp, lbol_csp, mdust_csp
       REAL(SP), INTENT(out), DIMENSION(nspec) :: spec_csp
       REAL(SP), DIMENSION(nemline, ntfull, nzin), intent(in) :: emlin_ssp
       REAL(SP), DIMENSION(nemline), intent(out) :: emlin_csp
     END SUBROUTINE CSP_GEN
  END INTERFACE

  INTERFACE
     FUNCTION FUNCINT(func,a,b)
       USE sps_vars
       REAL(SP), INTENT(IN) :: a,b
       REAL(SP) :: funcint
       INTERFACE
          FUNCTION func(x)
            USE sps_vars
            REAL(SP), DIMENSION(:), INTENT(IN) :: x
            REAL(SP), DIMENSION(SIZE(x)) :: func
          END FUNCTION func
       END INTERFACE
     END FUNCTION FUNCINT
  END INTERFACE

  INTERFACE
     SUBROUTINE GETZMET(smass,pos)
       USE sps_vars
       REAL(SP), INTENT(in) :: smass
       TYPE(PARAMS), INTENT(inout) :: pos
     END SUBROUTINE GETZMET
  END INTERFACE

  INTERFACE
     SUBROUTINE GETINDX(lambda,spec,indices)
       USE sps_vars
       REAL(SP), INTENT(in), DIMENSION(nspec) :: spec,lambda
       REAL(SP), INTENT(inout), DIMENSION(nindx) :: indices
     END SUBROUTINE GETINDX
  END INTERFACE

  INTERFACE
     FUNCTION GET_TUNIV(z)
       USE sps_vars
       REAL(SP), INTENT(in) :: z
       REAL(SP) :: get_tuniv
     END FUNCTION GET_TUNIV
  END INTERFACE
 
  INTERFACE
     FUNCTION GET_LUMDIST(z)
       USE sps_vars
       REAL(SP), INTENT(in) :: z
       REAL(SP) :: get_lumdist
     END FUNCTION GET_LUMDIST
  END INTERFACE
  
  INTERFACE
     SUBROUTINE GETMAGS(zred,spec,mags,mag_compute)
       USE sps_vars
       REAL(SP), INTENT(in) :: zred
       REAL(SP), INTENT(inout), DIMENSION(nspec) :: spec
       REAL(SP), DIMENSION(nbands) :: mags
       INTEGER, DIMENSION(nbands), INTENT(in), OPTIONAL  :: mag_compute
     END SUBROUTINE GETMAGS
  END INTERFACE
  
  INTERFACE
     SUBROUTINE GETSPEC(pset,mact,logt,lbol,logg,phase,ffco,lmdot,wght,spec)
       USE sps_vars
       REAL(SP), INTENT(in) :: mact,logt,lbol,logg,phase,ffco,wght,lmdot
       TYPE(PARAMS), INTENT(in) :: pset
       REAL(SP), INTENT(inout), DIMENSION(nspec) :: spec 
     END SUBROUTINE GETSPEC
  END INTERFACE

  INTERFACE
     FUNCTION IGM_ABSORB(lam,spec,zz,factor)
       USE sps_vars
       REAL(SP), DIMENSION(nspec), INTENT(in) :: lam,spec
       REAL(SP), INTENT(in) :: zz,factor
       REAL(SP), DIMENSION(nspec) :: igm_absorb
     END FUNCTION IGM_ABSORB
  END INTERFACE

  INTERFACE
     FUNCTION INTIND(lam,func,lo,hi)
       USE sps_vars
       REAL(SP), INTENT(in), DIMENSION(nspec) :: lam,func
       REAL(SP), INTENT(in) :: lo,hi
       REAL(SP) :: intind
     END FUNCTION INTIND
  END INTERFACE

  INTERFACE
     FUNCTION INTSFWGHT(sspind, logt, sfh)
       USE sps_vars
       TYPE(SFHPARAMS), INTENT(in) :: sfh
       INTEGER, INTENT(in) :: sspind
       REAL(SP), DIMENSION(2), INTENT(in) :: logt
       REAL(SP) :: intsfwght
     END FUNCTION INTSFWGHT
  END INTERFACE

  INTERFACE
     FUNCTION IMF(mass)
       USE sps_vars
       REAL(SP), DIMENSION(:), INTENT(in) :: mass
       REAL(SP), DIMENSION(size(mass)) :: imf
     END FUNCTION IMF
  END INTERFACE 

  INTERFACE
     SUBROUTINE IMF_WEIGHT(mini,wght,nmass)
       USE sps_vars
       REAL(SP), INTENT(inout), DIMENSION(nm) :: wght
       REAL(SP), INTENT(in), DIMENSION(nm)    :: mini
       INTEGER, INTENT(in) :: nmass
     END SUBROUTINE IMF_WEIGHT
  END INTERFACE 

  INTERFACE
     FUNCTION LINTERP(xin,yin,xout)
       USE sps_vars
       REAL(SP), DIMENSION(:), INTENT(in) :: xin,yin
       REAL(SP), INTENT(in)  :: xout
       REAL(SP) :: linterp
     END FUNCTION LINTERP
  END INTERFACE

  INTERFACE
     FUNCTION LINTERPARR(xin,yin,xout)
       USE sps_vars
       REAL(SP), DIMENSION(:), INTENT(in) :: xin,yin
       REAL(SP), INTENT(in), DIMENSION(:) :: xout
       REAL(SP), DIMENSION(SIZE(xout)) :: linterparr
     END FUNCTION LINTERPARR
  END INTERFACE

  INTERFACE
     FUNCTION LOCATE(xx,x)
       USE sps_vars
       REAL(SP), DIMENSION(:), INTENT(IN) :: xx
       REAL(SP), INTENT(IN) :: x
       INTEGER :: locate
     END FUNCTION LOCATE
  END INTERFACE

  INTERFACE
     SUBROUTINE MOD_GB(zz,t,age,delt,dell,pagb,redgb,agb,&
          nn,logl,logt,phase,wght)
       USE sps_vars
       INTEGER,  INTENT(in) :: t, nn,zz
       REAL(SP), INTENT(inout), DIMENSION(nt,nm) :: logl,logt
       REAL(SP), INTENT(in), DIMENSION(nt,nm)    :: phase
       REAL(SP), INTENT(inout), DIMENSION(nm)    :: wght
       REAL(SP), INTENT(in) :: delt, dell, pagb,redgb, agb
       REAL(SP), INTENT(in), DIMENSION(nt) :: age
     END SUBROUTINE MOD_GB
  END INTERFACE

  INTERFACE
     SUBROUTINE MOD_HB(f_bhb,t,mini,mact,logl,logt,logg,phase, &
          wght,hb_wght,nmass,hbtime)
       USE sps_vars
       REAL(SP), INTENT(inout), DIMENSION(nt,nm) :: mini,mact,&
            logl,logt,logg,phase
       REAL(SP), INTENT(inout), DIMENSION(nm) :: wght
       REAL(SP), DIMENSION(nm) :: tphase=0.0
       INTEGER, INTENT(inout), DIMENSION(nt) :: nmass
       REAL(SP), INTENT(inout) :: hb_wght
       INTEGER, INTENT(in) :: t
       REAL(SP), INTENT(in) :: f_bhb, hbtime
     END SUBROUTINE MOD_HB
  END INTERFACE

  INTERFACE
     SUBROUTINE SBF(pset,outfile)
       USE sps_vars
       CHARACTER(100), INTENT(in) :: outfile
       TYPE(PARAMS), INTENT(in)    :: pset
     END SUBROUTINE SBF
  END INTERFACE

  INTERFACE
     SUBROUTINE SETUP_TABULAR_SFH(pset, nzin)
       USE sps_vars
       TYPE(PARAMS), INTENT(in) :: pset
       INTEGER, INTENT(in) :: nzin
     END SUBROUTINE SETUP_TABULAR_SFH
  END INTERFACE

  INTERFACE
     SUBROUTINE SFHINFO(pset, age, mfrac, sfr, frac_linear)
       USE sps_vars
       TYPE(PARAMS), INTENT(in) :: pset
       REAL(SP), INTENT(in) :: age
       REAL(SP), INTENT(out) :: mfrac, sfr, frac_linear
     END SUBROUTINE SFHINFO
  END INTERFACE

  INTERFACE
     FUNCTION SFHLIMIT(tlim, sfh)
       USE sps_vars
       TYPE(SFHPARAMS), INTENT(in) :: sfh
       REAL(SP), INTENT(in) :: tlim
       REAL(SP) :: sfhlimit
     END FUNCTION SFHLIMIT
  END INTERFACE

  INTERFACE
     FUNCTION SFH_WEIGHT(sfh, imin, imax)
       USE sps_vars
       TYPE(SFHPARAMS), INTENT(in) :: sfh
       INTEGER, INTENT(in) :: imin, imax
       REAL(SP), DIMENSION(ntfull) :: sfh_weight
     END FUNCTION SFH_WEIGHT
  END INTERFACE

  INTERFACE
     FUNCTION TSUM(xin,yin)
       USE sps_vars
       REAL(SP), DIMENSION(:), INTENT(in) :: xin,yin
       REAL(SP) :: tsum
     END FUNCTION TSUM
  END INTERFACE

  INTERFACE
     SUBROUTINE SMOOTHSPEC(lambda,spec,sigma,minl,maxl,ires)
       USE sps_vars
       REAL(SP), INTENT(inout), DIMENSION(nspec) :: spec
       REAL(SP), INTENT(in), DIMENSION(nspec) :: lambda
       REAL(SP), INTENT(in), DIMENSION(nspec), OPTIONAL :: ires
       REAL(SP), INTENT(in) :: sigma,minl,maxl
     END SUBROUTINE SMOOTHSPEC
  END INTERFACE

  INTERFACE
     FUNCTION VACTOAIR(lam)
       USE sps_vars
       REAL(SP), DIMENSION(:), INTENT(in) :: lam
       REAL(SP), DIMENSION(SIZE(lam)) :: vactoair
     END FUNCTION VACTOAIR
  END INTERFACE

  INTERFACE
     SUBROUTINE WRITE_ISOCHRONE(outfile,pset)
       USE sps_vars
       TYPE(PARAMS), INTENT(in) :: pset
       CHARACTER(100), INTENT(in)  :: outfile
     END SUBROUTINE WRITE_ISOCHRONE
  END INTERFACE

  INTERFACE
     SUBROUTINE ZTINTERP(zpos,spec,lbol,mass,tpos,zpow)
       USE sps_vars
       REAL(SP),INTENT(in) :: zpos
       REAL(SP),INTENT(in), OPTIONAL :: tpos,zpow
       REAL(SP),INTENT(inout),DIMENSION(:) :: mass, lbol
       REAL(SP),INTENT(inout),DIMENSION(:,:) :: spec
     END SUBROUTINE ZTINTERP
  END INTERFACE

END MODULE SPS_UTILS

SUBROUTINE GETMAGS(zred,spec,mags,mag_compute)

  !routine to calculate magnitudes in the Vega or AB systems,
  !given an input spectrum and redshift.
  !see parameter compute_vega_mags in sps_vars.f90
  !magnitudes defined in accordance with Fukugita et al. 1996, Eqn 7
  !This routine also redshifts the spectrum, if necessary.

  USE sps_vars; USE sps_utils, ONLY : linterp, tsum
  IMPLICIT NONE

  INTEGER  :: i
  REAL(SP), INTENT(in) :: zred
  REAL(SP), INTENT(inout), DIMENSION(nspec) :: spec
  REAL(SP), INTENT(inout), DIMENSION(nbands) :: mags
  INTEGER, DIMENSION(nbands), INTENT(in), OPTIONAL  :: mag_compute
  INTEGER, DIMENSION(nbands) :: magflag
  REAL(SP), DIMENSION(nspec)  :: tspec
  REAL(SP) :: const, dm

  !-----------------------------------------------------------!
  !-----------------------------------------------------------!

  mags = 99.
  const= 0.0

  !set up the flags determining which mags are computed
  IF (PRESENT(mag_compute)) THEN
     magflag = mag_compute
     IF (compute_vega_mags.EQ.1) &
          magflag(1) = 1  !force V band to be computed
     IF (MAXVAL(magflag).EQ.0) & !no mags being computed so exit
          RETURN
  ELSE
     magflag = 1
  ENDIF

  !redshift the spectrum
  IF (ABS(zred).GT.tiny_number) THEN
     !write(*,*) "getmags: interpolating"
     DO i=1,nspec
        tspec(i) = MAX(linterp(spec_lambda*(1+zred),spec,&
                       spec_lambda(i)),0.0)
     ENDDO

     !compute additional terms for cosmological mags
     dm    = 5*LOG10(linterp(cosmospl(:,1),cosmospl(:,3),zred)/10.)
     const = dm - 2.5*LOG10(1+zred)

  ELSE

     tspec = spec

  ENDIF

  !integrate over each filter
  DO i=1,nbands
     IF (magflag(i).EQ.0) CYCLE
     mags(i) = TSUM(spec_lambda,tspec*bands(:,i)/spec_lambda)
     IF (mags(i).LE.tiny_number) THEN
        mags(i) = 99.0
     ELSE
        IF (compute_light_ages.EQ.0) THEN
           !the mag2cgs var converts from Lsun/Hz to cgs at 10pc
           mags(i) = -2.5*LOG10(mags(i)) - 48.60 - 2.5*mag2cgs + const
        ENDIF
     ENDIF
  ENDDO

  !put magnitudes in the Vega system if keyword is set
  !(V-band is the first element in the array)
  IF (compute_vega_mags.EQ.1.AND.compute_light_ages.EQ.0) &
       mags(2:nbands) = (mags(2:nbands)-mags(1)) - &
       (magvega(2:nbands)-magvega(1)) + mags(1)


END SUBROUTINE GETMAGS

FUNCTION AGN_DUST(lam,spec,pset,lbol_csp)

  USE sps_vars; USE sps_utils, ONLY: locate,attn_curve
  IMPLICIT NONE

  REAL(SP), DIMENSION(nspec), INTENT(in) :: lam,spec
  REAL(SP), INTENT(in)       :: lbol_csp
  TYPE(PARAMS), INTENT(in)   :: pset
  REAL(SP), DIMENSION(nspec) :: agn_dust,agnspeci
  INTEGER  :: jlo
  REAL(SP) :: dj
 
  !--------------------------------------------------------------!

  !interpolate in tau_agn
  jlo = MIN(MAX(locate(agndust_tau,pset%agn_tau),1),&
       nagndust-1)
  dj  = (pset%agn_tau-agndust_tau(jlo)) / &
       (agndust_tau(jlo+1)-agndust_tau(jlo))
  dj  = MAX(MIN(dj,1.0),0.0) !no extrapolation

  agnspeci  = (1-dj)*agndust_spec(:,jlo) + dj*agndust_spec(:,jlo+1)

  !attenuate the AGN emission by the diffuse dust
  agnspeci = agnspeci*EXP(-attn_curve(spec_lambda,dust_type,pset))

  agn_dust = spec + 10**lbol_csp*pset%fagn*agnspeci


END FUNCTION AGN_DUST
  

SUBROUTINE SPS_SETUP(zin)

  !read in isochrones and spectral libraries for all metallicities.
  !read in band-pass info and the spectrum for Vega.
  !Arrays are stored in a common block defined in sps_vars.f90

  !If zin=-1 then all metallicities are read in, otherwise only the
  !metallicity corresponding to zin in the look-up table zlegend.dat
  !is read.  Specifying only the metallicity of interest results
  !in a much faster setup.

  USE sps_vars; USE sps_utils
  IMPLICIT NONE
  INTEGER, INTENT(in) :: zin
  INTEGER :: stat=1,n,i,j,m,jj,k,i1,i2
  INTEGER, PARAMETER :: ntlam=1221,nspec_agb=6146,nspec_aringer=9032
  INTEGER, PARAMETER :: nlamwr=1963,nspec_pagb=9281
  INTEGER, PARAMETER :: nzwmb=12, nspec_wmb=5508
  INTEGER :: n_isoc,z,zmin,zmax,nlam
  CHARACTER(1) :: char,sqpah
  CHARACTER(6) :: zstype
  CHARACTER(5) :: zstype5
  REAL(SP) :: dumr1,d1,d2,logage,x,a,zero=0.0,d,one=1.0,dz,dlam
  CHARACTER(5), DIMENSION(nz) :: zlegend_str=''
  REAL(SP), DIMENSION(nspec) :: tspec=0.
  REAL(SP), DIMENSION(ntlam) :: tvega_lam=0.,tvega_spec=0.
  REAL(SP), DIMENSION(ntlam) :: tsun_lam=0.,tsun_spec=0.
  REAL(SP), DIMENSION(nlamwr) :: tlamwr=0.,tspecwr=0.
  REAL(SP), DIMENSION(nlamwr,ndim_wr,5) :: twrc=0.,twrn=0.
  REAL(SP), DIMENSION(5) :: twrzmet=0.
  REAL(SP), DIMENSION(50000) :: readlamb=0.,readband=0.
  REAL(SP), DIMENSION(25) :: wglam=0.
  REAL(SP), DIMENSION(25,18,2,6) :: wgtmp=0.
  REAL(SP), DIMENSION(10000) :: lambda_dagb=0.,fluxin_dagb=0.
  REAL(SP), DIMENSION(14) :: lami=0.
  INTEGER,  DIMENSION(14) :: ind
  REAL(SP), DIMENSION(nlam_nebcont) :: readlambneb=0.,readcontneb=0.
  REAL(SP), DIMENSION(22,n_agb_o)   :: tagb_logt_o
  REAL(SP), DIMENSION(22)           :: tagb_logz_o
  REAL(SP), DIMENSION(nspec_pagb) :: pagb_lam=0.0
  REAL(SP), DIMENSION(nspec_pagb,ndim_pagb,2) :: pagb_specinit=0.
  REAL(SP), DIMENSION(nspec_agb)  :: agb_lam=0.0
  REAL(SP), DIMENSION(nspec_aringer)  :: aringer_lam=0.0
  REAL(SP), DIMENSION(nspec_agb,n_agb_o) :: agb_specinit_o=0.
  REAL(SP), DIMENSION(nspec_agb,n_agb_c) :: agb_specinit_c=0.
  REAL(SP), DIMENSION(nspec_aringer,n_agb_car) :: aringer_specinit=0.
  REAL(SP), DIMENSION(nagndust_spec)           :: agndust_lam=0.
  REAL(SP), DIMENSION(nagndust_spec,nagndust)  :: agndust_specinit=0.
  REAL(KIND(1.0)), DIMENSION(nspec,nzinit,ndim_logt,ndim_logg) :: speclibinit=0.
  REAL(SP), DIMENSION(nspec,nzwmb,ndim_wmb_logt,ndim_wmb_logg) :: wmbsi=0.
  REAL(SP), DIMENSION(nzwmb)     :: zwmb=0.
  REAL(SP), DIMENSION(nspec_wmb) :: wmb_lam=0.
  REAL(SP), DIMENSION(nspec_wmb,ndim_wmb_logt,ndim_wmb_logg) :: wmb_specinit=0.
  REAL(SP), DIMENSION(ntabmax)   :: lsflam=0.,lsfsig=0.

  !---------------------------------------------------------------!
  !---------------------------------------------------------------!

  IF (verbose.EQ.1) THEN 
     WRITE(*,*) 
     WRITE(*,*) '    Setting up SPS...'
  ENDIF

  IF (zin.GT.nz) THEN
     WRITE(*,*) 'SPS_SETUP ERROR: zin GT nz', zin,nz
     STOP
  ENDIF

  !clean out all the common block arrays
  mini_isoc     = 0.
  mact_isoc     = 0.
  logl_isoc     = 0.
  logt_isoc     = 0.
  logg_isoc     = 0.
  ffco_isoc     = 0.
  phase_isoc    = 0.
  nmass_isoc    = 0
  timestep_isoc = 0.
  spec_lambda   = 0.
  vega_spec     = 0.
  sun_spec      = 0.
  speclib       = 0.
  speclib_logg  = 0.
  speclib_logt  = 0.
  agb_spec_o    = 0.
  agb_logt_o    = 0.
  agb_spec_c    = 0.
  agb_logt_c    = 0.
  n_isoc        = 0
  m             = 1

 
  !----------------------------------------------------------------!
  !--------------Confirm that variables are properly set-----------!
  !----------------------------------------------------------------!
 
  CALL getenv('SPS_HOME',SPS_HOME)
  IF (LEN_TRIM(SPS_HOME).EQ.0) THEN
     WRITE(*,*) 'SPS_SETUP ERROR: spsdir environment variable not set!'
     STOP
  ENDIF

  IF (basel_str.NE.'pdva'.AND.basel_str.NE.'wlbc') THEN
     WRITE(*,*) 'SPS_SETUP ERROR: basel_str var set to invalid type: ',basel_str
     STOP
  ENDIF

  !----------------------------------------------------------------!
  !----------------Read in metallicity values----------------------!
  !----------------------------------------------------------------!

  !units are simply metal fraction by mass (e.g. Z=0.0190 for Zsun)
  IF (isoc_type.EQ.'pdva') THEN
     OPEN(90,FILE=TRIM(SPS_HOME)//'/ISOCHRONES/Padova/Padova2007/zlegend'//&
          '.dat',STATUS='OLD',iostat=stat,ACTION='READ')
  ELSE IF (isoc_type.EQ.'prsc') THEN
     OPEN(90,FILE=TRIM(SPS_HOME)//'/ISOCHRONES/PARSEC/zlegend'//&
          '.dat',STATUS='OLD',iostat=stat,ACTION='READ')
  ELSE IF (isoc_type.EQ.'bsti') THEN
     OPEN(90,FILE=TRIM(SPS_HOME)//'/ISOCHRONES/BaSTI/zlegend'//&
          '.dat',STATUS='OLD',iostat=stat,ACTION='READ')
  ELSE IF (isoc_type.EQ.'mist') THEN
     OPEN(90,FILE=TRIM(SPS_HOME)//'/ISOCHRONES/MIST/zlegend'//&
          '.dat',STATUS='OLD',iostat=stat,ACTION='READ')
  ELSE IF (isoc_type.EQ.'bpss') THEN
     OPEN(90,FILE=TRIM(SPS_HOME)//'/ISOCHRONES/BPASS/zlegend'//&
          '.dat',STATUS='OLD',iostat=stat,ACTION='READ')
  ELSE IF (isoc_type.EQ.'gnva') THEN
     OPEN(90,FILE=TRIM(SPS_HOME)//'/ISOCHRONES/Geneva/zlegend'//&
          '.dat',STATUS='OLD',iostat=stat,ACTION='READ')
  ENDIF
  IF (stat.NE.0) THEN
     WRITE(*,*) 'SPS_SETUP ERROR: zlegend.dat cannot be opened'
     STOP 
  ENDIF

  IF (isoc_type.EQ.'mist') THEN
     DO z=1,nz
        READ(90,'(A5)') zlegend_str(z)
        zstype5 = zlegend_str(z)
        READ(zstype5(2:5),'(F4.2)') zlegend(z)
        IF (zstype5(1:1).EQ.'m') THEN
           zlegend(z) = 10**(-1*zlegend(z)) * zsol
        ELSE
           zlegend(z) = 10**(1*zlegend(z)) * zsol
        ENDIF
     ENDDO
  ELSE
     DO z=1,nz
        READ(90,'(F6.4)') zlegend(z)
     ENDDO
  ENDIF

  CLOSE(90)

  !C3K hack
  !zlegend_str(1) = 'p0.00'
  !zlegend(1) = 0.0134

  IF (zin.LE.0) THEN
     zmin = 1
     zmax = nz
  ELSE
     zmin = zin
     zmax = zin
  ENDIF

  !----------------------------------------------------------------!
  !---------------------Read in BPASS SSPs-------------------------!
  !----------------------------------------------------------------!

  IF (isoc_type.EQ.'bpss') THEN

     IF (time_res_incr.NE.1) THEN
        WRITE(*,*) 'SPS_SETUP ERROR: cannot have time_res_incr>1 w/ BPASS models'
        STOP
     ENDIF
     
     OPEN(91,FILE=TRIM(SPS_HOME)//'/ISOCHRONES/BPASS/bpass.lambda',&
          STATUS='OLD',iostat=stat,ACTION='READ')
     IF (stat.NE.0) THEN
        WRITE(*,*) 'SPS_SETUP ERROR: wavelength grid cannot be opened'
        STOP 
     ENDIF
     DO i=1,nspec
        READ(91,*) spec_lambda(i)
     ENDDO
     CLOSE(91)

     OPEN(92,FILE=TRIM(SPS_HOME)//'/ISOCHRONES/BPASS/bpass.mass',&
          STATUS='OLD',iostat=stat,ACTION='READ')
     IF (stat.NE.0) THEN
        WRITE(*,*) 'SPS_SETUP ERROR: wavelength grid cannot be opened'
        STOP 
     ENDIF
     DO i=1,nt
        READ(92,*) time_full(i),bpass_mass_ssp(i,:)
     ENDDO
     CLOSE(92)

     OPEN(93,FILE=TRIM(SPS_HOME)//'/ISOCHRONES/BPASS/bpass_v2.2_salpeter100'&
          //'.ssp.bin',FORM='UNFORMATTED',&
          STATUS='OLD',iostat=stat,ACTION='READ',access='direct',&
          recl=nspec*nt*nz*8)
     IF (stat.NE.0) THEN 
        WRITE(*,*) 'SPS_SETUP ERROR: failed to find bpass ssp models'
        STOP 
     ENDIF

     READ(93,rec=1) bpass_spec_ssp
     CLOSE(93)

  ENDIF
  
  !----------------------------------------------------------------!
  !-----------------Read in spectral libraries---------------------!
  !----------------------------------------------------------------!

  IF (isoc_type.NE.'bpss') THEN
  
  !read in wavelength array and spectral metallicity grid
  IF (spec_type.EQ.'basel') THEN
     OPEN(91,FILE=TRIM(SPS_HOME)//'/SPECTRA/BaSeL3.1/basel.lambda',&
          STATUS='OLD',iostat=stat,ACTION='READ')
     OPEN(93,FILE=TRIM(SPS_HOME)//'/SPECTRA/BaSeL3.1/zlegend.dat',&
          STATUS='OLD',iostat=stat,ACTION='READ')
  ELSE IF (spec_type.EQ.'miles') THEN
     OPEN(91,FILE=TRIM(SPS_HOME)//'/SPECTRA/MILES/miles.lambda',&
          STATUS='OLD',iostat=stat,ACTION='READ')
     OPEN(93,FILE=TRIM(SPS_HOME)//'/SPECTRA/MILES/zlegend.dat',&
          STATUS='OLD',iostat=stat,ACTION='READ')
  ELSE IF (spec_type(1:5).EQ.'ckc14') THEN
     OPEN(91,FILE=TRIM(SPS_HOME)//'/SPECTRA/CKC14/'//spec_type//'.lambda',&
          STATUS='OLD',iostat=stat,ACTION='READ')
     OPEN(93,FILE=TRIM(SPS_HOME)//'/SPECTRA/CKC14/zlegend.dat',&
          STATUS='OLD',iostat=stat,ACTION='READ')
  ENDIF
  IF (stat.NE.0) THEN
     WRITE(*,*) 'SPS_SETUP ERROR: wavelength grid cannot be opened'
     STOP 
  ENDIF
  DO i=1,nspec
     READ(91,*) spec_lambda(i)
  ENDDO
  CLOSE(91)

  !read in primary logg and logt arrays
  !NB: these are the same for all spectral libraries
  OPEN(91,FILE=TRIM(SPS_HOME)//'/SPECTRA/BaSeL3.1/basel_logt.dat',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  DO i=1,ndim_logt
     READ(91,*) speclib_logt(i)
  ENDDO
  CLOSE(91)
  OPEN(91,FILE=TRIM(SPS_HOME)//'/SPECTRA/BaSeL3.1/basel_logg.dat',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  DO i=1,ndim_logg
     READ(91,*) speclib_logg(i)
  ENDDO
  CLOSE(91)

  !read in each metallicity
  DO z=1,nzinit

     READ(93,*) zlegendinit(z)
     !zlegendinit(z) = zlegend(1) !C3K hack
     WRITE(zstype,'(F6.4)') zlegendinit(z)

     !read in the spectral library
     IF (spec_type.EQ.'basel') THEN
        OPEN(92,FILE=TRIM(SPS_HOME)//'/SPECTRA/BaSeL3.1/basel_'//basel_str//&
             '_z'//zstype//'.spectra.bin',FORM='UNFORMATTED',&
             STATUS='OLD',iostat=stat,ACTION='READ',access='direct',&
             recl=nspec*ndim_logg*ndim_logt*4)
     ELSE IF (spec_type.EQ.'miles') THEN
        OPEN(92,FILE=TRIM(SPS_HOME)//'/SPECTRA/MILES/imiles_z'&
             //zstype//'.spectra.bin',FORM='UNFORMATTED',&
             STATUS='OLD',iostat=stat,ACTION='READ',access='direct',&
             recl=nspec*ndim_logg*ndim_logt*4)
     ELSE IF (spec_type(1:5).EQ.'ckc14') THEN
        OPEN(92,FILE=TRIM(SPS_HOME)//'/SPECTRA/CKC14/'//spec_type//'_z'&
             //zstype//'.spectra.bin',FORM='UNFORMATTED',&
             STATUS='OLD',iostat=stat,ACTION='READ',access='direct',&
             recl=nspec*ndim_logg*ndim_logt*4)
     ENDIF
     IF (stat.NE.0) THEN 
        WRITE(*,*) 'SPS_SETUP ERROR: '//spec_type//&
             ' spectral library cannot be opened Z=', zstype
        IF (spec_type(1:5).EQ.'ckc14') THEN
           WRITE(*,*) 'you are attempting to use the CKC14 grid but you'//&
                ' seem to not have the files.  Download them here XXX, and '//&
                'put them in the SPECTRA/CKC14/ directory (not available yet!)'
        ENDIF
        STOP 
     ENDIF

     READ(92,rec=1) speclibinit(:,z,:,:)
     CLOSE(92)

  ENDDO

  CLOSE(93)

  !interpolate the input spectral library to the isochrone grid
  !notice that we're interpolating at fixed Z/Zsol even in cases
  !where the isochrones and spectra might have different Zsol. This might 
  !in fact be the best thing to do.  Either way, its not ideal.
  DO z=1,nz

     i1 = MIN(MAX(locate(LOG10(zlegendinit/zsol_spec),&
          LOG10(zlegend(z)/zsol)),1),nzinit-1)
     dz = (LOG10(zlegend(z)/zsol)-LOG10(zlegendinit(i1)/zsol_spec)) / &
          (LOG10(zlegendinit(i1+1)/zsol_spec)-LOG10(zlegendinit(i1)/zsol_spec))
     dz = MIN(MAX(dz,0.0),1.0) !no extrapolation!

     speclib(:,z,:,:) = (1-dz)*LOG10(speclibinit(:,i1,:,:)+tiny_number) + &
          dz*LOG10(speclibinit(:,i1+1,:,:)+tiny_number)
     speclib(:,z,:,:) = 10**speclib(:,z,:,:)

  ENDDO

  !--------------Read WMBasic Grid from JJ Eldridge----------------;

  !read in Teff array
  OPEN(93,FILE=TRIM(SPS_HOME)//'/SPECTRA/Hot_spectra/WMBASIC.teff',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  IF (stat.NE.0) THEN
     WRITE(*,*) 'SPS_SETUP ERROR: /SPECTRA/Hot_spectra/'//&
          'WMBASIC.teff cannot be opened'
     STOP 
  ENDIF
  DO i=1,ndim_wmb_logt
     READ(93,*) wmb_logt(i)
  ENDDO
  CLOSE(93)

  !logg for WMB grid
  wmb_logg = (/3.5,4.0,4.5/)

  OPEN(93,FILE=TRIM(SPS_HOME)//'/SPECTRA/Hot_spectra/WMBASIC_zlegend.dat',&
       STATUS='OLD',iostat=stat,ACTION='READ')

  DO z=1,nzwmb

     READ(93,*) zwmb(z)
     WRITE(zstype,'(F6.4)') zwmb(z)

     OPEN(95,FILE=TRIM(SPS_HOME)//'/SPECTRA/Hot_spectra/WMBASIC_z'//&
          zstype//'.spec',STATUS='OLD',iostat=stat,ACTION='READ')
     IF (stat.NE.0) THEN
        WRITE(*,*) 'SPS_SETUP ERROR: /Hot_spectra/'//&
          'WMBASIC_z'//zstype//'.spec '//'cannot be opened'
        STOP 
     ENDIF
     DO i=1,nspec_wmb
        READ(95,*) wmb_lam(i),wmb_specinit(i,:,1),wmb_specinit(i,:,2),&
             wmb_specinit(i,:,3)
     ENDDO
     CLOSE(95)

     !interpolate to the main spectral grid
     !NB: should be smoothing the models first to the resolution of the
     !input spectral grid
     DO i=1,ndim_wmb_logt
        DO j=1,ndim_wmb_logg
           wmbsi(:,z,i,j) = MAX(linterparr(wmb_lam,wmb_specinit(:,i,j),&
                spec_lambda),tiny_number)
        ENDDO
     ENDDO

  ENDDO

  CLOSE(93)

  !Now interpolate the input spectral library to the isochrone grid
  !notice that we're interpolating at fixed Z/Zsol even in cases
  !where the isochrones and spectra might have different Zsol. This might 
  !in fact be the best thing to do.  Either way, its not ideal.
  DO z=1,nz

     i1 = MIN(MAX(locate(LOG10(zwmb/zsol_spec),&
          LOG10(zlegend(z)/zsol)),1),nzwmb-1)
     dz = (LOG10(zlegend(z)/zsol)-LOG10(zwmb(i1)/zsol_spec)) / &
          (LOG10(zwmb(i1+1)/zsol_spec)-LOG10(zwmb(i1)/zsol_spec))

     wmb_spec(:,z,:,:) = (1-dz)*LOG10(wmbsi(:,i1,:,:)+tiny_number) + &
          dz*LOG10(wmbsi(:,i1+1,:,:)+tiny_number)
     wmb_spec(:,z,:,:) = 10**wmb_spec(:,z,:,:)

  ENDDO

  !-----------Read in TP-AGB Library from Lancon & Wood------------;

  !read in AGB Teff array for O-rich spectra
  OPEN(93,FILE=TRIM(SPS_HOME)//'/SPECTRA/AGB_spectra/Orich.teff',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  IF (stat.NE.0) THEN
     WRITE(*,*) 'SPS_SETUP ERROR: /SPECTRA/AGB_spectra/'//&
          'Orich.teff cannot be opened'
     STOP 
  ENDIF
  !burn the header
  READ(93,*) char
  READ(93,*) dumr1, tagb_logz_o
  DO i=1,n_agb_o
     READ(93,*) dumr1, tagb_logt_o(:,i)
  ENDDO
  CLOSE(93)

  !now interpolate the master Teff array to the particular Z array
  DO i=1,nz
     i1 = MIN(MAX(locate(tagb_logz_o,LOG10(zlegend(i)/zsol_spec)),1),22-1)
     dz = (LOG10(zlegend(i)/zsol_spec)-tagb_logz_o(i1)) / &
          (tagb_logz_o(i1+1)-tagb_logz_o(i1))
     agb_logt_o(i,:) = (1-dz)*tagb_logt_o(i1,:)+dz*tagb_logt_o(i1+1,:)

  ENDDO
  agb_logt_o = LOG10(agb_logt_o)

  !read in AGB Teff array for C-rich spectra
  OPEN(94,FILE=TRIM(SPS_HOME)//'/SPECTRA/AGB_spectra/Crich.teff',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  IF (stat.NE.0) THEN
     WRITE(*,*) 'SPS_SETUP ERROR: /SPECTRA/AGB_spectra/'//&
          'Crich.teff cannot be opened'
     STOP 
  ENDIF
  !burn the header
  READ(94,*) char
  DO i=1,n_agb_c
     READ(94,*) dumr1, agb_logt_c(i)
  ENDDO
  CLOSE(94)
  agb_logt_c = LOG10(agb_logt_c)
  
  !read in TP-AGB O-rich spectra
  OPEN(95,FILE=TRIM(SPS_HOME)//'/SPECTRA/AGB_spectra/Orich.spec',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  IF (stat.NE.0) THEN
     WRITE(*,*) 'SPS_SETUP ERROR: /AGB_spectra/'//&
          'Orich.spec '//'cannot be opened'
     STOP 
  ENDIF
  DO i=1,nspec_agb
     READ(95,*) agb_lam(i),agb_specinit_o(i,:)
  ENDDO
  CLOSE(95)
  !interpolate to the main spectral grid
  DO i=1,n_agb_o
     agb_spec_o(:,i) = MAX(linterparr(agb_lam,agb_specinit_o(:,i),&
          spec_lambda),tiny_number)
  ENDDO

  !read in TP-AGB C-rich spectra
  OPEN(96,FILE=TRIM(SPS_HOME)//'/SPECTRA/AGB_spectra/Crich.spec',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  IF (stat.NE.0) THEN
     WRITE(*,*) 'SPS_SETUP ERROR: /AGB_spectra/'//&
          'Crich.spec '//'cannot be opened'
     STOP 
  ENDIF
  DO i=1,nspec_agb
     READ(96,*) agb_lam(i),agb_specinit_c(i,:)
  ENDDO
  CLOSE(96)
  !interpolate to the main spectral grid
  DO i=1,n_agb_c
     agb_spec_c(:,i) = MAX(linterparr(agb_lam,agb_specinit_c(:,i),&
          spec_lambda),tiny_number)
  ENDDO

  !---------Read in Aringer carbon star library---------!

  !read in Aringer C-rich Teff grid
  OPEN(94,FILE=TRIM(SPS_HOME)//'/SPECTRA/AGB_spectra/Crich_Aringer.teff',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  IF (stat.NE.0) THEN
     WRITE(*,*) 'SPS_SETUP ERROR: /SPECTRA/AGB_spectra/'//&
          'Crich_Aringer.teff cannot be opened'
     STOP 
  ENDIF
  !burn the header
  DO i=1,n_agb_car
     READ(94,*) agb_logt_car(i)
  ENDDO
  CLOSE(94)
  agb_logt_car = LOG10(agb_logt_car)

  !read in Aringer C-rich spectra
  OPEN(96,FILE=TRIM(SPS_HOME)//&
       '/SPECTRA/AGB_spectra/Crich_Aringer.spec',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  IF (stat.NE.0) THEN
     WRITE(*,*) 'SPS_SETUP ERROR: /AGB_spectra/'//&
          'Crich_Aringer.spec '//'cannot be opened'
     STOP 
  ENDIF
  DO i=1,nspec_aringer
     READ(96,*) aringer_lam(i),aringer_specinit(i,:)
  ENDDO
  CLOSE(96)
  !interpolate to the main spectral grid
  DO i=1,n_agb_car
     agb_spec_car(:,i) = MAX(linterparr(aringer_lam,aringer_specinit(:,i),&
          spec_lambda),tiny_number)
  ENDDO

  !------------read in post-AGB spectra from Rauch 2003------------;

  !read in post-AGB Teff array
  OPEN(94,FILE=TRIM(SPS_HOME)//'/SPECTRA/Hot_spectra/ipagb.teff',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  IF (stat.NE.0) THEN
     WRITE(*,*) 'SPS_SETUP ERROR: Hot_spectra/ipagb.teff cannot be opened'
     STOP 
  ENDIF
  DO i=1,ndim_pagb
     READ(94,*) pagb_logt(i)
  ENDDO
  CLOSE(94)
  pagb_logt = LOG10(pagb_logt)

  !read in solar metallicity post-AGB spectra
  OPEN(97,FILE=TRIM(SPS_HOME)//'&
       /SPECTRA/Hot_spectra/ipagb_solar.spec',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  IF (stat.NE.0) THEN
     WRITE(*,*) 'SPS_SETUP ERROR: /SPECTRA/Hot_spectra/'//&
          'ipagb.spec_solar cannot be opened'
     STOP 
  ENDIF
  DO i=1,nspec_pagb
     READ(97,*) pagb_lam(i),pagb_specinit(i,:,2)
  ENDDO
  CLOSE(97)

  !read in halo metallicity post-AGB spectra
  OPEN(97,FILE=TRIM(SPS_HOME)//&
       '/SPECTRA/Hot_spectra/ipagb_halo.spec',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  IF (stat.NE.0) THEN
     WRITE(*,*) 'SPS_SETUP ERROR: /SPECTRA/Hot_spectra/'//&
          'ipagb.spec_halo cannot be opened'
     STOP 
  ENDIF
  DO i=1,nspec_pagb
     READ(97,*) pagb_lam(i),pagb_specinit(i,:,1)
  ENDDO
  CLOSE(97)
  
  !interpolate to the main spectral array
  DO j=1,2
     DO i=1,ndim_pagb
        pagb_spec(:,i,j) = MAX(linterparr(pagb_lam,pagb_specinit(:,i,j),&
             spec_lambda),tiny_number)
     ENDDO
  ENDDO

  !--------------read in WR spectra from Smith et al.--------------;

  !read in WR-N Teff array
  OPEN(94,FILE=TRIM(SPS_HOME)//'/SPECTRA/Hot_spectra/CMFGEN_WN.teff',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  IF (stat.NE.0) THEN
     WRITE(*,*) 'SPS_SETUP ERROR: Hot_spectra/CMFGEN_WN.teff cannot be opened'
     STOP 
  ENDIF
  DO i=1,ndim_wr
     READ(94,*) wrn_logt(i)
  ENDDO
  CLOSE(94)

  !read in WR-C Teff array
  OPEN(94,FILE=TRIM(SPS_HOME)//'/SPECTRA/Hot_spectra/CMFGEN_WC.teff',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  IF (stat.NE.0) THEN
     WRITE(*,*) 'SPS_SETUP ERROR: Hot_spectra/CMFGEN_WC.teff cannot be opened'
     STOP 
  ENDIF
  DO i=1,ndim_wr
     READ(94,*) wrc_logt(i)
  ENDDO
  CLOSE(94)
  
  !read in WR-N spectra
  OPEN(97,FILE=TRIM(SPS_HOME)//'/SPECTRA/Hot_spectra/CMFGEN_WN_Zall'//&
       '.spec',STATUS='OLD',iostat=stat,ACTION='READ')
  IF (stat.NE.0) THEN
     WRITE(*,*) 'SPS_SETUP ERROR: Hot_spectra/CMFGEN_WN_*.spec '//&
          'cannot be opened'
     STOP 
  ENDIF
  READ(97,*) tlamwr
  DO j=1,5
     DO i=1,ndim_wr
        READ(97,*) d1,twrzmet(j)
        READ(97,*) twrn(:,i,j)
     ENDDO
  ENDDO
  CLOSE(97)
  twrzmet = LOG10(twrzmet/zsol_spec)
  
  !interpolate to the main array
  DO j=1,nz
     i1 = MIN(MAX(locate(twrzmet,LOG10(zlegend(j)/zsol_spec)),1),SIZE(twrzmet)-1)
     dz = (LOG10(zlegend(j)/zsol_spec)-twrzmet(i1))/(twrzmet(i1+1)-twrzmet(i1))
     dz = MIN(MAX(dz,0.0),1.)
     DO i=1,ndim_wr
        tspecwr = (1-dz)*LOG10(twrn(:,i,i1)+tiny_number) + &
             dz*LOG10(twrn(:,i,i1+1)+tiny_number)
        wrn_spec(:,i,j) = 10**linterparr(LOG10(tlamwr),tspecwr,&
             LOG10(spec_lambda))-tiny_number
     ENDDO
  ENDDO

  !read in WR-C spectra
  OPEN(97,FILE=TRIM(SPS_HOME)//'/SPECTRA/Hot_spectra/CMFGEN_WC_Zall'//&
       '.spec',STATUS='OLD',iostat=stat,ACTION='READ')
  IF (stat.NE.0) THEN
     WRITE(*,*) 'SPS_SETUP ERROR: Hot_spectra/CMFGEN_WC_*.spec '//&
          'cannot be opened'
     STOP 
  ENDIF
  READ(97,*) tlamwr
  DO j=1,5
     DO i=1,ndim_wr
        READ(97,*) d1,twrzmet(j)
        READ(97,*) twrc(:,i,j)
     ENDDO
  ENDDO
  CLOSE(97)
  twrzmet = LOG10(twrzmet/zsol_spec)

  !interpolate to the main array
  DO j=1,nz
     i1 = MIN(MAX(locate(twrzmet,LOG10(zlegend(j)/zsol_spec)),1),SIZE(twrzmet)-1)
     dz = (LOG10(zlegend(j)/zsol_spec)-twrzmet(i1))/(twrzmet(i1+1)-twrzmet(i1))
     dz = MIN(MAX(dz,0.0),1.)
     DO i=1,ndim_wr
        tspecwr = (1-dz)*LOG10(twrc(:,i,i1)+tiny_number) + &
             dz*LOG10(twrc(:,i,i1+1)+tiny_number)
        wrc_spec(:,i,j) = 10**linterparr(LOG10(tlamwr),tspecwr,&
             LOG10(spec_lambda))-tiny_number
     ENDDO
  ENDDO

  !----------------------------------------------------------------!
  !--------------------Read in isochrones--------------------------!
  !----------------------------------------------------------------!

  !read in all metallicities
  DO z=zmin,zmax

     n_isoc = 0
     WRITE(zstype,'(F6.4)') zlegend(z)

     !open Padova isochrones
     IF (isoc_type.EQ.'pdva') OPEN(97,FILE=TRIM(SPS_HOME)//&
          '/ISOCHRONES/Padova/Padova2007/isoc_z'//&
          zstype//'.dat',STATUS='OLD', IOSTAT=stat,ACTION='READ')
     !open PARSEC isochrones
     IF (isoc_type.EQ.'prsc') OPEN(97,FILE=TRIM(SPS_HOME)//&
          '/ISOCHRONES/PARSEC/isoc_z'//&
          zstype//'.dat',STATUS='OLD', IOSTAT=stat,ACTION='READ')
     !open MIST isochrones
     IF (isoc_type.EQ.'mist') OPEN(97,FILE=TRIM(SPS_HOME)//&
          '/ISOCHRONES/MIST/isoc_z'//zlegend_str(z)//'.dat',STATUS='OLD',&
          IOSTAT=stat,ACTION='READ')
     !open BaSTI isochrones
     IF (isoc_type.EQ.'bsti') OPEN(97,FILE=TRIM(SPS_HOME)//&
          '/ISOCHRONES/BaSTI/isoc_z'//zstype//'.dat',STATUS='OLD',&
          IOSTAT=stat,ACTION='READ')
     !open Geneva isochrones
     IF (isoc_type.EQ.'gnva') OPEN(97,FILE=TRIM(SPS_HOME)//&
          '/ISOCHRONES/Geneva/isoc_z'//zstype//'.dat',STATUS='OLD',&
          IOSTAT=stat,ACTION='READ')

     IF (stat.NE.0) THEN
        WRITE(*,*) 'SPS_SETUP ERROR: isochrone files cannot be opened'
        STOP 
     END IF
        
     DO i=1,nlines
           
        READ(97,*,IOSTAT=stat) char
        IF (stat.NE.0) GOTO 20
        
        IF (char.EQ.'#') THEN 
           m = 1
        ELSE 
           
           IF (m.EQ.1) n_isoc = n_isoc+1
           BACKSPACE(97)
           IF (m.GT.nm) THEN
              WRITE(*,*) 'SPS_SETUP ERROR: number of mass points GT nm'
              STOP
           ENDIF
           IF (isoc_type.EQ.'mist') THEN
              READ(97,*,IOSTAT=stat) logage,mini_isoc(z,n_isoc,m),&
                   mact_isoc(z,n_isoc,m),logl_isoc(z,n_isoc,m),&
                   logt_isoc(z,n_isoc,m),logg_isoc(z,n_isoc,m),&
                   ffco_isoc(z,n_isoc,m),phase_isoc(z,n_isoc,m),&
                   lmdot_isoc(z,n_isoc,m)
           ELSE
              READ(97,*,IOSTAT=stat) logage,mini_isoc(z,n_isoc,m),&
                   mact_isoc(z,n_isoc,m),logl_isoc(z,n_isoc,m),&
                   logt_isoc(z,n_isoc,m),logg_isoc(z,n_isoc,m),&
                   ffco_isoc(z,n_isoc,m),phase_isoc(z,n_isoc,m)
              lmdot_isoc(z,n_isoc,m)=-99.
           ENDIF
           IF (stat.NE.0) GOTO 20
           IF (m.EQ.1) timestep_isoc(z,n_isoc) = logage
           nmass_isoc(z,n_isoc) = nmass_isoc(z,n_isoc)+1
           m = m+1
           
        ENDIF
        
     ENDDO

     WRITE(*,*) 'SPS_SETUP ERROR: didnt finish reading in the isochrones!'
     STOP
     
20   CONTINUE
     CLOSE(97)

     IF (n_isoc.NE.nt) THEN 
        WRITE(*,*) 'SPS_SETUP ERROR: number of isochrones NE nt',n_isoc,nt
        STOP
     ENDIF

  ENDDO

  !this is necessary because Geneva does not extend below 1.0 Msun
  !see imf_weight.f90 for details
  IF (isoc_type.EQ.'gnva') THEN
     imf_lower_bound = MINVAL(mini_isoc(zmin,1,1:nmass_isoc(zmin,1)))*0.99
  ELSE
     imf_lower_bound = imf_lower_limit
  ENDIF

  ENDIF  

  !----------------------------------------------------------------!
  !--------Read in dust emission spectra from Draine & Li----------!
  !----------------------------------------------------------------!
  
  DO k=1,nqpah_dustem
     WRITE(sqpah,'(I1)') k-1
     IF (k-1.EQ.10) THEN
        OPEN(99,FILE=TRIM(SPS_HOME)//'/dust/dustem/'//TRIM(str_dustem)//&
             '_MW3.1_100.dat',STATUS='OLD',iostat=stat,ACTION='READ')
     ELSE
        OPEN(99,FILE=TRIM(SPS_HOME)//'/dust/dustem/'//TRIM(str_dustem)//&
             '_MW3.1_'//sqpah//'0.dat',STATUS='OLD',iostat=stat,ACTION='READ')
     ENDIF
     IF (stat.NE.0) THEN 
        WRITE(*,*) 'SPS_SETUP ERROR: error opening dust emission file'
        STOP
     ENDIF
     DO i=1,2  !burn the header
        READ(99,*)
     ENDDO
     DO i=1,ndim_dustem
        READ(99,*,IOSTAT=stat) lambda_dustem(i),dustem_dustem(i,:)
        IF (stat.NE.0) THEN 
           WRITE(*,*) 'SPS_SETUP ERROR: error during dust emission read'
           STOP
        ENDIF
     ENDDO
     CLOSE(99)
     lambda_dustem = lambda_dustem*1E4  !convert to Ang
  
     !now interpolate the dust spectra onto the master wavelength array
     DO j=1,numin_dustem*2
        !the dust models only extend to 1um
        jj = locate(spec_lambda/1E4,one)
        dustem2_dustem(jj:,k,j) = linterparr(lambda_dustem,&
             dustem_dustem(:,j),spec_lambda(jj:))
     ENDDO

  ENDDO

  !----------------------------------------------------------------!
  !-------------Read in circumstellar AGB dust models--------------!
  !----------------------------------------------------------------!

  !O-rich spectra
  OPEN(99,FILE=TRIM(SPS_HOME)//'/dust/dusty/Orich_dusty.spec',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  IF (stat.NE.0) THEN 
     WRITE(*,*) 'SPS_SETUP ERROR: error opening dusty models'
     STOP
  ENDIF

  !number of wavelength points in the AGB grid
  READ(99,*) nlam
  !read in the wavelength grid
  READ(99,*,IOSTAT=stat) lambda_dagb(1:nlam)

  lambda_dagb(1:nlam) = lambda_dagb(1:nlam)

  DO i=1,nteff_dagb
     DO j=1,ntau_dagb
        READ(99,*,IOSTAT=stat) teff_dagb(1,i), tau1_dagb(1,j)
        READ(99,*,IOSTAT=stat) fluxin_dagb(1:nlam)
        IF (stat.NE.0) THEN 
           WRITE(*,*) 'SPS_SETUP ERROR: error reading dusty models'
           STOP
        ENDIF
        !interpolate the dust spectra onto the master wavelength array
        jj = locate(spec_lambda,lambda_dagb(1))
        flux_dagb(jj:,1,i,j) = linterparr(lambda_dagb(1:nlam),&
             fluxin_dagb(1:nlam),spec_lambda(jj:))
     ENDDO
  ENDDO
  CLOSE(99)

  !C-rich spectra
  OPEN(99,FILE=TRIM(SPS_HOME)//'/dust/dusty/Crich_dusty.spec',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  IF (stat.NE.0) THEN 
     WRITE(*,*) 'SPS_SETUP ERROR: error opening dusty models'
     STOP
  ENDIF

  !number of wavelength points in the AGB grid
  READ(99,*) nlam
  !read in the wavelength grid
  READ(99,*,IOSTAT=stat) lambda_dagb(1:nlam)

  DO i=1,nteff_dagb
     DO j=1,ntau_dagb
        READ(99,*,IOSTAT=stat) teff_dagb(2,i), tau1_dagb(2,j)
        READ(99,*,IOSTAT=stat) fluxin_dagb(1:nlam)
        IF (stat.NE.0) THEN 
           WRITE(*,*) 'SPS_SETUP ERROR: error reading dusty models'
           STOP
        ENDIF
        !interpolate the dust spectra onto the master wavelength array
        jj = locate(spec_lambda,lambda_dagb(1))
        flux_dagb(jj:,2,i,j) = linterparr(lambda_dagb(1:nlam),&
             fluxin_dagb(1:nlam),spec_lambda(jj:))
     ENDDO
  ENDDO
  CLOSE(99)

  !----------------------------------------------------------------!
  !--------------------Set up AGN dust model-----------------------!
  !----------------------------------------------------------------!

  !models from Nenkova et al. 2008

  OPEN(99,FILE=TRIM(SPS_HOME)//'/dust/Nenkova08_y010_torusg_n10_q2.0.dat',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  IF (stat.NE.0) THEN 
     WRITE(*,*) 'SPS_SETUP ERROR: error opening AGN dust models'
     STOP
  ENDIF

  !burn the header
  DO i=1,3
     READ(99,*)
  ENDDO

  !read in the optical depths
  READ(99,*) agndust_tau

  DO i=1,nagndust_spec
     READ(99,*) agndust_lam(i),agndust_specinit(i,:)
  ENDDO

  i1 = locate(spec_lambda,agndust_lam(1))
  i2 = locate(spec_lambda,agndust_lam(nagndust_spec))
  DO i=1,nagndust
     agndust_spec(i1:i2,i) = 10**linterparr(LOG10(agndust_lam),&
          LOG10(agndust_specinit(:,i)+tiny30),LOG10(spec_lambda(i1:i2)))-tiny30
  ENDDO


  !----------------------------------------------------------------!
  !----------------Set up nebular emission arrays------------------!
  !----------------------------------------------------------------!

  IF (isoc_type.EQ.'mist'.OR.isoc_type.EQ.'pdva'.OR.&
     isoc_type.EQ.'prsc'.OR.isoc_type.EQ.'bpss') THEN
  
     !read in nebular continuum arrays.  Units are Lsun/Hz/Q
     IF (cloudy_dust.EQ.1) THEN
        OPEN(99,FILE=TRIM(SPS_HOME)//'/nebular/ZAU_WD_'//isoc_type//'.cont',&
             STATUS='OLD',iostat=stat,ACTION='READ')
     ELSE
        OPEN(99,FILE=TRIM(SPS_HOME)//'/nebular/ZAU_ND_'//isoc_type//'.cont',&
             STATUS='OLD',iostat=stat,ACTION='READ')
     ENDIF
     IF (stat.NE.0) THEN
        WRITE(*,*) 'SPS_SETUP ERROR: nebular cont file cannot be opened. '
        STOP
     ENDIF
     !burn the header
     READ(99,*)
     !read the wavelength array
     READ(99,*) readlambneb
     DO i=1,nebnz
        DO j=1,nebnage
           DO k=1,nebnip
              READ(99,*,iostat=stat) nebem_logz(i),nebem_age(j),nebem_logu(k)
              READ(99,*,iostat=stat) readcontneb
              !interpolate onto the main wavelength grid
              !some values in the table are 0.0, set a floor of 1E-95
              nebem_cont(:,i,j,k) = linterparr(readlambneb,&
                   LOG10(readcontneb+10**(-95.d0)),spec_lambda)
           ENDDO
        ENDDO
     ENDDO
     CLOSE(99)
     
     !read in nebular emission line luminosities.  Units are Lsun/Q
     IF (cloudy_dust.EQ.1) THEN
        OPEN(99,FILE=TRIM(SPS_HOME)//'/nebular/ZAU_WD_'//isoc_type//'.lines',&
             STATUS='OLD',iostat=stat,ACTION='READ')
     ELSE
        OPEN(99,FILE=TRIM(SPS_HOME)//'/nebular/ZAU_ND_'//isoc_type//'.lines',&
             STATUS='OLD',iostat=stat,ACTION='READ')
     ENDIF
     IF (stat.NE.0) THEN
        WRITE(*,*) 'SPS_SETUP ERROR: nebular line file cannot be opened. Only available for Padova or MIST isochrones.'
        STOP
     ENDIF
     !burn the header
     READ(99,*) 
     !read the wavelength array
     READ(99,*) nebem_line_pos
     DO i=1,nebnz
        DO j=1,nebnage
           DO k=1,nebnip
              READ(99,*,iostat=stat) nebem_logz(i),nebem_age(j),nebem_logu(k)
              READ(99,*,iostat=stat) nebem_line(:,i,j,k)
           ENDDO
        ENDDO
     ENDDO
     CLOSE(99)
     
     !convert the nebem_age array to log(age), and log the emission arrays
     nebem_age  = LOG10(nebem_age)
     nebem_line = LOG10(nebem_line)
     
     !define the minimum resolution of the emission lines
     !based on the resolution of the spectral library
     DO i=1,nemline
        j = MIN(MAX(locate(spec_lambda,nebem_line_pos(i)),1),nspec-1)
        neb_res_min(i) = spec_lambda(j+1)-spec_lambda(j)
     ENDDO
     
     !set up a "master" array of normalized Gaussians
     !this makes the code much faster
     IF (setup_nebular_gaussians.EQ.1) THEN
        DO i=1,nemline
           IF (smooth_velocity.EQ.1) THEN
              !smoothing variable is km/s
              dlam = nebem_line_pos(i)*nebular_smooth_init/clight*1E13
           ELSE
              !smoothing variable is A
              dlam = nebular_smooth_init
           ENDIF
           !broaden the line to at least the resolution element 
           !of the spectrum (x2).
           dlam = MAX(dlam,neb_res_min(i)*2)
           gaussnebarr(:,i) = 1/SQRT(2*mypi)/dlam*&
                EXP(-(spec_lambda-nebem_line_pos(i))**2/2/dlam**2)  / &
                clight*nebem_line_pos(i)**2
        ENDDO
     ENDIF

  ENDIF

 
  !----------------------------------------------------------------!
  !-------------------Set up magnitude info------------------------!
  !----------------------------------------------------------------!

  !read in Vega-like star (lambda, Flambda)
  !(this is actually a Kurucz (1992) model for Vega)
  OPEN(98,FILE=TRIM(SPS_HOME)//'/SPECTRA/A0V_KURUCZ_92.SED',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  IF (stat.NE.0) THEN
     WRITE(*,*) 'SPS_SETUP ERROR: SPECTRA/A0V_KURUCZ_92.SED cannot be opened'
     STOP 
  ENDIF  
  !burn the header
  READ(98,*)
  DO i=1,ntlam
     READ(98,*) tvega_lam(i), tvega_spec(i)
  ENDDO
  CLOSE(98)

  !interpolate the Vega spectrum onto the wavelength grid
  !and convert to fnu
  jj = locate(vega_spec,tvega_lam(ntlam))
  vega_spec(:jj) = 10**linterparr(LOG10(tvega_lam),&
          LOG10(tvega_spec+tiny_number),LOG10(spec_lambda(:jj)))
  vega_spec = vega_spec*spec_lambda**2
  vega_spec(jj+1:) = tiny_number

  !read in Solar spectrum; units are fnu, flux is appropriate for
  !deriving absolute magnitudes.  spectrum from STScI, extrapolated 
  !beyond 2.5um with a blackbody.
  OPEN(98,FILE=TRIM(SPS_HOME)//'/SPECTRA/SUN_STScI.SED',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  IF (stat.NE.0) THEN
     WRITE(*,*) 'SPS_SETUP ERROR: SPECTRA/SUN_STScI.SED cannot be opened'
     STOP 
  END IF  
  DO i=1,ntlam
     READ(98,*) tsun_lam(i), tsun_spec(i)
  ENDDO
  CLOSE(98)

  !interpolate the Solar spectrum onto the wavelength grid
  jj = locate(sun_spec,tsun_lam(ntlam))
  sun_spec(:jj) = 10**linterparr(LOG10(tsun_lam),&
          LOG10(tsun_spec+tiny_number),LOG10(spec_lambda(:jj)))
  sun_spec(jj+1:) = tiny_number

  !read in and set up band-pass filters
  IF (TRIM(alt_filter_file).EQ.'') THEN
     OPEN(99,FILE=TRIM(SPS_HOME)//'/data/allfilters.dat',&
          STATUS='OLD',iostat=stat,ACTION='READ')
  ELSE
     OPEN(99,FILE=TRIM(SPS_HOME)//'/data/'//TRIM(alt_filter_file),&
          STATUS='OLD',iostat=stat,ACTION='READ')
  ENDIF
  READ(99,*)


  !loop over all the transmission filters
  DO i=1,nbands

     jj=0
     readlamb = 0.0
     readband = 0.0
     DO j=1,50000
        READ(99,*,iostat=stat) d1,d2
        IF (stat.NE.0) GOTO 909
        IF (jj.EQ.0) THEN
           jj = jj+1
           readlamb(jj) = d1
           !force the transmission to be GE 0
           readband(jj) = MAX(d2,0.0)
        ELSE
           !only read unique lambda points
           IF (readlamb(jj).NE.d1) THEN
              jj = jj+1
              readlamb(jj) = d1
              !force the transmission to be GE 0
              readband(jj) = MAX(d2,0.0)
           ENDIF
        ENDIF
     ENDDO

909  CONTINUE

     IF (j.GE.50000) THEN
        WRITE(*,*) 'SPS_SETUP ERROR: did not finish reading in filter ',i
        STOP
     ENDIF
     IF (jj.EQ.0) THEN
        WRITE(*,*) 'SPS_SETUP ERROR: error during filter definition read-in',i
        STOP
     ENDIF

     !interpolate the filter onto the master wavelength array
     i1 = MAX(locate(spec_lambda,readlamb(1)),1)
     i2 = locate(spec_lambda,readlamb(jj))
     IF (i1.NE.i2) bands(i1:i2,i) = &
          linterparr(readlamb(1:jj),readband(1:jj),spec_lambda(i1:i2))

     !normalize
     dumr1 = TSUM(spec_lambda,bands(:,i)/spec_lambda)
     !in this case the band is entirely outside the wavelength array
     IF (dumr1.LE.tiny_number) dumr1=1.0 
     bands(:,i) = bands(:,i) / dumr1
     bands(:,i) = MAX(bands(:,i),0.0)  !force no negative values

     !compute absolute magnitude of the Sun
     magsun(i) = TSUM(spec_lambda,sun_spec*bands(:,i)/spec_lambda)
     IF (magsun(i).LT.2*tiny_number) THEN
        magsun(i) = 99.0
     ELSE
        magsun(i) = -2.5*LOG10(magsun(i)) - 48.60
     ENDIF

     !compute mags of Vega
     magvega(i) = TSUM(spec_lambda,vega_spec*bands(:,i)/spec_lambda)
     IF (magvega(i).LE.tiny_number) THEN
        magvega(i) = 99.0 
     ELSE
        magvega(i) = -2.5 * LOG10(magvega(i)) - 48.60
     ENDIF
     
     !put Sun magnitudes in the Vega system if keyword is set
     IF (compute_vega_mags.EQ.1.AND.magsun(i).NE.99.0) &
          magsun(i) = (magsun(i)-magsun(1)) - &
          (magvega(i)-magvega(1)) + magsun(1)

  ENDDO
  CLOSE(99)

  !only execute this loop for the standard filter list
  IF (TRIM(alt_filter_file).EQ.'') THEN
     !normalize the IRAC, PACS, SPIRE, and IRAS photometry to nu*fnu=const
     !Note: this turns out to be irrelevant and is the result of rather
     !confusing documentation on the IRAC website
     lami = (/3.550,4.493,5.731,7.872,70.0,100.0,160.0,250.0,350.0,500.0,&
          12.0,25.0,60.0,100.0/)*1E4
     ind=(/53,54,55,56,95,96,97,98,99,100,101,102,103,104/)
     DO j=1,14
        IF (ind(j).GT.nbands) THEN
           WRITE(*,*) 'SPS_SETUP ERROR: trying to index a filter that does not exist!'
           EXIT
        ENDIF
        d = TSUM(spec_lambda,(spec_lambda/lami(j))**(-1.0)*bands(:,ind(j))/&
             spec_lambda)
        bands(:,ind(j)) = bands(:,ind(j)) / MAX(d,tiny_number)
     ENDDO
     
     !normalize the MIPS photometry to a BB (beta=2)
     !this part is *not* irrelevant.
     lami(1:3) = (/23.68,71.42,155.9/)*1E4
     ind(1:3)  = (/90,91,92/)
     DO j=1,3
        IF (ind(j).GT.nbands) THEN
           WRITE(*,*) 'SPS_SETUP ERROR: trying to index a filter that does not exist!'
           EXIT
        ENDIF
        d = TSUM(spec_lambda,(spec_lambda/lami(j))**(-2.0)*bands(:,ind(j))/&
             spec_lambda)
        bands(:,ind(j)) = bands(:,ind(j)) / MAX(d,tiny_number)
     ENDDO
  ENDIF

  !compute the effective wavelength of each filter
  !NB: These are sometimes referred to as "pivot" wavelengths
  ! in the literature.  See Bessell & Murphy 2012 A.2.1 for details'
  DO i=1,nbands
     filter_leff(i) = TSUM(spec_lambda,spec_lambda*bands(:,i)) / &
          TSUM(spec_lambda,bands(:,i)/spec_lambda)
     filter_leff(i) = SQRT(filter_leff(i))
  ENDDO

  !----------------------------------------------------------------!
  !---------------Set up extinction curve indices------------------!
  !----------------------------------------------------------------!

  !these are the breakpoints for the CCM89 MW parameterization
  DO j=1,nspec
     x = 1E4/spec_lambda(j)
     IF (x.GT.12.) mwdindex(6)=j
     IF (x.GE.8.)  mwdindex(5)=j
     IF (x.GE.5.9) mwdindex(4)=j
     IF (x.GE.3.3) mwdindex(3)=j
     IF (x.GE.1.1) mwdindex(2)=j
     IF (x.GE.0.1) mwdindex(1)=j
  ENDDO

  !----------------------------------------------------------------!
  !----------Set up Witt & Gordon 2000 attenuation curves----------!
  !----------------------------------------------------------------!

  !read in the WG00 dust model attenuation curves
  OPEN(99,FILE=TRIM(SPS_HOME)//'/dust/alldirty_h.dat',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  READ(99,*)
  READ(99,*)
  READ(99,*)
  DO i=1,18
     DO j=1,25
        READ(99,*) wglam(j), d1,wgtmp(j,i,1,:)
     ENDDO
  ENDDO
  CLOSE(99)
  OPEN(99,FILE=TRIM(SPS_HOME)//'/dust/alldirty_c.dat',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  READ(99,*)
  READ(99,*)
  READ(99,*)
  DO i=1,18
     DO j=1,25
        READ(99,*) wglam(j), d1,wgtmp(j,i,2,:)
     ENDDO
  ENDDO
  CLOSE(99)

  !interpolate the WG00 models onto the spectral grid
  DO k=1,2
     DO i=1,18
        DO j=1,6
           DO n=1,nspec
              IF (spec_lambda(n).GT.wglam(25)) THEN
                 wgdust(n,i,j,k)=0.0
              ELSE IF (spec_lambda(n).LT.wglam(1)) THEN
                 wgdust(n,i,j,k) = wgtmp(1,i,k,j)
              ELSE
                 wgdust(n,i,j,k) = linterp(wglam,wgtmp(:,i,k,j),&
                      spec_lambda(n))
              ENDIF
           ENDDO
        ENDDO
     ENDDO
  ENDDO

  !----------------------------------------------------------------!
  !--------------set up the redshift-age-DL relations--------------!
  !----------------------------------------------------------------!

  DO i=1,500
     a = (i-1)/499.*(1-1/1001.)+1/1001.
     cosmospl(i,1) = 1/a-1  !redshift
     cosmospl(i,2) = get_tuniv(cosmospl(i,1))   ! Tuniv in Gyr
     cosmospl(i,3) = get_lumdist(cosmospl(i,1)) ! Lum Dist in pc
  ENDDO

  !set Tuniv
  tuniv = get_tuniv(zero)

  !----------------------------------------------------------------!
  !-----------------read in index definitions----------------------!
  !----------------------------------------------------------------!

  OPEN(99,FILE=TRIM(SPS_HOME)//'/data/allindices.dat',&
       STATUS='OLD',iostat=stat,ACTION='READ')
  DO i=1,4  !burn the header
     READ(99,*)
  ENDDO
  DO i=1,nindx
     READ(99,*,IOSTAT=stat) indexdefined(:,i)
     IF (stat.NE.0) THEN 
        WRITE(*,*) 'SPS_SETUP ERROR: error during index defintion read'
        STOP
     ENDIF
     !convert the Lick indices from air to vacuum wavelengths
     IF (i.LE.25) THEN 
        indexdefined(1:6,i) = airtovac(indexdefined(1:6,i))
     ENDIF
  ENDDO
  CLOSE(99)

  !----------------------------------------------------------------!
  !-----------------set up expanded time array---------------------!
  !----------------------------------------------------------------!

  IF (isoc_type.NE.'bpss') THEN
  
     DO i=1,ntfull
        IF (MOD(i-1,time_res_incr).EQ.0) THEN
           time_full(i) = timestep_isoc(zmin,(i-1)/time_res_incr+1)
        ELSE
           IF ((i-1)/time_res_incr+2.LT.nt) THEN
              d1 = (timestep_isoc(zmin,(i-1)/time_res_incr+2)-&
                   timestep_isoc(zmin,(i-1)/time_res_incr+1))/time_res_incr 
           ENDIF
           time_full(i) = timestep_isoc(zmin,(i-1)/time_res_incr+1)+d1
           time_full(i) = time_full(i-1)+d1
        ENDIF
     ENDDO

  ENDIF

  !----------------------------------------------------------------!
  !------------------------set up the LSF--------------------------!
  !----------------------------------------------------------------!

  IF (smooth_lsf.EQ.1) THEN

     OPEN(99,FILE=TRIM(SPS_HOME)//'/data/lsf.dat',&
       STATUS='OLD',iostat=stat,ACTION='READ')
     IF (stat.NE.0) THEN
        WRITE(*,*) 'SPS_SETUP ERROR: lsf.dat cannot be opened'
        STOP 
     ENDIF

     DO i=1,ntabmax
        READ(99,*,iostat=stat) lsflam(i),lsfsig(i)
        IF (stat.NE.0) GOTO 910
        IF (i.EQ.1) lsfinfo%minlam=lsflam(i)
     ENDDO

     WRITE(*,*) 'SPS_SETUP ERROR: read to end of lsf.dat file'
     STOP

910  CONTINUE
     
     lsfinfo%maxlam = lsflam(i-1)

     !interpolate onto the main wavelength array
     DO n=1,nspec
        IF (spec_lambda(n).GE.lsfinfo%minlam.AND.&
             spec_lambda(n).LE.lsfinfo%maxlam) THEN
           lsfinfo%lsf(n) = linterp(lsflam(1:i-1),lsfsig(1:i-1),&
                spec_lambda(n))
        ENDIF
     ENDDO

  ENDIF


  !----------------------------------------------------------------!
  !----------------------------------------------------------------!
  !----------------------------------------------------------------!

  whlam5000 = locate(spec_lambda,5000.d0)
  whlylim   = locate(spec_lambda,912.d0)
  !define the frequency array
  spec_nu   = clight / spec_lambda

  !set flag indicating that sps_setup has been run, initializing 
  !important common block vars/arrays
  check_sps_setup = 1

  IF (verbose.EQ.1) THEN
     WRITE(*,*) '      ...done'
     WRITE(*,*)
  ENDIF

END SUBROUTINE SPS_SETUP

FUNCTION INTIND(lam,func,lo,hi)

  !perform integral over spectrum for index computation

  USE sps_vars
  USE sps_utils, ONLY : tsum, locate
  IMPLICIT NONE

  INTEGER :: l1,l2,i
  REAL(SP), INTENT(in), DIMENSION(nspec) :: lam, func
  REAL(SP), INTENT(in) :: lo,hi
  REAL(SP) :: f1,f2,intind

  !---------------------------------------------------------------!
  !---------------------------------------------------------------!

  !take care of the ends
  l1 = MAX(MIN(locate(lam,lo),nspec-1),1)
  l2 = MAX(MIN(locate(lam,hi),nspec-1),2)
  f1 = (func(l1+1)-func(l1))/(lam(l1+1)-lam(l1))*&
       (lo-lam(l1))+func(l1)
  f2 = (func(l2+1)-func(l2))/(lam(l2+1)-lam(l2))*&
       (hi-lam(l2))+func(l2)

  IF (l1.EQ.l2) THEN
     intind = (f2+f1)/2.*(hi-lo)
  ELSE
     intind = TSUM(lam(l1+1:l2),func(l1+1:l2))
     intind = intind + (lam(l1+1)-lo)*(f1+func(l1+1))/2.
     intind = intind + (hi-lam(l2))*(f2+func(l2))/2.
  ENDIF

END FUNCTION INTIND

!------------------------------------------------------------!
!------------------------------------------------------------!
!------------------------------------------------------------!

SUBROUTINE GETINDX(lambda,spec,indices)

  !routine to calculate indices from an input spectrum
  !indices are defined in fsps/data/allindices.dat

  USE sps_vars
  USE sps_utils, ONLY : intind, locate
  IMPLICIT NONE

  INTEGER :: j
  REAL(SP), INTENT(in), DIMENSION(nspec) :: spec,lambda
  REAL(SP), INTENT(inout), DIMENSION(nindx) :: indices
  REAL(SP) :: intfifc,cb,cr,lr,lb

  !---------------------------------------------------------------!
  !---------------------------------------------------------------!

  indices = 999.

  DO j=1,nindx

     !blue continuum
     cb = intind(lambda,spec,indexdefined(3,j),indexdefined(4,j))
     cb = cb / (indexdefined(4,j)-indexdefined(3,j))     
     lb = (indexdefined(3,j)+indexdefined(4,j))/2.

     IF (indexdefined(7,j).NE.4) THEN 

        !red continuum 
        cr = intind(lambda,spec,indexdefined(5,j),indexdefined(6,j))
        cr = cr / (indexdefined(6,j)-indexdefined(5,j))
        lr = (indexdefined(5,j)+indexdefined(6,j))/2.
        
        !compute integral(fi/fc)
        !NB: fc here is a linear interpolation between the red and blue.
        intfifc = intind(lambda,spec/((cr-cb)/(lr-lb)*(lambda-lb) + cb),&
             indexdefined(1,j),indexdefined(2,j))
     
     ELSE
        intfifc = intind(lambda,spec,indexdefined(1,j),indexdefined(2,j))
        intfifc = intfifc/(indexdefined(2,j)-indexdefined(1,j))
     ENDIF

     IF (indexdefined(7,j).EQ.1.) THEN
        !compute magnitude
        indices(j) = &
             -2.5*LOG10(intfifc/(indexdefined(2,j)-indexdefined(1,j)))
     ELSE IF (indexdefined(7,j).EQ.2.) THEN
        !compute EW (in Ang)
        indices(j) = (indexdefined(2,j)-indexdefined(1,j)) - intfifc
     ELSE IF (indexdefined(7,j).EQ.3.) THEN
        !compute Dn4000
        !NB: this only works with cr and cb computed above b/c 
        !the wavelength intervals for blue and red are the 
        !same for these indices, otherwise a slightly 
        !different cr and cb would have to be computed
        indices(j) = cr/cb
     ELSE IF (indexdefined(7,j).EQ.4.) THEN
        !compute magnitude from a flux ratio
        indices(j) = -2.5*LOG10(intfifc/cb)
     ENDIF

     !set dummy values for indices defined off of the wavelength grid
     IF (indexdefined(6,j).GT.lambda(nspec)) indices(j) = 999.0
     IF (indexdefined(3,j).LT.lambda(1)) indices(j) = 999.0

  ENDDO

END SUBROUTINE GETINDX

MODULE SPS_VARS

  ! module to set up most arrays and variables

  IMPLICIT NONE
  SAVE

!-------set the spectral library------!
#ifndef MILES
#define MILES 1
#endif

#ifndef BASEL
#define BASEL 0
#endif

! "C3K" currently under development.  do not use.
#ifndef C3K
#define C3K 0
#endif

!------set the isochrone library------!
#ifndef MIST
#define MIST 1
#endif

#ifndef PADOVA
#define PADOVA 0
#endif

#ifndef PARSEC
#define PARSEC 0
#endif

#ifndef BASTI
#define BASTI 0
#endif

#ifndef GENEVA
#define GENEVA 0
#endif

!note that in the case of BPASS the SSPs are already pre-computed
!so the spectral library, IMF, etc. is fixed in this case.  
#ifndef BPASS
#define BPASS 0
#endif

!------set the dust emission model------!
#ifndef DL07
#define DL07 1
#endif

#ifndef THEMIS
#define THEMIS 0
#endif
  
  !--------------------------------------------------------------!
  !--------------------------------------------------------------!

  !note that "SP" actually means double precision; this is a hack
  !to turn the nr routines into DP
  INTEGER, PARAMETER :: SP = KIND(1.d0)

  !------Common parameters that may be altered by the user-------!

  !setup cosmology (WMAP7).  Used only for z(t) relation.
  REAL(SP) :: om0=0.27, ol0=0.73, H0=72.

  !controls the level of output
  !0 = minimal output to screen.
  !1 = lots of output to screen.  useful for debugging.
  INTEGER, PARAMETER :: verbose=0

  !flag specifying TP-AGB normalization scheme
  !0 = default Padova 2007 isochrones
  !1 = Conroy & Gunn 2010 normalization
  !2 = Villaume, Conroy, Johnson 2015 normalization
  INTEGER :: tpagb_norm_type=2

  !turn-on time for BHB and SBS phases, time is in log(yrs)
  REAL(SP), PARAMETER :: bhb_sbs_time=9.5

  !turn on/off convolution of SSP with P(Z) (pz_convol.f90)
  !NB: pz_convol.f90 has not been tested in some time, use with caution
  INTEGER :: pzcon=0

  !the factor by which we increase the time array
  !this should no longer need to be set to anything other than 1
  INTEGER, PARAMETER :: time_res_incr=1

  !whether to interpolate the SSPs in logt (0) or t (1)
  integer :: interpolation_type = 0

  !The log of the minimum age to use when computing CSPs.  The spectrum for
  !this age is taken from the youngest available SSP.  Should be less than ~3
  real(SP) :: tiny_logt = 0.0

  !Use Aringer et al. (2009) Carbon star library if set
  !otherwise use Lancon & Wood (2002) empirical spectra
  INTEGER, PARAMETER :: cstar_aringer=1

  !turn on/off computation of light-weighted stellar ages
  !NB: currently only works with sfh=1,4 options
  INTEGER :: compute_light_ages=0

  !turn on/off the Draine & Li 2007 dust emission model
  INTEGER :: add_dust_emission=1

  !turn on/off the Nenkova et al. 2008 AGN torus dust model
  INTEGER :: add_agn_dust=1

  !turn on/off the AGB circumstellar dust model
  !see Villaume et al. (2014) for details
  INTEGER :: add_agb_dust_model=1

  !turn on/off a Cloudy-based nebular emission model (cont+lines)
  !if set to 2, then the nebular emission lines are added at the SSP
  !level, which may be useful if the nebular parameters are fixed
  INTEGER :: add_neb_emission=0
  !turn on/off the nebular continuum component (automatically
  !turned off if the above is set to 0)
  INTEGER  :: add_neb_continuum=1
  !include dust in the Cloudy tables or not
  INTEGER :: cloudy_dust=0

  !turn on/off IGM absorption a la Madau (1995)
  INTEGER :: add_igm_absorption=0

  !turn on/off the addition of stellar remnants to the
  !computation of stellar masses
  INTEGER :: add_stellar_remnants=1

  !if set, use a simpler, algorithm to smooth
  !the spectra.  Accurate to ~0.1% and somewhat faster than the
  !correct approach.  NB: one should be careful when choosing
  !to run the slow version, as the accuracy depends on the min/max
  !wavelength parameters.  Contact me if you are intersted in this feature.
  INTEGER :: smoothspec_fast=1

  !if set, smooth the spectrum in velocity space, otherwise
  !smooth in Angstrom space (in all cases the width of the
  !kernel is a sigma, not FWHM)
  INTEGER :: smooth_velocity=1

  !if set, smooth the SSPs within ssp_gen by an instrumental
  !LSF that is specified in data/lsf.dat
  INTEGER :: smooth_lsf=0

  !set attenuation-law for the diffuse ISM
  !0 = power-law attenuation.  See dust_index variable below
  !1 = MW extinction law, parameterized by Cardelli et al. 1989,
  !    with a UV bump strength parameterized by uvb (see params below)
  !2 = Calzetti attenuation law
  !3 = Witt & Gordon 2000 attenuation curve models
  INTEGER :: dust_type=0

  !IMF definition
  !0 = Salpeter (parameters defined above)
  !1 = Chabrier 2003 (parameters defined above)
  !2 = Kroupa 2001 (three slopes must be specified in imf_alpha)
  !3 = van Dokkum 2008 (parameter must be specified in imf_vdmc)
  !4 = Dave 2008 (parameter specified in imf_mdave)
  !5 = user-defined piece-wise power-law, specified in imf.dat
  INTEGER :: imf_type=2

  !flag specifying zero-point of magnitudes
  !0 = AB system
  !1 = Vega system
  INTEGER  :: compute_vega_mags=0

  !output wavelengths in air (rather than vac) if set to 1
  INTEGER :: vactoair_flag=0

  !flag indicating whether or not the output colors
  !will be redshifted to the age of the Universe corresponding
  !to the age of the SSP or CSP
  !(only works when using compsp.f90 to compute mags)
  !0 = colors redshifted to a fixed redshift, specified in parameter set
  !1 = colors redshifted according to the age of the SSP or CSP
  INTEGER :: redshift_colors=0

  !flag indicating whether to use the Mdot tabulated in the isochrone
  !files (if available) for the AGB dust model.  Note: only use this
  !feature with isochrone files that include Mdot (e.g., MIST)
  INTEGER :: use_isoc_mdot=0

  !flag indicating if the Gaussians used for implementing
  !nebular emission lines should be set up on initialization
  INTEGER :: setup_nebular_gaussians=0

  !Width of Gaussian kernels for initial nebular smoothing
  !if setup_nebular_gaussians=1 (units=km/s if smooth_velocity=1)
  REAL(SP) :: nebular_smooth_init=100.

  !flag to include emission lines in the spectrum
  !if not set, the line luminosities are still computed
  INTEGER :: nebemlineinspec=1

  !------------Pre-compiler defintions------------!

  !flag indicating type of isochrones to use
  !and number of metallicities in the set
#if (BASTI)
  REAL(SP), PARAMETER :: zsol = 0.020
  CHARACTER(4), PARAMETER :: isoc_type = 'bsti'
  INTEGER, PARAMETER :: nt=94
  INTEGER, PARAMETER :: nz=10
#elif (GENEVA)
  REAL(SP), PARAMETER :: zsol = 0.020
  CHARACTER(4), PARAMETER :: isoc_type = 'gnva'
  INTEGER, PARAMETER :: nt=51
  INTEGER, PARAMETER :: nz=5
#elif (MIST)
  REAL(SP), PARAMETER :: zsol = 0.0142
  CHARACTER(4), PARAMETER :: isoc_type = 'mist'
  INTEGER, PARAMETER :: nt=107
  INTEGER, PARAMETER :: nz=12
#elif (PARSEC)
  REAL(SP), PARAMETER :: zsol = 0.01524
  CHARACTER(4), PARAMETER :: isoc_type = 'prsc'
  INTEGER, PARAMETER :: nt=93
  INTEGER, PARAMETER :: nz=15
#elif (PADOVA)
  REAL(SP), PARAMETER :: zsol = 0.019
  CHARACTER(4), PARAMETER :: isoc_type = 'pdva'
  INTEGER, PARAMETER :: nt=94
  INTEGER, PARAMETER :: nz=22
#elif (BPASS)
  REAL(SP), PARAMETER :: zsol = 0.020
  CHARACTER(4), PARAMETER :: isoc_type = 'bpss'
  INTEGER, PARAMETER :: nt=43
  INTEGER, PARAMETER :: nz=12
#endif

  !flag indicating type of spectral library to use
  !and number of elements per stellar spectrum
#if (BPASS)
  REAL(SP), PARAMETER :: zsol_spec = 0.020
  CHARACTER(5), PARAMETER :: spec_type = 'bpass'
  INTEGER, PARAMETER :: nzinit=1
  INTEGER, PARAMETER :: nspec=15000
#else
#if (MILES)
  REAL(SP), PARAMETER :: zsol_spec = 0.019
  CHARACTER(5), PARAMETER :: spec_type = 'miles'
  INTEGER, PARAMETER :: nzinit=5
  INTEGER, PARAMETER :: nspec=5994
#elif (C3K)
  REAL(SP), PARAMETER :: zsol_spec = 0.0134
  CHARACTER(5), PARAMETER :: spec_type = 'ckc14'
  INTEGER, PARAMETER :: nzinit=6
  INTEGER, PARAMETER :: nspec=47378  !46666 !47378 !, 26500
#elif (BASEL)
  REAL(SP), PARAMETER :: zsol_spec = 0.020
  CHARACTER(5), PARAMETER :: spec_type = 'basel'
  INTEGER, PARAMETER :: nzinit=6
  INTEGER, PARAMETER :: nspec=1963
#endif
#endif

  !flag indicating the type of normalization used in the BaSeL library
  !pdva = normalized to Padova isochrones
  !wlbc = normalized to Teff-color relations
  !NB: currently only the wlbc option is included in the public release
  CHARACTER(4), PARAMETER :: basel_str = 'wlbc'

  !---------Dimensions of various arrays----------!

  !You must change the number of bands here if
  !filters are added to allfilters.dat
  INTEGER, PARAMETER :: nbands=143
  !number of indices defined in allindices.dat
  INTEGER, PARAMETER :: nindx=30

  !The following parameters should never be changed
  !unless you are changing the libraries

  !max dimension of array for each isochrone
  INTEGER, PARAMETER :: nm=2000  !10000
  !max number of lines to read in
  INTEGER, PARAMETER ::  nlines=1000000
  !max number of lines in tabulated SFH, LSF
  INTEGER, PARAMETER :: ntabmax=20000
  !dimensions of BaSeL library
  INTEGER, PARAMETER :: ndim_logt=68, ndim_logg=19
  !number of O-rich, C-rich AGB spectra (and Aringer C-rich spec)
  INTEGER, PARAMETER :: n_agb_o=9, n_agb_c=5, n_agb_car=9
  !number of post-AGB spectra
  INTEGER, PARAMETER :: ndim_pagb=14
  !number of WR spectra
  INTEGER, PARAMETER :: ndim_wr=12
  !dimensions of WMBasic grid
  INTEGER, PARAMETER :: ndim_wmb_logt=11,ndim_wmb_logg=3
  !parameters for circumstellar dust models
  INTEGER, PARAMETER :: ntau_dagb=50, nteff_dagb=6
  !number of emission lines and continuum emission points
  INTEGER, PARAMETER :: nemline=128, nlam_nebcont=1963
  !number of metallicity, age, and ionization parameter points
  INTEGER, PARAMETER :: nebnz=11, nebnage=10, nebnip=7
  !number of optical depths for AGN dust models
  INTEGER, PARAMETER :: nagndust=9
  !number of spectral points in the input library
  INTEGER, PARAMETER :: nagndust_spec=125

  !------------IMF-related Constants--------------!

  !Salpeter IMF index
  REAL(SP) :: salp_ind= 2.35
  !min/max masses for the IMF
  REAL(SP) :: imf_lower_limit = 0.08, imf_upper_limit=120.
  REAL(SP) :: imf_lower_bound
  !Chabrier 2003 IMF parameters
  REAL(SP), PARAMETER :: chab_mc=0.08, chab_sigma2=0.69*0.69,&
       chab_ind=1.3
  !van Dokkum 2008 IMF parameters
  REAL(SP), PARAMETER :: vd_sigma2=0.69*0.69, vd_ah=0.0443,&
       vd_ind=1.3, vd_al=0.14, vd_nc=25.
  !mass limits for BH and neutron star initial-mass mass relations
  REAL(SP) :: mlim_bh=40.0, mlim_ns=8.5

  !-------------Physical Constants---------------!
  !-------in cgs units where applicable----------!

  !constant such that g = C MT^4/L
  REAL(SP), PARAMETER :: gsig4pi = 1/4.13E10
  !pi
  REAL(SP), PARAMETER :: mypi    = 3.14159265
  !hc/k (Ang*K)
  REAL(SP), PARAMETER :: hck     = 1.43878E8
  !speed of light (Ang/s)
  REAL(SP), PARAMETER :: clight  = 2.9979E18
  !hc^2/sigma_SB
  REAL(SP), PARAMETER :: hc2sig  = 0.105021
  !Solar mass in grams
  REAL(SP), PARAMETER :: msun    = 1.989E33
  !Solar radius in cm
  REAL(SP), PARAMETER :: rsun    = 6.955E10
  !Solar luminosity in erg/s
  REAL(SP), PARAMETER :: lsun    = 3.839E33
  !Newton's constant
  REAL(SP), PARAMETER :: newton  = 6.67428E-8
  !cm in a pc
  REAL(SP), PARAMETER :: pc2cm   = 3.08568E18
  !seconds per year
  REAL(SP), PARAMETER :: yr2sc   = 3.15569E7
  !Planck's constant
  REAL(SP), PARAMETER :: hplank  = 6.6261E-27
  !constant to convert mags into propert units (see getmags.f90)
  REAL(SP), PARAMETER :: mag2cgs = LOG10(lsun/4.0/mypi/(pc2cm*pc2cm)/100.0)

  !define large and small numbers.  numbers whose abs values
  !are less than tiny_number are treated as equal to 0.0
  REAL(SP), PARAMETER :: huge_number = 10**(70.d0)
  REAL(SP), PARAMETER :: tiny_number = 10**(-70.d0)
  REAL(SP), PARAMETER :: tiny30      = 10**(-30.0)

  !---------------Common Block-------------------!

  INTEGER :: check_sps_setup = 0

  !IMF parameters for Kroupa 2001 IMF
  !the user does not set these vars explicitly.  They
  !are set in the PARAMS structure below and are
  !copied internally
  REAL(SP), DIMENSION(3) :: imf_alpha=1.3
  !IMF cut-off for van Dokkum parameterization
  !the user does not set this var explicitly.  It
  !is set in the PARAMS structure below and
  !copied internally
  REAL(SP) :: imf_vdmc  = 0.08
  !IMF transition mass for Dave parameterization
  !the user does not set this var explicitly.  It
  !is set in the PARAMS structure below and
  !copied internally
  REAL(SP) :: imf_mdave = 0.5
  !parameters for user-defined IMF
  INTEGER :: n_user_imf = 0
  REAL(SP), DIMENSION(3,100) :: imf_user_alpha=0.

  !environment variable for SPS home directory
  CHARACTER(250) :: SPS_HOME=''
  !name of the filter file, if blank it defaults to allfilters.dat
  CHARACTER(30)  :: alt_filter_file=''

  !Age of Universe in Gyr (set in sps_setup.f90)
  REAL(SP) :: tuniv=0.

  !index in the wavelength array where lambda=5000A, Ly_lim
  INTEGER :: whlam5000,whlylim

  !this specifies the size of the full time grid
  INTEGER, PARAMETER :: ntfull = time_res_incr*nt

  !array of index definitions
  REAL(SP), DIMENSION(7,nindx) :: indexdefined=0.

  !array holding MW extinction curve indices
  INTEGER, DIMENSION(6) :: mwdindex=0

  !array holding Witt & Gordon dust models
  !wgdust(lam,tau,model,homo/clump)
  REAL(SP), DIMENSION(nspec,18,6,2) :: wgdust=0.

  !Index for P(Z) distribution.  1=closed box;
  !P(Z) = z^zpow*exp(-z/pmetals)  (see pz_convol.f90)
  !pmetals set in PARAMS structure
  REAL(SP) :: zpow2=1.0

  !array holding redshift-age-DL relations
  REAL(SP), DIMENSION(500,3) :: cosmospl=0.

  !array holding tabulated SFH
  REAL(SP), DIMENSION(3,ntabmax) :: sfh_tab=0.
  INTEGER :: ntabsfh=0

  !array of bandpass filters
  REAL(SP), DIMENSION(nspec,nbands) :: bands
  !magnitude of the Sun in all filters
  REAL(SP), DIMENSION(nbands) :: magsun,magvega,filter_leff
  !Vega-like star spectrum for Vega magnitude zero-point
  !spectrum of Sun, for absolute mags of Sun
  REAL(SP), DIMENSION(nspec)  :: vega_spec=0.,sun_spec=0.
  !common wavelength and frequench arrays
  REAL(SP), DIMENSION(nspec)  :: spec_lambda=0.,spec_nu=0.0

  !arrays for stellar spectral information in HR diagram
  REAL(SP), DIMENSION(ndim_logt) :: speclib_logt=0.
  REAL(SP), DIMENSION(ndim_logg) :: speclib_logg=0.
  REAL(KIND(1.0)), DIMENSION(nspec,nz,ndim_logt,ndim_logg) :: speclib=0.

  !arrays for the WMBasic grid
  REAL(SP), DIMENSION(ndim_wmb_logt) :: wmb_logt=0.
  REAL(SP), DIMENSION(ndim_wmb_logg) :: wmb_logg=0.
  REAL(KIND(1.0)), DIMENSION(nspec,nz,ndim_wmb_logt,ndim_wmb_logg) :: wmb_spec=0.

  !AGB library (Lancon & Mouhcine 2002)
  REAL(SP), DIMENSION(nspec,n_agb_o) :: agb_spec_o=0.
  REAL(SP), DIMENSION(nz,n_agb_o)    :: agb_logt_o=0.
  REAL(SP), DIMENSION(nspec,n_agb_c) :: agb_spec_c=0.
  REAL(SP), DIMENSION(n_agb_c)       :: agb_logt_c=0.
  !C-rich library (Aringer et al. 2009)
  REAL(SP), DIMENSION(n_agb_car)       :: agb_logt_car=0.
  REAL(SP), DIMENSION(nspec,n_agb_car) :: agb_spec_car=0.

  !post-AGB library (Rauch 2003)
  REAL(SP), DIMENSION(nspec,ndim_pagb,2) :: pagb_spec=0.
  REAL(SP), DIMENSION(ndim_pagb)         :: pagb_logt=0.

  !WR library (Smith et al. 2002)
  REAL(SP), DIMENSION(nspec,ndim_wr,nz) :: wrn_spec=0.,wrc_spec=0.
  REAL(SP), DIMENSION(ndim_wr)          :: wrn_logt=0.,wrc_logt=0.

#if (DL07)
  !dust emission model (Draine & Li 2007)
  INTEGER, PARAMETER :: ndim_dustem=1001
  INTEGER, PARAMETER :: numin_dustem=22, nqpah_dustem=7
  CHARACTER(6), PARAMETER :: str_dustem='DL07'
  REAL(SP), DIMENSION(nqpah_dustem), PARAMETER :: &
       qpaharr = (/0.47,1.12,1.77,2.50,3.19,3.90,4.58/)
  REAL(SP), DIMENSION(numin_dustem) :: uminarr = &
       (/0.1,0.15,0.2,0.3,0.4,0.5,0.7,0.8,1.0,1.2,1.5,2.0,&
       2.5,3.0,4.0,5.0,7.0,8.0,12.0,15.0,20.0,25.0/)
#elif (THEMIS)
  !dust emission model (THEMIS; Jones et al. 2013, 2017)
  INTEGER, PARAMETER :: ndim_dustem=576
  INTEGER, PARAMETER :: numin_dustem=37, nqpah_dustem=11
  CHARACTER(6), PARAMETER :: str_dustem='THEMIS'
  REAL(SP), DIMENSION(nqpah_dustem), PARAMETER :: &
       qpaharr = (/0.02,0.06,0.10,0.14,0.17,0.20,0.24,0.28,0.32,0.36,0.40/)/2.2*100
  REAL(SP), DIMENSION(numin_dustem) :: uminarr = &
       (/0.1,0.12,0.15,0.17,0.2,0.25,0.3,0.35,0.4,0.5,0.6,0.7,0.8,1.0,&
       1.2,1.5,1.7, 2.0, 2.5, 3.0, 3.5, 4.0, 5.0, 6.0, 7.0, 8.0, 10.0,&
       12.0, 15.0, 17.0, 20.0, 25.0, 30.0, 35.0, 40.0, 50.0, 80.0/)
#endif

  REAL(SP), DIMENSION(ndim_dustem)                :: lambda_dustem=0.
  REAL(SP), DIMENSION(ndim_dustem,numin_dustem*2) :: dustem_dustem=0.
  REAL(SP), DIMENSION(nspec,nqpah_dustem,numin_dustem*2) :: dustem2_dustem=0.

  
  !circumstellar AGB dust model (Villaume et al. 2015)
  REAL(SP), DIMENSION(nspec,2,nteff_dagb,ntau_dagb) :: flux_dagb=0.
  REAL(SP), DIMENSION(2,ntau_dagb)                  :: tau1_dagb=0.
  REAL(SP), DIMENSION(2,nteff_dagb)                 :: teff_dagb=0.

  !nebular emission model
  REAL(SP), DIMENSION(nemline) :: nebem_line_pos=0.
  REAL(SP), DIMENSION(nemline,nebnz,nebnage,nebnip) :: nebem_line=0.
  REAL(SP), DIMENSION(nspec,nebnz,nebnage,nebnip) :: nebem_cont=0.
  REAL(SP), DIMENSION(nebnz)   :: nebem_logz=0.
  REAL(SP), DIMENSION(nebnage) :: nebem_age=0.
  REAL(SP), DIMENSION(nebnip)  :: nebem_logu=0.
  !minimum resolution for nebular lines, based
  !on the resolution of the spectral libraries.
  REAL(SP), DIMENSION(nspec)   :: neb_res_min=0.0
  REAL(SP), DIMENSION(nspec,nemline) :: gaussnebarr=0.0

  !arrays for AGN dust
  REAL(SP), DIMENSION(nagndust)       :: agndust_tau=0.
  REAL(SP), DIMENSION(nspec,nagndust) :: agndust_spec=0.

  !arrays for the isochrone data
  REAL(SP), DIMENSION(nz,nt,nm) :: mact_isoc=0.,logl_isoc=0.,&
       logt_isoc=0.,logg_isoc=0.,ffco_isoc=0.,phase_isoc=0.,&
       mini_isoc=0.,lmdot_isoc=0.

  !arrays holding the number of mass elements for each isochrone,
  !the age of each isochrone, and the metallicity of each isochrone
  INTEGER, DIMENSION(nz,nt)  :: nmass_isoc=0
  REAL(SP), DIMENSION(nz,nt) :: timestep_isoc=0.
  REAL(SP), DIMENSION(nz)    :: zlegend=-99.
  REAL(SP), DIMENSION(nzinit):: zlegendinit=-99.

  !arrays for the full Z-dep SSP spectra
  REAL(SP), DIMENSION(nspec,ntfull,nz) :: spec_ssp_zz=0.
  REAL(SP), DIMENSION(ntfull,nz)       :: mass_ssp_zz=0.,lbol_ssp_zz=0.

  REAL(SP), DIMENSION(ntfull) :: time_full=0.

  !array for full BPASS SSPs
  REAL(SP), DIMENSION(nspec,nt,nz) :: bpass_spec_ssp=0.
  REAL(SP), DIMENSION(nt,nz)       :: bpass_mass_ssp=0.
  
  !------------Define TYPE structures-------------!

  !structure for the set of parameters necessary to generate a model
  TYPE PARAMS
     REAL(SP) :: pagb=1.0,dell=0.,delt=0.,fbhb=0.,sbss=0.,tau=1.0,&
          const=0.,tage=0.,fburst=0.,tburst=11.0,dust1=0.,dust2=0.,&
          logzsol=0.,zred=0.,pmetals=0.02,imf1=1.3,imf2=2.3,imf3=2.3,&
          vdmc=0.08,dust_clumps=-99.,frac_nodust=0.,dust_index=-0.7,&
          dust_tesc=7.0,frac_obrun=0.,uvb=1.0,mwr=3.1,redgb=1.0,agb=1.0,&
          dust1_index=-1.0,mdave=0.5,sf_start=0.,sf_trunc=0.,sf_slope=0.,&
          duste_gamma=0.01,duste_umin=1.0,duste_qpah=3.5,fcstar=1.0,&
          masscut=150.0,sigma_smooth=0.,agb_dust=1.0,min_wave_smooth=1E3,&
          max_wave_smooth=1E4,gas_logu=-2.0,gas_logz=0.,igm_factor=1.0,&
          fagn=0.0,agn_tau=10.0
     INTEGER :: zmet=1,sfh=0,wgp1=1,wgp2=1,wgp3=1,evtype=-1
     INTEGER, DIMENSION(nbands) :: mag_compute=1
     INTEGER, DIMENSION(nt) :: ssp_gen_age=1
     CHARACTER(50) :: imf_filename='', sfh_filename=''
  END TYPE PARAMS

  !structure for the output of the compsp routine
  TYPE COMPSPOUT
     REAL(SP) :: age=0.,mass_csp=0.,lbol_csp=0.,sfr=0.,mdust=0.,mformed=0.
     REAL(SP), DIMENSION(nbands)  :: mags=0.
     REAL(SP), DIMENSION(nspec)   :: spec=0.
     REAL(SP), DIMENSION(nindx)   :: indx=0.
     REAL(SP), DIMENSION(nemline) :: emlines=0.
  END TYPE COMPSPOUT

  ! A structure to hold SFH params converted to intrinsic units
  TYPE SFHPARAMS
     REAL(SP) :: tau=1.0,tage=0.,tburst=0.,sf_trunc=0.,sf_slope=0.,&
          tq=0.,t0=0.,tb=0.
     INTEGER :: type=0,use_simha_limits=0
  END TYPE SFHPARAMS

  TYPE TLSF
     REAL(SP), DIMENSION(nspec) :: lsf=0.
     REAL(SP) :: minlam=0.,maxlam=0.
  END TYPE TLSF

  TYPE(TLSF) :: lsfinfo

  !-----the following structures are not used in the public code-----!
  !--they are included here because some users of FSPS utilize them--!

  !structure for observational data
  TYPE OBSDAT
     REAL(SP)                    :: zred=0.,logsmass=0.
     REAL(SP), DIMENSION(nbands) :: mags=0.,magerr=0.
     REAL(SP), DIMENSION(nspec)  :: spec=0.,specerr=99.
  END TYPE OBSDAT

  !structure for using P(z) in chi2
  INTEGER, PARAMETER :: npzphot   = 200
  TYPE TPZPHOT
     REAL(SP), DIMENSION(npzphot) :: zz=0.,pz=0.
  END TYPE TPZPHOT

  !used for Powell minimization
  TYPE(OBSDAT) :: powell_data, sedfit_data

  !used for creating a pre-tabulated grid of CSPs as a function
  !of tau and metallicity
  !INTEGER, PARAMETER :: ntaugrid=20
  !REAL(SP), DIMENSION(ntaugrid) :: taugrid=0.0
  !REAL, DIMENSION(nspec,ntfull,ntaugrid,nz) :: csp_grid=0.0
  !INTEGER :: csp_grid_flag=0


END MODULE SPS_VARS

SUBROUTINE SFHSTAT(pos,model,ssfr6,ssfr7,ssfr8,ave_age)

  !compute basic statistics given a parameterized star formation history.
  !required inputs are the parameter set and a single element output
  !structure from compsp
  
  USE sps_vars
  IMPLICIT NONE

  TYPE(PARAMS), INTENT(in)    :: pos
  TYPE(COMPSPOUT), INTENT(in) :: model
  REAL(SP), INTENT(inout)     :: ssfr6,ssfr7,ssfr8,ave_age
  REAL(SP) :: dt
  
  !---------------------------------------------------------------!
  !---------------------------------------------------------------!

  dt = 10**model%age/1E9 - pos%sf_start

  IF (dt.LT.0.) THEN
     WRITE(*,*) 'SFHSTAT ERROR: dt<0.0, stopping....'
     STOP
  ENDIF

  !compute mass-weighted stellar age of tau component
  IF (pos%sfh.EQ.1) THEN
     ave_age = pos%tau*(1.-EXP(-dt/pos%tau)*(dt/pos%tau+1.))/&
          (1.-EXP(-dt/pos%tau))
     ssfr6 = (EXP(-(dt-1E-3)/pos%tau)-EXP(-dt/pos%tau))/(1.-EXP(-dt/pos%tau))
     ssfr7 = (EXP(-(dt-1E-2)/pos%tau)-EXP(-dt/pos%tau))/(1.-EXP(-dt/pos%tau))
     ssfr8 = (EXP(-(dt-1E-1)/pos%tau)-EXP(-dt/pos%tau))/(1.-EXP(-dt/pos%tau))
  ELSE IF (pos%sfh.EQ.4) THEN
     ave_age = (2.-EXP(-dt/pos%tau)*(dt/pos%tau*(dt/pos%tau+2.)+2.))*&
          pos%tau/(1.-EXP(-dt/pos%tau)*(dt/pos%tau+1))
     ssfr6 = (EXP(-(dt-1E-3)/pos%tau)*((dt-1E-3)/pos%tau)-&
          EXP(-dt/pos%tau)*(dt/pos%tau))/&
          (1.-EXP(-dt/pos%tau)*(dt/pos%tau+1))
     ssfr7 = (EXP(-(dt-1E-2)/pos%tau)*((dt-1E-2)/pos%tau)-&
          EXP(-dt/pos%tau)*(dt/pos%tau))/&
          (1.-EXP(-dt/pos%tau)*(dt/pos%tau+1))
     ssfr8 = (EXP(-(dt-1E-1)/pos%tau)*((dt-1E-1)/pos%tau)-&
          EXP(-dt/pos%tau)*(dt/pos%tau))/&
          (1.-EXP(-dt/pos%tau)*(dt/pos%tau+1))
  ELSE
     WRITE(*,*) 'SFHSTAT ERROR: you should not be calling sfhstat '//&
          'for sfh types NE 1 or 4, stopping....'
     STOP
  ENDIF

  !add constant component
  ave_age = ave_age*(1.-pos%const) + pos%const*dt/2.
  ssfr6   = ssfr6  *(1.-pos%const) + pos%const*1E-3/dt
  ssfr7   = ssfr7  *(1.-pos%const) + pos%const*1E-2/dt
  ssfr8   = ssfr8  *(1.-pos%const) + pos%const*1E-1/dt

  !convert to lookback time
  ave_age = dt - ave_age

  !only add the burst if the burst has happened
  IF (10**model%age/1E9.GT.pos%tburst) &
       ave_age = (1.-pos%fburst)*ave_age + pos%fburst*pos%tburst
  IF (dt-pos%tburst.LE.1E-3) ssfr6 = ssfr6 + pos%fburst
  IF (dt-pos%tburst.LE.1E-2) ssfr7 = ssfr7 + pos%fburst
  IF (dt-pos%tburst.LE.1E-1) ssfr8 = ssfr8 + pos%fburst


  !convert from integral(SFR) to log(<SSFR>), in 1/Gyr
  ssfr6 = LOG10(MAX(ssfr6/model%mass_csp/1E-3,tiny_number))
  ssfr7 = LOG10(MAX(ssfr7/model%mass_csp/1E-2,tiny_number))
  ssfr8 = LOG10(MAX(ssfr8/model%mass_csp/1E-1,tiny_number)) 


END SUBROUTINE SFHSTAT

FUNCTION LINTERPARR(xin,yin,xout)

  !routine to linearly interpolate a function yin(xin) at xout

  USE sps_vars; USE sps_utils, ONLY: locate
  IMPLICIT NONE
  REAL(SP), DIMENSION(:), INTENT(in) :: xin,yin
  REAL(SP), INTENT(in), DIMENSION(:) :: xout
  REAL(SP), DIMENSION(SIZE(xout)) :: linterparr
  INTEGER :: klo,n,n2,i

  !---------------------------------------------------------------!
  !---------------------------------------------------------------!

  n   = SIZE(xin)
  n2  = SIZE(xout)

  DO i=1,n2
     klo = MAX(MIN(locate(xin,xout(i)),n-1),1)
     linterparr(i) = yin(klo) + (yin(klo+1)-yin(klo))*&
          (xout(i)-xin(klo))/(xin(klo+1)-xin(klo))
  ENDDO

END FUNCTION LINTERPARR

subroutine sfhinfo(pset, age, mfrac, sfr, frac_linear)
  ! Get the SFR integrated from T=0 to T=age, normalized by the SFR integrated
  ! from T=0 to T=Tmax, where Tmax is the maximum isochrone/SSP age.
  !
  ! Inputs
  ! ---------
  !
  ! pset:
  !   A `PARAMS` structure containing the SFH parameters.
  !
  ! age:
  !   The age (in forward Gyr) at which to calculate the SFR and mass
  !   fractions.
  !
  ! Outputs:
  ! ----------
  !
  ! mfrac:
  !    Fraction of mass formed by `age` \equiv mass_formed(age) /
  !    mass_formed(maxtime) where maxtime is the age of the oldest isochrone.
  !
  ! sfr:
  !    The SFR at `age`, normalized s.t. the integral of the SFR from 0 to the
  !    oldest isochrone age is 1.  Infinite SFR from bursts is not included.
  !
  ! frac_linear:
  !   If pset%sfh=5, this gives the fraction of m_formed(age) that was formed
  !   in the linear portion.
  !
  use sps_vars, only: time_full, ntfull, tiny_number, &
                      sfh_tab, ntabsfh, &
                      PARAMS, SP
  use sps_utils, only: locate
  implicit none

  type(PARAMS), intent(in) :: pset
  real(SP), intent(in) :: age

  real(SP), intent(out) :: mfrac, sfr, frac_linear
  
  real(SP) :: Tmax, Tprime, Tz, Ttrunc, Thi
  real(SP) :: m, gammainc
  real(SP) :: mass_tau, mass_linear, mfrac_burst
  real(SP) :: total_mass_tau, total_mass_linear
  real(SP) :: sfr_tau, sfr_linear, sfr_trunc, sfr_const
  integer :: power, itab

  ! Defaults
  mfrac = 1.
  sfr = 0.
  frac_linear = 0.
  
  if (pset%sfh.eq.0) then
     ! SSPs
     mfrac = 1.0
     sfr = 0. ! actually the sfr is infinity
     
  else if ((pset%sfh.eq.1).or.(pset%sfh.eq.4).or.(pset%sfh.eq.5)) then
     ! Compute tau model component, for SFH=1,4,5
     !
     ! Integration limits are from 0 to Tmax and 0 to Tprime, where
     !   - Tmax is the maximum isochrone age, and
     !   - Tprime is the given `age`,
     ! both adjusted for sf_start, and we'll clip them to Ttrunc.
     Tmax = 10**(time_full(ntfull) - 9) - pset%sf_start
     Tprime = age - pset%sf_start
     ! Ttrunc only matters if nonzero and not before sf_start.
     if ((pset%sf_trunc.lt.tiny_number).or.(pset%sf_trunc.lt.pset%sf_start)) then
        Ttrunc = Tmax
     else
        Ttrunc = pset%sf_trunc - pset%sf_start
     endif

     ! Now integrate to get mass formed by Tprime and by Tmax, dealing with
     ! truncation that happens after sf_start but before Tmax and/or Tprime.
     if (pset%sfh.eq.1) power = 1
     if ((pset%sfh.eq.4).or.(pset%sfh.eq.5)) power = 2
     total_mass_tau = pset%tau * gammainc(power, min(Tmax, Ttrunc) / pset%tau)
     if (Tprime.lt.0) then
        ! Deal with sf that hasn't started yet
        mass_tau = 0.
        sfr_tau = 0.
     else
        mass_tau = pset%tau * gammainc(power, min(Tprime, Ttrunc) / pset%tau)
        ! The SFR at Tprime (unnormalized)
        sfr_tau = (min(Tprime, Ttrunc) / pset%tau)**(power-1.) * exp(-min(Tprime, Ttrunc) / pset%tau)
     endif

  endif

  ! Add the constant and burst portions, for SFH=1,4.
  if ((pset%sfh.eq.1).or.(pset%sfh.eq.4)) then

     ! Fraction of the burst mass formed by Tprime
     if (Tprime.gt.(pset%tburst-pset%sf_start)) then
        mfrac_burst = 1.0
     else
        mfrac_burst = 0.0
     endif
     ! SFR from constant portion at Tprime
     if (Tprime.gt.0) then
        sfr_const = 1.0 / min(Tmax, Ttrunc)
     else
        sfr_const = 0.0
     endif

     ! Add formed mass fractions for each component, weighted by component fractions.
     ! Fraction of the constant mass formed by Tprime is just Tprime/Tmax
     mfrac = (1. - pset%const - pset%fburst) * mass_tau / total_mass_tau + &
          pset%const * max(min(Tprime, Ttrunc), 0.0) * sfr_const + &
          pset%fburst * mfrac_burst

     ! N.B. for Tprime = tburst, sfr is infinite, but we ignore that case.
     ! For constant SFR=1, total_mass_const = Tmax
     if (Tprime.gt.Ttrunc) then
        ! We've truncated.
        sfr = 0.
     else
        sfr = (1. - pset%const - pset%fburst) * sfr_tau / total_mass_tau + &
              pset%const * sfr_const
     endif

  ! Add the linear portion, for Simha, SFH=5.
  ! This is the integral of sfr_trunc*(1 - m * (T - Ttrunc)) from Ttrunc to Tz
  else if (pset%sfh.eq.5) then
     m = -pset%sf_slope
     if (m.gt.0) then
        ! find time at which SFR=0, if m>0
        Tz = Ttrunc + 1.0 / m
     else
        ! m <= 0 will never reach SFR=0
        Tz = Tmax
     endif

     ! Logic for Linear portion
     if ((Ttrunc.le.0).or.(Ttrunc.gt.Tmax)) then
        ! Truncation does not occur during the SFH.
        total_mass_linear = 0.
        mass_linear = 0.
        sfr = sfr_tau / total_mass_tau
        frac_linear = 0.
     else
        ! Truncation does occur, integrate linear to zero crossing or Tmax.
        Thi = min(Tz, Tmax)
        sfr_trunc = (Ttrunc/pset%tau) * exp(-Ttrunc/pset%tau)
        total_mass_linear = sfr_trunc * ((Thi - Ttrunc) - m/2.*(Thi**2 + Ttrunc**2) + &
                                         m * Thi * Ttrunc)

        if (Ttrunc.ge.Tprime) then
           ! But Tprime has not reached truncation yet.
           mass_linear = 0.0
           sfr = sfr_tau / (total_mass_tau + total_mass_linear)
        else
           ! Tprime is past truncation, how much mass formed?
           Thi = min(Tz, Tprime)
           mass_linear = sfr_trunc * ((Thi - Ttrunc) - m/2.*(Thi**2 + Ttrunc**2) + &
                                      m * Thi * Ttrunc)
           sfr = max(sfr_trunc * (1 - m * (Tprime - Ttrunc)), 0.) / (total_mass_tau + total_mass_linear)
        endif

     endif

     ! Fractions including tau and linear portions, wrapped in if/else to avoid NaNs
     if (Tprime.ge.0) then
        mfrac = (mass_tau + mass_linear) / (total_mass_tau + total_mass_linear)
        ! Mass fraction of the simha SFH at Tprime that formed in the linear portion.
        frac_linear = mass_linear / (mass_linear + mass_tau)
     else
        mfrac = 0.0
        frac_linear = 0.0
        sfr = 0.0
     endif

  endif

  ! Tabular.  Simple linear interpolation to get the sfr.
  ! The table is in units of yrs of forward time and M_sun/yr.
  if ((pset%sfh.eq.2).or.(pset%sfh.eq.3)) then
     itab = max(min(locate(sfh_tab(1, 1:ntabsfh), age*1e9), ntabsfh-1), 1)
     m = (sfh_tab(2, itab+1) - sfh_tab(2, itab)) / (sfh_tab(1, itab+1) - sfh_tab(1, itab))
     sfr = sfh_tab(2, itab) + m * (age*1e9 - sfh_tab(1, itab))
     sfr = max(sfr, 0.0) * 1e9 ! convert to per Gyr
  endif
  
  ! Convert SFR from per Gyr to per year
  sfr = sfr / 1e9
  
end subroutine sfhinfo

function gammainc(power, arg)
  !
  ! Calculate incomplete gamma for a = 1 or 2

  use sps_vars, only: SP
  implicit none
  integer, intent(in) :: power
  real(SP), intent(in) :: arg

  real(SP) :: gammainc

  if (power.eq.2) then
     gammainc = 1.0 - exp(-arg) - arg * exp(-arg)
  else if (power.eq.1) then
     gammainc = 1.0 - exp(-arg)
  else
     write(*,*) "gammainc: power must be 1 or 2"
     STOP
  endif

end function gammainc

SUBROUTINE ZTINTERP(zpos,spec,lbol,mass,tpos,zpow)

  !Linearly interpolate a grid of SSPs with the following options:
  !1) single metallicity (zpos) for a single age (tpos)
  !2) integrate over an MDF (zpos,zpow) for a grid of ages
  !3) single metallicity (zpos) for a grid of ages

  USE sps_vars; USE sps_utils, ONLY : locate, tsum
  IMPLICIT NONE

  REAL(SP),INTENT(in) :: zpos
  REAL(SP),INTENT(in), OPTIONAL :: tpos,zpow
  REAL(SP),INTENT(inout),DIMENSION(:) :: mass, lbol
  REAL(SP),INTENT(inout),DIMENSION(:,:) :: spec
  INTEGER  :: zlo,zhi,tlo,i
  REAL(SP) :: dz,dt,z0,imdf,w1=0.25,w2=0.5,w3=0.25
  REAL(SP), DIMENSION(nz) :: mdf

  !------------------------------------------------------------!


  !interpolate to a single metallicity and a single time
  IF (PRESENT(tpos)) THEN
     
     IF (SIZE(mass).GT.1.OR.SIZE(lbol).GT.1.OR.SIZE(spec(:,1)).GT.nspec) THEN
        WRITE(*,*) 'ZTINERP ERROR: you specified an age but are '//&
             'asking for the full age array as output!'
        STOP
     ENDIF
     
     IF (PRESENT(zpow)) THEN
        WRITE(*,*) 'ZTINERP ERROR: you cannot specify both an age and'//&
             'an MDF at the same time!'
        STOP
     ENDIF

     tlo = MAX(MIN(locate(time_full,tpos),ntfull-1),1)
     dt  = (tpos - time_full(tlo)) / (time_full(tlo+1) - time_full(tlo))
     zlo = MAX(MIN(locate(LOG10(zlegend/zsol),zpos),nz-1),1)
     dz  = (zpos-LOG10(zlegend(zlo)/zsol)) / &
          ( LOG10(zlegend(zlo+1)/zsol) - LOG10(zlegend(zlo)/zsol) )

     mass = (1-dz)*(1-dt)*mass_ssp_zz(tlo,zlo) + &
          dz*(1-dt)*mass_ssp_zz(tlo,zlo+1) + &
          (1-dz)*dt*mass_ssp_zz(tlo+1,zlo) + &
          dz*dt*mass_ssp_zz(tlo+1,zlo+1)
     
     lbol = (1-dz)*(1-dt)*lbol_ssp_zz(tlo,zlo) + &
          dz*(1-dt)*lbol_ssp_zz(tlo,zlo+1) + &
          (1-dz)*dt*lbol_ssp_zz(tlo+1,zlo) + &
          dz*dt*lbol_ssp_zz(tlo+1,zlo+1)
     
     spec(:,1) = (1-dz)*(1-dt)*spec_ssp_zz(:,tlo,zlo) + &
          dz*(1-dt)*spec_ssp_zz(:,tlo,zlo+1) + &
          (1-dz)*dt*spec_ssp_zz(:,tlo+1,zlo) + &
          dz*dt*spec_ssp_zz(:,tlo+1,zlo+1)
     
  ELSE

     
     !integrate over an MDF and return a grid of ages
     !Note: this is a very crude implementation of an integral
     !over an MDF.  Really the MDF is just specifying a set of 
     !weights over which we sum the Z-dependent SSPs.
     IF (PRESENT(zpow)) THEN

        IF (zpow.LT.0) THEN
           ! This smooths the SSPs in metallicity using a simple
           ! triangular kernel given by w1,w2,w3.  The smoothed SSPs
           ! are then interpolated to the target metallicity.  
           mdf = 0.
           zlo = MAX(MIN(locate(LOG10(zlegend/zsol),zpos),nz-1),1)
           dz  = (zpos-LOG10(zlegend(zlo)/zsol)) / &
                ( LOG10(zlegend(zlo+1)/zsol) - LOG10(zlegend(zlo)/zsol) )
           ! Here the weights for the mdf are a combination of the
           ! triangular kernel weights and the the linear interpolation
           ! weights.  If the kernel extends off the metallicity grid
           ! then the out-of-bounds weights are accumulated at the edges.
           mdf(MAX(zlo-1,1)) = w1*(1-dz)
           mdf(MIN(zlo+2,nz)) = w3*dz
           mdf(zlo)   = mdf(zlo) + w2*(1-dz) + w1*dz
           mdf(zlo+1) = mdf(zlo+1) + w3*(1-dz) + w2*dz
           ! order matters here
           zhi = min(zlo+2, nz)
           zlo = max(zlo-1, 1)
        ELSE
           z0  = 10**zpos*zsol
           !mdf = ds/dlogZ
           mdf = ( zlegend/z0 * EXP(-zlegend/z0) )**zpow
           zlo = 1
           zhi = nz
        ENDIF
        mdf = mdf / SUM(mdf)

        mass = 0.
        lbol = 0.
        spec = 0.
        DO i=zlo,zhi
           mass = mass + mdf(i)*mass_ssp_zz(:,i)
           lbol = lbol + mdf(i)*lbol_ssp_zz(:,i)
           spec = spec + mdf(i)*spec_ssp_zz(:,:,i)
        ENDDO
 
     !interpolate to a single metallicity and return a grid of ages
     ELSE

        zlo = MAX(MIN(locate(LOG10(zlegend/zsol),zpos),nz-1),1)
        dz  = (zpos-LOG10(zlegend(zlo)/zsol)) / &
             ( LOG10(zlegend(zlo+1)/zsol) - LOG10(zlegend(zlo)/zsol) )
        
        mass = (1-dz)*mass_ssp_zz(:,zlo)   + dz*mass_ssp_zz(:,zlo+1)
        lbol = (1-dz)*lbol_ssp_zz(:,zlo)   + dz*lbol_ssp_zz(:,zlo+1)
        spec(:,:) = (1-dz)*spec_ssp_zz(:,:,zlo) + dz*spec_ssp_zz(:,:,zlo+1)
     
     ENDIF

  ENDIF


END SUBROUTINE ZTINTERP

SUBROUTINE ADD_DUST(pset,csp1,csp2,specdust,mdust,ncsp1,ncsp2,nebdust)

  USE sps_vars
  USE sps_utils, ONLY : tsum, locate, attn_curve, linterparr
  IMPLICIT NONE

  REAL(SP), DIMENSION(nspec), INTENT(in) :: csp1,csp2
  TYPE(PARAMS), INTENT(in) :: pset
  REAL(SP), DIMENSION(nspec), INTENT(out) :: specdust
  REAL(SP), INTENT(out) :: mdust
  REAL(SP), DIMENSION(nemline), INTENT(in) :: ncsp1,ncsp2
  REAL(SP), DIMENSION(nemline), INTENT(out) :: nebdust
  INTEGER :: i,qlo,ulo,iself=0
  REAL(SP), DIMENSION(nspec)  :: diff_dust,tau2,cspi
  REAL(SP), DIMENSION(nemline)  :: diff_dust_neb,ncspi
  REAL(SP), DIMENSION(nspec)  :: nu,dumin,dumax
  REAL(SP), DIMENSION(nspec)  :: mduste,duste,oduste,sduste,tduste
  REAL(SP) :: clump_ave,lboln,lbold,labs,gamma,norm,dq,du

  !---------------------------------------------------------------!
  !----------------------Test input params------------------------!
  !---------------------------------------------------------------!

  IF (dust_type.NE.0.AND.dust_type.NE.1.AND.dust_type.NE.2&
       .AND.dust_type.NE.3.AND.dust_type.NE.4) THEN
     WRITE(*,*) 'ADD_DUST ERROR: unknown dust_type: ', dust_type
     STOP
  ENDIF

  IF (pset%uvb.LT.0) THEN
     WRITE(*,*) 'ADD_DUST ERROR: pset%uvb<0!'
     STOP
  ENDIF

  IF (pset%wgp1.LT.1.OR.pset%wgp2.LT.1) THEN
     WRITE(*,*) 'ADD_DUST ERROR: pset%wgp1 and/or pset%wgp2 '//&
          'out of bounds: ',pset%wgp1,pset%wgp2
     STOP
  ENDIF

  IF (pset%dust_clumps.GT.tiny_number) THEN
     WRITE(*,*) 'ADD_DUST ERROR: dust_clumps feature no longer supported'
     STOP
  ENDIF

  IF (pset%frac_obrun.LT.0.0.OR.pset%frac_obrun.GT.1.0.OR.&
       pset%frac_nodust.LT.0.0.OR.pset%frac_nodust.GT.1.0) THEN
     WRITE(*,*) 'ADD_DUST ERROR: frac_obrun and/or frac_nodust out of bounds'
     STOP
  ENDIF

  !---------------------------------------------------------------!
  !----------------------Add dust absorption----------------------!
  !---------------------------------------------------------------!

  !compute attenuation curve for diffuse dust
  diff_dust = EXP(-attn_curve(spec_lambda,dust_type,pset))
 
  !combine old and young stars, attenuating the young
  !with a fixed power-law attn curve, and allowing a fraction
  !of the young stars to be dust-free ("OB runaways")
  cspi = csp1 * EXP(-pset%dust1*(spec_lambda/5500.)**(pset%dust1_index))*&
       (1-pset%frac_obrun) + csp1*pset%frac_obrun + csp2
  
  !allow a fraction of the diffuse dust spectrum to be dust-free
  specdust  = cspi*diff_dust*(1-pset%frac_nodust) + &
       cspi*pset%frac_nodust

  !as above, for nebular line luminosities
  diff_dust_neb = linterparr(spec_lambda,diff_dust,nebem_line_pos)
  ncspi = ncsp1 * EXP(-pset%dust1*(nebem_line_pos/5500.)**(pset%dust1_index))*&
       (1-pset%frac_obrun) + ncsp1*pset%frac_obrun + ncsp2
  nebdust  = ncspi*diff_dust_neb*(1-pset%frac_nodust) + &
       ncspi*pset%frac_nodust

  !---------------------------------------------------------------!
  !----------------------Add dust emission------------------------!
  !---------------------------------------------------------------!
  
  ! The dust spectrum is computed according to Draine & Li 2007
  ! we are computing the integral of the dust spectrum over P(U)dU
  ! by considering two components, a delta function at Umin and 
  ! a power-law distribution from Umin to Umax=1E6 and alpha=2
  ! the relative weights of the two components are given by gamma
  
  IF (add_dust_emission.EQ.1) THEN 

     !only add dust emission if there is absorption
     IF (pset%dust2.GT.tiny_number.OR.pset%dust1.GT.tiny_number) THEN

        iself=0
        !compute Lbol both before and after dust attenuation
        !this will determine the normalization of the dust emission
        nu    = clight/spec_lambda
        lbold = TSUM(nu,specdust)
        lboln = TSUM(nu,csp1+csp2)
        IF (nebemlineinspec.EQ.0) THEN
           lboln = lboln + SUM(ncsp1) + SUM(ncsp2) - SUM(nebdust)
        ENDIF

        !set up qpah interpolation
        qlo = MAX(MIN(locate(qpaharr,pset%duste_qpah),nqpah_dustem-1),1)
        dq  = (pset%duste_qpah-qpaharr(qlo))/(qpaharr(qlo+1)-qpaharr(qlo))
        dq  = MIN(MAX(dq,0.0),1.0)  !no extrapolation
        
        !set up Umin interpolation
        !set limits on Umin: 0.1<Umin<25.0
        ulo = MAX(MIN(locate(uminarr,pset%duste_umin),numin_dustem),1)
        du  = (pset%duste_umin-uminarr(ulo))/(uminarr(ulo+1)-uminarr(ulo))
        du  = MIN(MAX(du,0.0),1.0)  !no extrapolation

        !set limits to gamma (gamma is a fraction)
        gamma = MAX(MIN(pset%duste_gamma,1.0),0.0)

        !bi-linear interpolation over qpah and Umin
        dumin = (1-dq)*(1-du)*dustem2_dustem(:,qlo,2*ulo-1) + &
             dq*(1-du)*dustem2_dustem(:,qlo+1,2*ulo-1) + &
             dq*du*dustem2_dustem(:,qlo+1,2*(ulo+1)-1) + &
             (1-dq)*du*dustem2_dustem(:,qlo,2*(ulo+1)-1)
        dumax = (1-dq)*(1-du)*dustem2_dustem(:,qlo,2*ulo) + &
             dq*(1-du)*dustem2_dustem(:,qlo+1,2*ulo) + &
             dq*du*dustem2_dustem(:,qlo+1,2*(ulo+1)) + &
             (1-dq)*du*dustem2_dustem(:,qlo,2*(ulo+1))

        !combine both parts of P(U)dU
        mduste = (1-gamma)*dumin + gamma*dumax
        mduste = MAX(mduste,tiny_number)

        !normalize the dust emission to the luminosity absorbed by 
        !the dust, i.e., demand that Lbol remains the same
        labs = (lboln-lbold)
        norm   = TSUM(nu,mduste)
        duste  = mduste/norm * labs
        duste  = MAX(duste,tiny_number)

        !include dust self-absorption
        !we need to iterate because the dust
        !will re-emit and be re-absorbed, etc.
        tduste = 0.0
        DO WHILE (((lboln-lbold).GT.1E-2).OR.iself.EQ.0)

           oduste = duste
           duste  = duste * diff_dust
           tduste = tduste + duste
           
           lbold = TSUM(nu,duste)  !after  self-abs
           lboln = TSUM(nu,oduste) !before self-abs

           duste = MAX(mduste/norm*(lboln-lbold),tiny_number)
           
           iself=1

        ENDDO

        !this factor assumes Md/Mh=0.01 (appropriate for the 
        !MW3.1 models), and includes conversion factors from 
        !Jy -> Lsun and the hydrogen mass in solar units
        mdust = 3.21E-3 / 4/mypi * labs/norm

        !add the dust emission to the stellar spectrum
        specdust = specdust + tduste
        
     ELSE
        mdust = tiny_number
     ENDIF

  ENDIF

END SUBROUTINE ADD_DUST

! ------------------------------------
! Routines used to evaluate the indefinite integrals that arise when exactly
! integrating interpolated spectra weighted by particular SFHs.
!
! Adding new SFHs is as easy as adding new sfh%type cases in both sfhint_*
! functions below (and making sure the sfhlimits.f90 make sense)
! ------------------------------------

function intsfwght(sspind, logt, sfh)
  ! Wrapper on the sfhint_* routines to choose the correct interpolation type
  ! and calculate the definite integral of the weighted SFR between the given
  ! limits.
  !
  ! Inputs
  ! -------
  !
  ! sspind:
  !    The index of the SSP forming the bracket with the SSP you are getting a
  !    weight for.
  !
  ! logt:
  !    the limits of the integral, 2-element array (lo, hi) of
  !    log(lookback time) (in yrs).
  !
  ! sfh:
  !    Structure containing the SFH parameters in units of years, including an
  !    integer `type` specifiying the form of SFR(t).
  !
  ! Outputs
  !--------
  !  intsfwght:
  !    The exact definite integral between the limits specified in `logt`.
  
  use sps_vars, only: interpolation_type, SFHPARAMS, SP
  implicit none
  
  integer, intent(in) :: sspind
  real(SP), intent(in), dimension(2) :: logt
  type(SFHPARAMS), intent(in) :: sfh

  real(SP) :: intsfwght, sfwght_log, sfwght_lin

  if (interpolation_type.eq.0) then
     intsfwght =  sfwght_log(sspind, logt(2), sfh) - sfwght_log(sspind, logt(1), sfh)
  else if (interpolation_type.eq.1) then
     intsfwght = (sfwght_lin(sspind, 10**logt(2), sfh) - sfwght_lin(sspind, 10**logt(1), sfh))
  endif
  
end function intsfwght
   

function sfwght_log(sspind, logt, sfh)
  ! Evaluates the indefinite integral of the interpolation weight in log time,
  ! weighted by the SFH, and evaluated at `logt`.  In detail, this function
  ! returns:
  !   (\int dt \, \mathrm{SFR}(t) \, (x - \log t) )|_{\texttt{logt}}
  ! where x = time_full(ssp_ind) and `t` is *lookback* time.
  !
  ! Inputs
  ! -------
  !
  ! sspind:
  !    The index of the SSP forming the bracket with the SSP you are getting a
  !    weight for.
  !
  ! logt:
  !    Where the indefinite integral is evaluated, log(t_lookback) (in yrs).
  !
  ! sfh:
  !    Structure containing the SFH parameters in units of years, including an
  !    integer `type` specifiying the form of SFR(t).
  !
  ! Outputs
  !--------
  !  sfwght_log:
  !    The exact indefinite integral, evaluated at `logt`.  Scalar float.
  
  use sps_vars, only: time_full, tiny_logt, SFHPARAMS, SP
  implicit none
  
  integer, intent(in) :: sspind
  real(SP), intent(in) :: logt
  type(SFHPARAMS), intent(in) :: sfh

  real(SP) :: sfwght_log

  real(SP) :: loge, ei
  real(SP) :: logage, tprime ! intermediate time variables
  real(SP) :: a, b, c ! dummy variables used to break up long expressions

  REAL(SP), PARAMETER :: e=2.7182818284590452353602874713526624977572_sp
  loge = log10(e)

  ! Zero index means use ~0 age.
  if (sspind.gt.0) then
     logage = time_full(sspind)
  else
     logage = tiny_logt
  endif
     
  if (sfh%type.eq.0) then
     ! SFR = Constant ~ 1
     sfwght_log = 10**logt * (logage - logt + loge)
     
  else if (sfh%type.eq.1) then
     ! SFR = exponential ~ exp(-T/tau)
     tprime = 10**logt / sfh%tau
     sfwght_log = (logage - logt) * exp(tprime) + loge * ei(tprime)

  else if (sfh%type.eq.4) then
     ! SFR = delayed exponential ~ T/tau exp(-T/tau)
     tprime = 10**logt / sfh%tau ! t/tau
     a = (10**logt - sfh%tage - sfh%tau) * (logt - logage)
     b = sfh%tau * loge
     c = (sfh%tage + sfh%tau) * loge
     sfwght_log = (a - b) * exp(tprime) + c * ei(tprime)
     
  else if (sfh%type.eq.5) then
     !SFR = linear ~ (1 - sf_slope * (T - T_trunc)), T > T_trunc
     tprime = max(0.0, sfh%tage - sfh%sf_trunc) !t_q
     a = 1 - sfh%sf_slope * tprime
     b = a * 10**logt * (logage - logt + loge)
     c = sfh%sf_slope * (10**logt)**2 / 2 * (logage - logt + loge / 2)
     sfwght_log = b + c
     
  endif
  
end function sfwght_log


function sfwght_lin(sspind, t, sfh)
  ! Evaluates the indefinite integral of the interpolation weight in linear
  ! time, weighted by the SFH, and evaluated at `logt`.  In detail, this
  ! function returns:
  !   (\int dt \, \mathrm{SFR}(t) \, (x - t) )|_{\texttt{t}}
  ! where x = 10**time_full(ssp_ind), and `t` is *lookback* time.
  !
  ! Inputs
  ! -------
  !
  ! sspind:
  !    The index of the SSP forming the bracket with the SSP you are getting a
  !    weight for.
  !
  ! t:
  !    Where the indefinite integral is evaluated, linear years (lookback time).
  !
  ! sfh:
  !    Structure containing the SFH parameters in units of years, including an
  !    integer `type` specifiying the form of SFR(t).
  !
  ! Outputs
  !--------
  !  sfwght_lin:
  !    The indefinite integral, evaluated at `t`

  use sps_vars, only: time_full, tiny_logt, SFHPARAMS, SP
  implicit none
  
  integer, intent(in) :: sspind 
  real(SP), intent(in) :: t
  type(SFHPARAMS), intent(in) :: sfh

  real(SP) :: sfwght_lin
  
  real(SP) :: age, tprime
  real(SP) :: a

  ! Convert from log(age_ssp) to age_ssp,
  ! accounting for the case sspind=0 (where age~0)
  if (sspind.gt.0) then
     age = 10**time_full(sspind)
  else
     age = 10**tiny_logt
  endif

  if (sfh%type.eq.0) then
     ! SFR = Constant ~ 1
     sfwght_lin = age * t - t**2 / 2

  else if (sfh%type.eq.1) then
     ! SFR = exponential ~ 1/tau * exp(-T/tau)
     tprime = t / sfh%tau
     sfwght_lin = (age - t + sfh%tau) * exp(tprime)

  else if (sfh%type.eq.4) then
     ! SFR = delayed exponential ~ T/tau**2 * exp(-T/tau)
     tprime = t / sfh%tau
     a = sfh%tage * age - (sfh%tage + age) * (t - sfh%tau) + &
          t**2 - 2*t*sfh%tau + 2*sfh%tau**2
     sfwght_lin = a * exp(tprime)
     
  else if (sfh%type.eq.5) then
     ! SFR = linear ~ (1 - sf_slope * (T - T_trunc)), T > T_trunc
     tprime = max(0.0, sfh%tage - sfh%sf_trunc) !t_q
     a = 1 - sfh%sf_slope * tprime
     sfwght_lin = a * age * t + (sfh%sf_slope*age - a) * t**2 / 2 - sfh%sf_slope * t**3 / 3

  endif

end function sfwght_lin


FUNCTION EI(X)
!
! ============================================
! Purpose: Compute exponential integral Ei(x)
! Input :  x  --- Argument of Ei(x)
! Output:  EI --- Ei(x)
!
! Shanjie Zhang and Jianming Jin
!
!  Copyrighted but permission granted to use code in programs.
!  Buy their book "Computation of Special Functions", 1996, John Wiley & Sons, Inc.
!
!       ============================================
!
  implicit none
  INTEGER, PARAMETER :: SP = KIND(1.d0)
  REAL(SP) :: X, EI

  INTEGER :: K, MAXIT=1000
  REAL(SP), PARAMETER :: GA=0.5772156649015328D0, eps=1.0D-20
  REAL(SP) :: R
  
  IF (X.EQ.0.0) THEN
     EI=-1.0D+300
  ELSE IF (X .LT. 0) THEN
     WRITE(*,*) "EI: X < 0."
     STOP
  ELSE IF (DABS(X).LE.40.0) THEN
     ! Power series around x=0
     EI=1.0D0
     R=1.0D0
     DO K = 1, MAXIT
        R = R*K*X / (K+1.0D0)**2
        EI = EI+R
        IF (DABS(R/EI).LE.eps) THEN
           CONTINUE
        ELSE IF (K.eq.MAXIT) then
           write(*,*) "EI: Series failed to converge."
           STOP
        ENDIF
           
     ENDDO
     EI=GA+DLOG(X)+X*EI

  ELSE
     ! Asymptotic expansion (the series is not convergent)
     EI=1.0D0
     R=1.0D0
     DO K=1,20
        R=R*K/X
        EI=EI+R
     ENDDO
     EI=DEXP(X)/X*EI
  ENDIF
  RETURN
END FUNCTION EI

SUBROUTINE ADD_BS(s_bs,t,mini,mact,logl,logt,logg,phase, &
     wght,hb_wght,nmass)

  !routine to add blue straggler stars into older 
  !stellar populations.  The BS stars are just an extension
  !of the main sequence.
  !They are given a weight relative to the horizontal branch, 
  !S_bs, a metric which is common in the literature but is 
  !otherwise not terribly physical.

  !They are also given masses appropriate for MS stars with 
  !their luminosity and Teff.  This is suggested by the recent
  !results of M67 (Liu et al. 2008), but should nontheless be 
  !considered an uncertainty.

  !Note that the parameter bhb_sbs_time, set in sps_vars.f90,
  !sets the turn-on time for this modification

  USE sps_vars; USE sps_utils, ONLY : linterp
  IMPLICIT NONE

  REAL(SP), INTENT(inout), DIMENSION(nt,nm) :: mini,mact,&
       logl,logt,logg,phase
  REAL(SP), INTENT(inout), DIMENSION(nm) :: wght
  REAL(SP), INTENT(in) :: hb_wght, s_bs
  INTEGER, INTENT(in)  :: t
  INTEGER, INTENT(inout), DIMENSION(nt) :: nmass
  INTEGER, PARAMETER :: nbs = 20 !Number of BS stars to add
  !weight given to total BS population
  REAL(SP) :: bs_wght=0.
  REAL(SP) :: tol=0., msspl=0.
  INTEGER  :: maxt=0,i,k

  !---------------------------------------------------------------!
  !---------------------------------------------------------------!

  tol = 0.0
  bs_wght = s_bs * hb_wght
  
  !find the extent of the t~0 MS
  maxt = 1
  DO WHILE(logl(1,maxt).LT.3.5)
     maxt = maxt+1
  ENDDO

  !find the MS turn-off at the current age
  i=0
  DO WHILE (tol.LT.0.2)
     i = i+1
     msspl = linterp(logt(1,1:maxt),logl(1,1:maxt),logt(t,i))
     tol   = ABS(msspl-logl(t,i))
  ENDDO

  !now add the BS stars
  DO k=1,nbs

     !distribute them uniformly from L_TO to L_TO+0.75 dex
     !luminosity offset by 0.2 dex to better match NGC 5466
     logl(t,nmass(t)+k) = k*0.75/nbs + logl(t,i-1) + 0.2
     mini(t,nmass(t)+k) = linterp(logl(1,1:maxt),mini(1,1:maxt),&
          logl(t,nmass(t)+k))
     mact(t,nmass(t)+k) = mini(t,nmass(t)+k)
     logt(t,nmass(t)+k) = linterp(logl(1,1:maxt),logt(1,1:maxt),&
          logl(t,nmass(t)+k))
     logg(t,nmass(t)+k) = LOG10( gsig4pi*mact(t,nmass(t)+k)/&
          10**logl(t,nmass(t)+k) ) + 4*logt(t,nmass(t)+k)
     phase(t,nmass(t)+k) = 7.
     wght(nmass(t)+k)    = 1./nbs*bs_wght
     
  ENDDO

  !update number of stars in the isochrone
  nmass(t) = nmass(t) + nbs

  IF (nmass(t).GT.nm) THEN
     WRITE(*,*) 'ADD_BS ERROR: number of mass points GT nm'
     STOP
  ENDIF

  RETURN

END SUBROUTINE ADD_BS

PROGRAM SPEC_BIN

  !routine to convert ascii spectral files to binary
  !must be run twice for each value of isoc_type var

  USE sps_vars
  IMPLICIT NONE
  INTEGER  :: z,dumi1,i,j
  REAL(SP) :: dumr1,d2,d3
  CHARACTER(6) :: zstype

  !----------------------------------------------------------------!

  CALL GETENV('SPS_HOME',SPS_HOME)
  
  IF (spec_type.EQ.'basel') THEN
     OPEN(90,FILE=TRIM(SPS_HOME)//'/SPECTRA/BaSeL3.1/zlegend.dat',&
          STATUS='OLD',ACTION='READ')
  ELSE IF (spec_type.EQ.'miles') THEN
     OPEN(90,FILE=TRIM(SPS_HOME)//'/SPECTRA/MILES/zlegend.dat',&
          STATUS='OLD',ACTION='READ')
  ELSE IF (spec_type.EQ.'ckc14') THEN
     OPEN(90,FILE=TRIM(SPS_HOME)//'/SPECTRA/CKC14/zlegend.dat',&
          STATUS='OLD',ACTION='READ')
  ENDIF
  DO z=1,nzinit
     READ(90,'(F6.4)') zlegendinit(z)
  ENDDO
  CLOSE(90)

  DO z=1,nzinit
     
     WRITE(zstype,'(F6.4)') zlegendinit(z)

     IF (spec_type.EQ.'basel') THEN
        OPEN(92,FILE=TRIM(SPS_HOME)//'/SPECTRA/BaSeL3.1/basel_'&
             //basel_str//'_z'//zstype//'.spectra',FORM='FORMATTED',&
             STATUS='OLD',ACTION='READ')
        OPEN(93,FILE=TRIM(SPS_HOME)//'/SPECTRA/BaSeL3.1/basel_'&
             //basel_str//'_z'//zstype//'.spectra.bin',&
             FORM='UNFORMATTED',STATUS='REPLACE',access='direct',&
             recl=nspec*ndim_logg*ndim_logt*4)

     ELSE IF (spec_type.EQ.'miles') THEN
        OPEN(92,FILE=TRIM(SPS_HOME)//'/SPECTRA/MILES/imiles_z'&
             //zstype//'.spectra',FORM='FORMATTED',&
             STATUS='OLD',ACTION='READ')
        OPEN(93,FILE=TRIM(SPS_HOME)//'/SPECTRA/MILES/imiles_z'&
             //zstype//'.spectra.bin',FORM='UNFORMATTED',&
             STATUS='REPLACE',access='direct',&
             recl=nspec*ndim_logg*ndim_logt*4)

     ELSE IF (spec_type(1:5).EQ.'ckc14') THEN
        OPEN(92,FILE=TRIM(SPS_HOME)//'/SPECTRA/CKC14/'//spec_type//'_z'&
             //zstype//'.spectra',FORM='FORMATTED',&
             STATUS='OLD',ACTION='READ')
        OPEN(93,FILE=TRIM(SPS_HOME)//'/SPECTRA/CKC14/'//spec_type//'_z'&
             //zstype//'.spectra.bin',FORM='UNFORMATTED',&
             STATUS='REPLACE',access='direct',&
             recl=nspec*ndim_logg*ndim_logt*4)
  
    ENDIF

     DO i=1,ndim_logg
        DO j=1,ndim_logt
           READ(92,*) dumi1,d2,d3,dumr1
           READ(92,*) speclib(:,z,j,i)
        ENDDO
     ENDDO

     WRITE(93,rec=1) speclib(:,z,:,:)
     CLOSE(92)
     CLOSE(93)
     
  ENDDO
  
END PROGRAM SPEC_BIN

FUNCTION MYARTH(first,increment,n)

  USE sps_vars
  IMPLICIT NONE
  REAL(SP), INTENT(IN) :: first,increment
  INTEGER, INTENT(IN) :: n
  INTEGER, PARAMETER :: NPAR_ARTH=16,NPAR2_ARTH=8
  REAL(SP), DIMENSION(n) :: myarth
  INTEGER :: k,k2
  REAL(SP) :: temp

  IF (n > 0) myarth(1)=first
  IF (n <= NPAR_ARTH) THEN
     DO k=2,n
        myarth(k)=myarth(k-1)+increment
     ENDDO
  ELSE
     DO k=2,NPAR2_ARTH
        myarth(k)=myarth(k-1)+increment
     ENDDO
     temp=increment*NPAR2_ARTH
     k=NPAR2_ARTH
     DO
        IF (k >= n) EXIT
        k2=k+k
        myarth(k+1:MIN(k2,n))=temp+myarth(1:MIN(k,n-k))
        temp=temp+temp
        k=k2
     ENDDO
  ENDIF

END FUNCTION MYARTH

!---------------------------------------------------------------!
!---------------------------------------------------------------!

SUBROUTINE MYTRAPZD(func,a,b,s,n)

  USE sps_vars
  IMPLICIT NONE
  REAL(SP), INTENT(IN) :: a,b
  REAL(SP), INTENT(INOUT) :: s
  INTEGER, INTENT(IN) :: n
  INTERFACE
     FUNCTION func(x)
       USE sps_vars
       REAL(SP), DIMENSION(:), INTENT(IN) :: x
       REAL(SP), DIMENSION(SIZE(x)) :: func
     END FUNCTION func
  END INTERFACE
  INTERFACE
     FUNCTION myarth(first,increment,n)
       USE sps_vars
       REAL(SP), INTENT(IN) :: first,increment
       INTEGER, INTENT(IN) :: n
       REAL(SP), DIMENSION(n) :: myarth
     END FUNCTION myarth
  END INTERFACE
  REAL(SP) :: del,fsum
  INTEGER :: it

  IF (n == 1) THEN
     s=0.5*(b-a)*SUM(func( (/ a,b /) ))
  ELSE
     it=2**(n-2)
     del=(b-a)/it
     fsum=SUM(func(myarth(a+0.5*del,del,it)))
     s=0.5*(s+del*fsum)
  ENDIF

END SUBROUTINE MYTRAPZD

!---------------------------------------------------------------!
!---------------------------------------------------------------!

SUBROUTINE MYPOLINT(xa,ya,x,y,dy)

  USE sps_vars
  IMPLICIT NONE
  REAL(SP), DIMENSION(:), INTENT(IN) :: xa,ya
  REAL(SP), INTENT(IN) :: x
  REAL(SP), INTENT(OUT) :: y,dy
  INTEGER :: m,n,ns
  INTEGER, DIMENSION(1) :: imin
  REAL(SP), DIMENSION(SIZE(xa)) :: c,d,den,ho

  n  = SIZE(xa)
  c  = ya
  d  = ya
  ho = xa-x
  imin = MINLOC(ABS(x-xa))
  ns = imin(1)
  y  = ya(ns)
  ns = ns-1

  DO m=1,n-1
     den(1:n-m)=ho(1:n-m)-ho(1+m:n)
     IF (ANY(den(1:n-m) == 0.0)) &
          WRITE(*,*) 'POLINT ERROR'
     den(1:n-m)=(c(2:n-m+1)-d(1:n-m))/den(1:n-m)
     d(1:n-m)=ho(1+m:n)*den(1:n-m)
     c(1:n-m)=ho(1:n-m)*den(1:n-m)
     IF (2*ns < n-m) THEN
        dy=c(ns+1)
     ELSE
        dy=d(ns)
        ns=ns-1
     ENDIF
     y=y+dy
  ENDDO
  
END SUBROUTINE MYPOLINT

!---------------------------------------------------------------!
!---------------------------------------------------------------!

FUNCTION FUNCINT(func,a,b)

  USE sps_vars
  IMPLICIT NONE
  REAL(SP), INTENT(IN) :: a,b
  REAL(SP) :: funcint
  INTERFACE
     FUNCTION func(x)
       USE sps_vars
       REAL(SP), DIMENSION(:), INTENT(IN) :: x
       REAL(SP), DIMENSION(size(x)) :: func
     END FUNCTION func
  END INTERFACE
  INTERFACE 
     SUBROUTINE MYPOLINT(xa,ya,x,y,dy)
       USE sps_vars
       REAL(SP), DIMENSION(:), INTENT(IN) :: xa,ya
       REAL(SP), INTENT(IN) :: x
       REAL(SP), INTENT(OUT) :: y,dy
     END SUBROUTINE MYPOLINT
  END INTERFACE
  INTEGER, PARAMETER :: JMAX=20,JMAXP=JMAX+1,K=5,KM=K-1
  REAL(SP), PARAMETER :: EPS=1.0e-7
  REAL(SP), DIMENSION(JMAXP) :: h,s
  REAL(SP) :: dqromb,zero=0.0
  INTEGER :: j

  h(1)=1.0
  DO j=1,JMAX
     CALL mytrapzd(func,a,b,s(j),j)
     IF (j >= K) THEN
        CALL mypolint(h(j-KM:j),s(j-KM:j),zero,funcint,dqromb)
        IF (abs(dqromb) <= EPS*ABS(funcint)) RETURN
     ENDIF
     s(j+1)=s(j)
     h(j+1)=0.25*h(j)
  ENDDO

  WRITE(*,*) 'FUNCINT ERROR:',a,b

END FUNCTION FUNCINT

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  Routine to calculate the evolution of a single stellar          !
!  population from a set of input theoretical isochrones and a     !
!  heterogeneous library of stellar spectra.  The code also allows !
!  for variation in the horizontal branch morphology, TP-AGB       !
!  phase, and the blue straggler population.  The output is a      !
!  time-dependent spectrum from the far-UV to the far-IR.          !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!   PARAMETER RANGES:
!   1.  if (fbhb,sbs)<1E-3 then (fbhb,sbs)=0.0
!   2.  if abs(delt)>0.5 then abs(delt)=0.5
!
!-----------------------------------------------------------!
!-----------------------------------------------------------!

SUBROUTINE SSP_GEN(pset,mass_ssp,lbol_ssp,spec_ssp)

  USE sps_vars; USE sps_utils
  IMPLICIT NONE
  
  INTEGER :: i=1, j=1, stat,ii,klo,khi,tlo,thi
  !weight given to the entire horizontal branch
  REAL(SP) :: hb_wght,dt,tco
  !array of IMF weights
  REAL(SP), DIMENSION(nm) :: wght
  !SSP spectrum
  REAL(SP), INTENT(inout), DIMENSION(nspec,ntfull) :: spec_ssp
  REAL(SP), DIMENSION(nspec,ntfull) :: tspec_ssp
  !Mass and Lbol info
  REAL(SP), INTENT(inout), DIMENSION(ntfull) :: mass_ssp, lbol_ssp

  !temp arrays for the isochrone data
  REAL(SP), DIMENSION(nt,nm) :: mini,mact,logl,logt,logg,&
       ffco,phase,lmdot
  !arrays holding the number of mass elements for each 
  !isochrone and the age of each isochrone
  INTEGER, DIMENSION(nt)     :: nmass
  REAL(SP), DIMENSION(nt)    :: time
  REAL(SP), DIMENSION(nspec) :: tspec
  !structure containing all necessary parameters
  !(TYPE objects defined in sps_vars.f90)
  TYPE(PARAMS), INTENT(in) :: pset
  CHARACTER(2) :: istr,istr2

  !-----------------------------------------------------------!
  !--------------------------Setup----------------------------!
  !-----------------------------------------------------------!

  IF (check_sps_setup.EQ.0) THEN
     WRITE(*,*) 'SSP_GEN ERROR0: '//&
          'SPS_SETUP must be run once before calling SSP_GEN. '
     STOP
  ENDIF

  !reset arrays
  spec_ssp = 0.
  mass_ssp = 0.
  lbol_ssp = 0.

  !test metallicity range
  IF (pset%zmet.LT.1.OR.pset%zmet.GT.nz) THEN
     WRITE(*,*) 'SSP_GEN ERROR: metallicity outside of range',pset%zmet
     STOP
  ENDIF

  IF (isoc_type.EQ.'bpss') THEN

     !the BPASS SSPs are stored in a master array so simply
     !pull the relevant metallicity model into spec_ssp
     spec_ssp = bpass_spec_ssp(:,:,pset%zmet)
     mass_ssp = bpass_mass_ssp(:,pset%zmet)
    
  ELSE

     IF (imf_type.NE.0.AND.imf_type.NE.1.AND.imf_type.NE.2.&
          .AND.imf_type.NE.3.AND.imf_type.NE.4.AND.imf_type.NE.5) THEN
        WRITE(*,*) 'SSP_GEN ERROR: IMF type outside of range',imf_type
        STOP
     ENDIF
     
     !dump IMF parameters into common block
     imf_alpha(1) = pset%imf1
     imf_alpha(2) = pset%imf2
     imf_alpha(3) = pset%imf3
     imf_vdmc     = pset%vdmc
     imf_mdave    = pset%mdave
     
     !read in user-defined IMF (this needs to be done here rather than
     !in sps_setup because the user can change the IMF without having
     !to re-run the setup
     IF (imf_type.EQ.5) THEN
        IF (TRIM(pset%imf_filename).EQ.'') THEN
           OPEN(13,FILE=TRIM(SPS_HOME)//'/data/imf.dat',ACTION='READ',STATUS='OLD')
        ELSE
           OPEN(13,FILE=TRIM(SPS_HOME)//'/data/'//TRIM(pset%imf_filename),&
                ACTION='READ',STATUS='OLD')
        ENDIF
        DO i=1,100
           READ(13,*,IOSTAT=stat) imf_user_alpha(1,i),imf_user_alpha(2,i),&
                imf_user_alpha(3,i)
           IF (stat.NE.0) GOTO 29
        ENDDO
        WRITE(*,*) 'SSP_GEN ERROR: didnt finish reading in the imf file'
        STOP
29      CONTINUE
        CLOSE(13)
        n_user_imf = i-1
        !define the upper and lower IMF limits
        imf_lower_limit = imf_user_alpha(1,1)
        imf_upper_limit = imf_user_alpha(2,n_user_imf)
     ENDIF
     
     !transfer isochrones into temporary arrays
     mini  = mini_isoc(pset%zmet,:,:)  !initial mass
     mact  = mact_isoc(pset%zmet,:,:)  !actual (present) mass
     logl  = logl_isoc(pset%zmet,:,:)  !log(Lbol)
     logt  = logt_isoc(pset%zmet,:,:)  !log(Teff)
     logg  = logg_isoc(pset%zmet,:,:)  !log(g)
     ffco  = ffco_isoc(pset%zmet,:,:)  !is the TP-AGB star C-rich or O-rich?
     phase = phase_isoc(pset%zmet,:,:) !flag indicating phase of evolution
     lmdot = lmdot_isoc(pset%zmet,:,:) !log Mdot
     nmass = nmass_isoc(pset%zmet,:)   !number of elements per isochrone
     time  = timestep_isoc(pset%zmet,:)!age of each isochrone in log(yr)
     
     !write for control
     IF (verbose.EQ.1) THEN
        WRITE(*,*)
        WRITE(*,'("   Log(Z/Zsol): ",F6.3)') LOG10(zlegend(pset%zmet)/0.019)
        WRITE(*,'("   Fraction of blue HB stars: ",F6.3)') pset%fbhb
        WRITE(*,'("   Ratio of BS to HB stars  : ",F6.3)') pset%sbss
        WRITE(*,'("   Shift to TP-AGB [log(Teff),log(Lbol)]: ",F5.2,1x,F5.2)') &
             pset%delt, pset%dell
        IF (imf_type.EQ.2) THEN
           WRITE(*,'("   IMF: ",I1,", slopes= ",3F4.1)') &
                imf_type,imf_alpha
        ELSE IF (imf_type.EQ.3) THEN
           WRITE(*,'("   IMF: ",I1,", cut-off= ",F4.2)') imf_type,imf_vdmc
        ELSE
           WRITE(*,'("   IMF: ",I1)') imf_type
        ENDIF
     ENDIF
     
     !-----------------------------------------------------------!
     !---------------------Generate SSPs-------------------------!
     !-----------------------------------------------------------!
     
     !loop over each isochrone
     DO i=1,nt
        
        !flag that allows us to compute only a subset of models
        IF (pset%ssp_gen_age(i).EQ.0) CYCLE
        
        !reset arrays
        hb_wght  = 0.
        wght     = 0.
        
        IF (verbose.EQ.1) &
             WRITE(*,'("age=",F5.2)') time(i)
        
        !compute IMF-based weights
        CALL IMF_WEIGHT(mini(i,:),wght,nmass(i))
        
        !modify the horizontal branch
        !need the hb weight for the blue stragglers too
        IF (pset%fbhb.GT.0.0.OR.pset%sbss.GT.1E-3) &
             CALL MOD_HB(pset%fbhb,i,mini,mact,logl,logt,logg,phase,&
             wght,hb_wght,nmass,time(i))
        
        !add in blue stragglers
        IF (time(i).GE.bhb_sbs_time.AND.pset%sbss.GT.1E-3) &
             CALL ADD_BS(pset%sbss,i,mini,mact,logl,logt,logg,phase,&
             wght,hb_wght,nmass)
        
        !modify the TP-AGB stars and Post-AGB stars
        CALL MOD_GB(pset%zmet,i,time,pset%delt,pset%dell,pset%pagb,&
             pset%redgb,pset%agb,nmass(i),logl,logt,phase,wght)
        
        ii = 1 + (i-1)*time_res_incr
        
        !compute IMF-weighted mass of the SSP
        mass_ssp(ii) = SUM(wght(1:nmass(i))*mact(i,1:nmass(i)))
        
        !add in remant masses
        IF (add_stellar_remnants.EQ.1) THEN 
           CALL ADD_REMNANTS(mass_ssp(ii),MAXVAL(mini(i,:)))
        ENDIF
        
        !compute IMF-weighted bolometric luminosity (actually log(Lbol))
        lbol_ssp(ii) = LOG10(SUM(wght(1:nmass(i))*10**logl(i,1:nmass(i))))
        
        !compute SSP spectrum
        spec_ssp(:,ii) = 0.
        DO j=1,nmass(i)
           
           tco = ffco(i,j)
           IF (phase(i,j).EQ.5.AND.tco.GT.1.0) THEN
              !dilute the C star fraction
              !IF (1.0.GE.pset%fcstar) tco = 1.0
           ENDIF
           
           CALL GETSPEC(pset,mact(i,j),logt(i,j),&
                10**logl(i,j),logg(i,j),phase(i,j),tco,lmdot(i,j),&
                wght(j)/MAXVAL(wght(1:nmass(i))*10**logl(i,1:nmass(i))),tspec)
           
           !only construct SSPs for particular evolutionary
           !phases if evtype NE -1
           IF ((pset%evtype.EQ.-1.OR.pset%evtype.EQ.phase(i,j))&
                .AND.mini(i,j).LT.pset%masscut) &
                spec_ssp(:,ii) = wght(j)*tspec + spec_ssp(:,ii)
           
        ENDDO
        
     ENDDO

  ENDIF

  !-------------------------------------------------------------!
  !-now interpolate the SSPs to fill out the expanded time grid-!
  !-------------------------------------------------------------!
  
  IF (time_res_incr.GT.1) THEN
     DO j=1,ntfull
        IF (MOD(j-1,time_res_incr).EQ.0) CYCLE
        klo = MAX(MIN(locate(time,time_full(j)),nt-1),1)
        dt  = (time_full(j)-time(klo))/(time(klo+1)-time(klo))
        klo = 1+(klo-1)*time_res_incr
        khi = klo+time_res_incr
        spec_ssp(:,j) = 10**( (1-dt)*LOG10(spec_ssp(:,klo)) + &
             dt*LOG10(spec_ssp(:,khi)))
        lbol_ssp(j)   = (1-dt)*lbol_ssp(klo)   + dt*lbol_ssp(khi)
        mass_ssp(j)   = (1-dt)*mass_ssp(klo)   + dt*mass_ssp(khi)
     ENDDO
  ENDIF

  !-------------------------------------------------------------!
  !-------add the nebular emission model at the SSP level-------!
  !-------------------------------------------------------------!

  IF (add_neb_emission.EQ.2) THEN
     CALL ADD_NEBULAR(pset,spec_ssp,tspec_ssp)
     spec_ssp = tspec_ssp
  ENDIF

  !-------------------------------------------------------------!
  !--------now smooth by an instrumental LSF if provided--------!
  !-------------------------------------------------------------!

  IF (smooth_lsf.EQ.1) THEN
     DO j=1,ntfull
        CALL SMOOTHSPEC(spec_lambda,spec_ssp(:,j),99.d0,lsfinfo%minlam,&
             lsfinfo%maxlam,lsfinfo%lsf)
     ENDDO
  ENDIF


END SUBROUTINE SSP_GEN

SUBROUTINE PZ_CONVOL(yield,zave,spec_pz,lbol_pz,mass_pz)

  !routine to weight SSP(Z) by the MDF: P(Z)=Z**zpow*EXP(-Z/p).  
  !The yield is the only input. 
  !zpow is set in sps_vars.f90; zpow=1 yields a closed-box
  !requires that all the SSPs are set up in the common block
  !variables spec_ssp_zz, mass_ssp_zz, and lbol_ssp_zz
  !The average metallicity is returned as zave

  USE sps_vars; USE sps_utils, ONLY : linterp
  IMPLICIT NONE
  
  INTEGER  :: i,t,z
  REAL(SP) :: norm
  REAL(SP), INTENT(out), DIMENSION(nspec,ntfull) :: spec_pz
  REAL(SP), INTENT(out), DIMENSION(ntfull) :: mass_pz, lbol_pz
  REAL(SP), INTENT(out)    :: zave
  REAL(SP), DIMENSION(nz)  ::  pzz1
  REAL(SP), DIMENSION(100) :: pzz2,zz2,zzspec
  REAL(SP), INTENT(in) :: yield

  !-----------------------------------------------------------!

  spec_pz = 0.0  
  lbol_pz = 0.0
  mass_pz = 0.0
  norm    = 0.0
  zave    = 0.0

  !if using the Padova+BaSeL model, just use the native Z grid
  IF (nz.EQ.22) THEN

     !define P(Z)
     pzz1 = zlegend**zpow2 * EXP(-zlegend/yield)
     
     !integrate over P(Z)
     DO z=1,nz-1
        spec_pz = spec_pz + (LOG(zlegend(z+1))-LOG(zlegend(z))) * &
             (pzz1(z+1)*spec_ssp_zz(:,:,z+1) + pzz1(z)*spec_ssp_zz(:,:,z))/2.
        lbol_pz = lbol_pz + (LOG(zlegend(z+1))-LOG(zlegend(z))) * &
             (pzz1(z+1)*lbol_ssp_zz(:,z+1) + pzz1(z)*lbol_ssp_zz(:,z))/2.
        mass_pz = mass_pz + (LOG(zlegend(z+1))-LOG(zlegend(z))) * &
             (pzz1(z+1)*mass_ssp_zz(:,z+1) + pzz1(z)*mass_ssp_zz(:,z))/2.
        norm    = norm + (LOG(zlegend(z+1))-LOG(zlegend(z))) * &
          (pzz1(z+1)+pzz1(z))/2.
        zave    = zave + (LOG(zlegend(z+1))-LOG(zlegend(z))) * &
          (pzz1(z+1)*zlegend(z+1)+pzz1(z)*zlegend(z))/2.
     ENDDO
     
  ELSE

     !set up Z grid
     DO i=1,100
        zz2(i) = 10**(REAL(i)/100.*(-1+4.0)-4)
     ENDDO

     !define P(Z)
     pzz2 = zz2**zpow2 * EXP(-zz2/yield)
     !pzz2 = zz2/ (1/zz2 + 1E4*zz2**zpow)

     DO t=nt,nt
        DO i=1,nspec
           !interpolate
           DO z=1,100
              zzspec(z) = 10**linterp(log10(zlegend),&
                   log10(spec_ssp_zz(i,t,:)),log10(zz2(z)))
           ENDDO
           !integrate
           DO z=1,100-1
              spec_pz(i,t) = spec_pz(i,t) + (LOG(zz2(z+1))-LOG(zz2(z))) * &
                   (pzz2(z+1)*zzspec(z+1) + pzz2(z)*zzspec(z))/2.
           ENDDO
        ENDDO
     ENDDO

     DO z=1,100-1
        norm = norm + (LOG(zz2(z+1))-LOG(zz2(z))) * &
             (pzz2(z+1)+pzz2(z))/2.
        zave = zave + (LOG(zz2(z+1))-LOG(zz2(z))) * &
             (pzz2(z+1)*zz2(z+1)+pzz2(z)*zz2(z))/2.
     ENDDO

  ENDIF

 
  spec_pz = spec_pz / norm
  lbol_pz = lbol_pz / norm
  mass_pz = mass_pz / norm
  zave    = zave    / norm

END SUBROUTINE PZ_CONVOL

FUNCTION GET_TUNIV(z)

  !compute age of Universe in Gyr at redshift z
  !assumes flat universe w/ only matter and lambda
  !assumes om0,ol0,H0 set in sps_vars.f90
  
  USE sps_vars
  IMPLICIT NONE
  INTEGER :: i
  INTEGER, PARAMETER :: ii=10000
  REAL(SP), INTENT(in) :: z
  REAL(SP) :: get_tuniv, thub
  REAL(SP), DIMENSION(ii) :: lnstig, hub

  !---------------------------------------------------------------!
  !---------------------------------------------------------------!

  get_tuniv = 0.0

  !Hubble time in Gyr
  thub = 0.978E3 / H0

  DO i=1,ii
     lnstig(i) = REAL(i)/ii*(LOG(1E4)-LOG(1+z))+LOG(1+z)
  ENDDO
  
  hub = SQRT( om0*EXP(lnstig)**3 + ol0 )

  DO i=1,ii-1
     get_tuniv = get_tuniv + 0.5*(1/hub(i)+1/hub(i+1))
  ENDDO
  get_tuniv = get_tuniv * thub * (lnstig(2)-lnstig(1))


END FUNCTION GET_TUNIV

PROGRAM LESSSIMPLE

  !set up modules
  USE sps_vars; USE sps_utils
  
  IMPLICIT NONE

  !NB: the various structure types are defined in sps_vars.f90
  !    variables not explicitly defined here are defined in sps_vars.f90
  INTEGER :: i
  !define variable for SSP spectrum
  REAL(SP), DIMENSION(ntfull,nspec)  :: spec_pz
  !define variables for Mass and Lbol info
  REAL(SP), DIMENSION(ntfull)    :: mass_pz,lbol_pz
  CHARACTER(100) :: file2=''
  !structure containing all necessary parameters
  TYPE(PARAMS) :: pset
  !define structure for CSP spectrum
  TYPE(COMPSPOUT), DIMENSION(ntfull) :: ocompsp
  REAL(SP) :: zave

  !---------------------------------------------------------------!
  !---------------------------------------------------------------!
  
  ! Now we're going to show you how to use full  
  ! metallicity-dependent info                   
  
  imf_type = 0    ! Salpeter IMF
  pset%sfh = 0    ! compute SSP

  !here we have to read in all the librarries
  CALL SPS_SETUP(-1)

  !compute all SSPs (i.e. at all Zs)
  !nz and the various *ssp_zz arrays are stored 
  !in the common block set up in sps_vars.f90
  DO i=1,nz
     pset%zmet = i
     CALL SSP_GEN(pset,mass_ssp_zz(:,i),&
          lbol_ssp_zz(:,i),spec_ssp_zz(:,:,i))
  ENDDO

  !define the yield for a closed box distribution
  pset%pmetals = 0.02
  !compute SSP convolved with a closed box  
  CALL PZ_CONVOL(pset,zave,spec_pz,lbol_pz,mass_pz)
  file2    = 'SSP_pz.out'
  !now compute magnitudes for this SSP
  CALL COMPSP(1,1,file2,mass_pz,lbol_pz,spec_pz,pset,ocompsp)

  !run compsp for a tabulated sfh with a metallicity history
  !NB: one must have setup all the SSPs, as was done in the DO-loop above
  pset%sfh = 2
  file2    = 'CSP_tabsfh.out'
  CALL COMPSP(1,nz,file2,mass_ssp_zz,lbol_ssp_zz,&
          spec_ssp_zz,pset,ocompsp)


END PROGRAM LESSSIMPLE

FUNCTION TSUM(xin,yin)

  !simple trapezoidal integration of tabulated function (xin,yin)
  !NB: notice the abs(dx) in the equation below.  The x-axis can
  !therefore be in reverse order

  USE sps_vars
  IMPLICIT NONE

  REAL(SP), DIMENSION(:), INTENT(in) :: xin,yin
  REAL(SP) :: tsum
  INTEGER  :: nn

  !---------------------------------------------------------------!
  !---------------------------------------------------------------!

  nn = SIZE(xin)

  tsum = SUM( ABS((xin(2:nn)-xin(1:nn-1))) * &
       (yin(2:nn)+yin(1:nn-1))/2. )


END FUNCTION TSUM
